(set-logic QF-UFLIA)


(declare-sort Loc)
(declare-sort Set)

(declare-fun singleton (Int) Set)
(declare-fun union (Set Set) Set)
(declare-fun inter (Set Set) Set)
(declare-fun emptyset () Set)
(declare-fun in (Int Set) Bool)
(declare-fun subset (Set Set) Bool)
(declare-fun lt (Set Set) Bool)
(declare-fun eq (Set Set) Bool)
(declare-fun disjoint (Set Set) Bool)


(declare-fun nil () Loc)
(declare-fun key (Loc) Int)
(declare-fun priority (Loc) Int)
(declare-fun l (Loc) Loc)
(declare-fun r (Loc) Loc)
(declare-fun l' (Loc) Loc)
(declare-fun r' (Loc) Loc)
(declare-fun l1 (Loc) Loc)
(declare-fun r1 (Loc) Loc)
(declare-fun treap (Loc) Bool)
(declare-fun treap' (Loc) Bool)
(declare-fun treap1 (Loc) Bool)


(declare-fun keys (Loc) Set)
(declare-fun keys' (Loc) Set)
(declare-fun keys1 (Loc) Set)
(declare-fun priorities (Loc) Set)
(declare-fun priorities' (Loc) Set)
(declare-fun priorities1 (Loc) Set)


(assert (treap nil))
(assert (treap' nil))
(assert (treap1 nil))
(assert (eq (keys nil) emptyset))
(assert (eq (keys' nil) emptyset))
(assert (eq (keys1 nil) emptyset))
(assert (eq (priorities nil) emptyset))
(assert (eq (priorities' nil) emptyset))
(assert (eq (priorities1 nil) emptyset))


; Vars
(declare-fun x () Loc)
(declare-fun k () Int)
(declare-fun p () Int)
(declare-fun y () Loc)
(declare-fun w1 () Int)
(declare-fun w2 () Int)


(assert (iff (in k (union (keys' (l' y)) (singleton (key y)))) (or (in k (keys' (l' y))) (in k (singleton (key y))))))
(assert (iff (in p (union (keys' (l' y)) (singleton (key y)))) (or (in p (keys' (l' y))) (in p (singleton (key y))))))
(assert (iff (in w1 (union (keys' (l' y)) (singleton (key y)))) (or (in w1 (keys' (l' y))) (in w1 (singleton (key y))))))
(assert (iff (in w2 (union (keys' (l' y)) (singleton (key y)))) (or (in w2 (keys' (l' y))) (in w2 (singleton (key y))))))
(assert (iff (in (key y) (union (keys' (l' y)) (singleton (key y)))) (or (in (key y) (keys' (l' y))) (in (key y) (singleton (key y))))))
(assert (iff (in (priority y) (union (keys' (l' y)) (singleton (key y)))) (or (in (priority y) (keys' (l' y))) (in (priority y) (singleton (key y))))))
(assert (iff (in k (union (keys' (r' y)) (singleton (key y)))) (or (in k (keys' (r' y))) (in k (singleton (key y))))))
(assert (iff (in p (union (keys' (r' y)) (singleton (key y)))) (or (in p (keys' (r' y))) (in p (singleton (key y))))))
(assert (iff (in w1 (union (keys' (r' y)) (singleton (key y)))) (or (in w1 (keys' (r' y))) (in w1 (singleton (key y))))))
(assert (iff (in w2 (union (keys' (r' y)) (singleton (key y)))) (or (in w2 (keys' (r' y))) (in w2 (singleton (key y))))))
(assert (iff (in (key y) (union (keys' (r' y)) (singleton (key y)))) (or (in (key y) (keys' (r' y))) (in (key y) (singleton (key y))))))
(assert (iff (in (priority y) (union (keys' (r' y)) (singleton (key y)))) (or (in (priority y) (keys' (r' y))) (in (priority y) (singleton (key y))))))
(assert (iff (in k (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (or (in k (union (keys' (l' y)) (keys' (r' y)))) (in k (singleton (key y))))))
(assert (iff (in p (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (or (in p (union (keys' (l' y)) (keys' (r' y)))) (in p (singleton (key y))))))
(assert (iff (in w1 (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (or (in w1 (union (keys' (l' y)) (keys' (r' y)))) (in w1 (singleton (key y))))))
(assert (iff (in w2 (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (or (in w2 (union (keys' (l' y)) (keys' (r' y)))) (in w2 (singleton (key y))))))
(assert (iff (in (key y) (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (or (in (key y) (union (keys' (l' y)) (keys' (r' y)))) (in (key y) (singleton (key y))))))
(assert (iff (in (priority y) (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (or (in (priority y) (union (keys' (l' y)) (keys' (r' y)))) (in (priority y) (singleton (key y))))))
(assert (iff (in k (union (keys' (l' y)) (keys' (r' y)))) (or (in k (keys' (l' y))) (in k (keys' (r' y))))))
(assert (iff (in p (union (keys' (l' y)) (keys' (r' y)))) (or (in p (keys' (l' y))) (in p (keys' (r' y))))))
(assert (iff (in w1 (union (keys' (l' y)) (keys' (r' y)))) (or (in w1 (keys' (l' y))) (in w1 (keys' (r' y))))))
(assert (iff (in w2 (union (keys' (l' y)) (keys' (r' y)))) (or (in w2 (keys' (l' y))) (in w2 (keys' (r' y))))))
(assert (iff (in (key y) (union (keys' (l' y)) (keys' (r' y)))) (or (in (key y) (keys' (l' y))) (in (key y) (keys' (r' y))))))
(assert (iff (in (priority y) (union (keys' (l' y)) (keys' (r' y)))) (or (in (priority y) (keys' (l' y))) (in (priority y) (keys' (r' y))))))
(assert (iff (in k (union (priorities' (l' y)) (singleton (priority y)))) (or (in k (priorities' (l' y))) (in k (singleton (priority y))))))
(assert (iff (in p (union (priorities' (l' y)) (singleton (priority y)))) (or (in p (priorities' (l' y))) (in p (singleton (priority y))))))
(assert (iff (in w1 (union (priorities' (l' y)) (singleton (priority y)))) (or (in w1 (priorities' (l' y))) (in w1 (singleton (priority y))))))
(assert (iff (in w2 (union (priorities' (l' y)) (singleton (priority y)))) (or (in w2 (priorities' (l' y))) (in w2 (singleton (priority y))))))
(assert (iff (in (key y) (union (priorities' (l' y)) (singleton (priority y)))) (or (in (key y) (priorities' (l' y))) (in (key y) (singleton (priority y))))))
(assert (iff (in (priority y) (union (priorities' (l' y)) (singleton (priority y)))) (or (in (priority y) (priorities' (l' y))) (in (priority y) (singleton (priority y))))))
(assert (iff (in k (union (priorities' (r' y)) (singleton (priority y)))) (or (in k (priorities' (r' y))) (in k (singleton (priority y))))))
(assert (iff (in p (union (priorities' (r' y)) (singleton (priority y)))) (or (in p (priorities' (r' y))) (in p (singleton (priority y))))))
(assert (iff (in w1 (union (priorities' (r' y)) (singleton (priority y)))) (or (in w1 (priorities' (r' y))) (in w1 (singleton (priority y))))))
(assert (iff (in w2 (union (priorities' (r' y)) (singleton (priority y)))) (or (in w2 (priorities' (r' y))) (in w2 (singleton (priority y))))))
(assert (iff (in (key y) (union (priorities' (r' y)) (singleton (priority y)))) (or (in (key y) (priorities' (r' y))) (in (key y) (singleton (priority y))))))
(assert (iff (in (priority y) (union (priorities' (r' y)) (singleton (priority y)))) (or (in (priority y) (priorities' (r' y))) (in (priority y) (singleton (priority y))))))
(assert (iff (in k (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (or (in k (union (priorities' (l' y)) (priorities' (r' y)))) (in k (singleton (priority y))))))
(assert (iff (in p (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (or (in p (union (priorities' (l' y)) (priorities' (r' y)))) (in p (singleton (priority y))))))
(assert (iff (in w1 (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (or (in w1 (union (priorities' (l' y)) (priorities' (r' y)))) (in w1 (singleton (priority y))))))
(assert (iff (in w2 (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (or (in w2 (union (priorities' (l' y)) (priorities' (r' y)))) (in w2 (singleton (priority y))))))
(assert (iff (in (key y) (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (or (in (key y) (union (priorities' (l' y)) (priorities' (r' y)))) (in (key y) (singleton (priority y))))))
(assert (iff (in (priority y) (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (or (in (priority y) (union (priorities' (l' y)) (priorities' (r' y)))) (in (priority y) (singleton (priority y))))))
(assert (iff (in k (union (priorities' (l' y)) (priorities' (r' y)))) (or (in k (priorities' (l' y))) (in k (priorities' (r' y))))))
(assert (iff (in p (union (priorities' (l' y)) (priorities' (r' y)))) (or (in p (priorities' (l' y))) (in p (priorities' (r' y))))))
(assert (iff (in w1 (union (priorities' (l' y)) (priorities' (r' y)))) (or (in w1 (priorities' (l' y))) (in w1 (priorities' (r' y))))))
(assert (iff (in w2 (union (priorities' (l' y)) (priorities' (r' y)))) (or (in w2 (priorities' (l' y))) (in w2 (priorities' (r' y))))))
(assert (iff (in (key y) (union (priorities' (l' y)) (priorities' (r' y)))) (or (in (key y) (priorities' (l' y))) (in (key y) (priorities' (r' y))))))
(assert (iff (in (priority y) (union (priorities' (l' y)) (priorities' (r' y)))) (or (in (priority y) (priorities' (l' y))) (in (priority y) (priorities' (r' y))))))
(assert (iff (in k (union (singleton k) (keys x))) (or (in k (singleton k)) (in k (keys x)))))
(assert (iff (in p (union (singleton k) (keys x))) (or (in p (singleton k)) (in p (keys x)))))
(assert (iff (in w1 (union (singleton k) (keys x))) (or (in w1 (singleton k)) (in w1 (keys x)))))
(assert (iff (in w2 (union (singleton k) (keys x))) (or (in w2 (singleton k)) (in w2 (keys x)))))
(assert (iff (in (key y) (union (singleton k) (keys x))) (or (in (key y) (singleton k)) (in (key y) (keys x)))))
(assert (iff (in (priority y) (union (singleton k) (keys x))) (or (in (priority y) (singleton k)) (in (priority y) (keys x)))))
(assert (iff (in k (union (singleton p) (priorities x))) (or (in k (singleton p)) (in k (priorities x)))))
(assert (iff (in p (union (singleton p) (priorities x))) (or (in p (singleton p)) (in p (priorities x)))))
(assert (iff (in w1 (union (singleton p) (priorities x))) (or (in w1 (singleton p)) (in w1 (priorities x)))))
(assert (iff (in w2 (union (singleton p) (priorities x))) (or (in w2 (singleton p)) (in w2 (priorities x)))))
(assert (iff (in (key y) (union (singleton p) (priorities x))) (or (in (key y) (singleton p)) (in (key y) (priorities x)))))
(assert (iff (in (priority y) (union (singleton p) (priorities x))) (or (in (priority y) (singleton p)) (in (priority y) (priorities x)))))



(assert (iff (in k (singleton (key y))) (= k (key y))))
(assert (iff (in p (singleton (key y))) (= p (key y))))
(assert (iff (in w1 (singleton (key y))) (= w1 (key y))))
(assert (iff (in w2 (singleton (key y))) (= w2 (key y))))
(assert (iff (in (key y) (singleton (key y))) (= (key y) (key y))))
(assert (iff (in (priority y) (singleton (key y))) (= (priority y) (key y))))
(assert (iff (in k (singleton (priority y))) (= k (priority y))))
(assert (iff (in p (singleton (priority y))) (= p (priority y))))
(assert (iff (in w1 (singleton (priority y))) (= w1 (priority y))))
(assert (iff (in w2 (singleton (priority y))) (= w2 (priority y))))
(assert (iff (in (key y) (singleton (priority y))) (= (key y) (priority y))))
(assert (iff (in (priority y) (singleton (priority y))) (= (priority y) (priority y))))
(assert (iff (in k (singleton k)) (= k k)))
(assert (iff (in p (singleton k)) (= p k)))
(assert (iff (in w1 (singleton k)) (= w1 k)))
(assert (iff (in w2 (singleton k)) (= w2 k)))
(assert (iff (in (key y) (singleton k)) (= (key y) k)))
(assert (iff (in (priority y) (singleton k)) (= (priority y) k)))
(assert (iff (in k (singleton p)) (= k p)))
(assert (iff (in p (singleton p)) (= p p)))
(assert (iff (in w1 (singleton p)) (= w1 p)))
(assert (iff (in w2 (singleton p)) (= w2 p)))
(assert (iff (in (key y) (singleton p)) (= (key y) p)))
(assert (iff (in (priority y) (singleton p)) (= (priority y) p)))


(assert (=> (eq (keys nil) emptyset) (iff (in k (keys nil)) (in k emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in p (keys nil)) (in p emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in w1 (keys nil)) (in w1 emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in w2 (keys nil)) (in w2 emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in (key y) (keys nil)) (in (key y) emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in (priority y) (keys nil)) (in (priority y) emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in k (keys' nil)) (in k emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in p (keys' nil)) (in p emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in w1 (keys' nil)) (in w1 emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in w2 (keys' nil)) (in w2 emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in (key y) (keys' nil)) (in (key y) emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in (priority y) (keys' nil)) (in (priority y) emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in k (keys1 nil)) (in k emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in p (keys1 nil)) (in p emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in w1 (keys1 nil)) (in w1 emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in w2 (keys1 nil)) (in w2 emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in (key y) (keys1 nil)) (in (key y) emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in (priority y) (keys1 nil)) (in (priority y) emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in k (priorities nil)) (in k emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in p (priorities nil)) (in p emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in w1 (priorities nil)) (in w1 emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in w2 (priorities nil)) (in w2 emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in (key y) (priorities nil)) (in (key y) emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in (priority y) (priorities nil)) (in (priority y) emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in k (priorities' nil)) (in k emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in p (priorities' nil)) (in p emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in w1 (priorities' nil)) (in w1 emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in w2 (priorities' nil)) (in w2 emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in (key y) (priorities' nil)) (in (key y) emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in (priority y) (priorities' nil)) (in (priority y) emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in k (priorities1 nil)) (in k emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in p (priorities1 nil)) (in p emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in w1 (priorities1 nil)) (in w1 emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in w2 (priorities1 nil)) (in w2 emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in (key y) (priorities1 nil)) (in (key y) emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in (priority y) (priorities1 nil)) (in (priority y) emptyset))))
(assert (=> (eq (keys' y) emptyset) (iff (in k (keys' y)) (in k emptyset))))
(assert (=> (eq (keys' y) emptyset) (iff (in p (keys' y)) (in p emptyset))))
(assert (=> (eq (keys' y) emptyset) (iff (in w1 (keys' y)) (in w1 emptyset))))
(assert (=> (eq (keys' y) emptyset) (iff (in w2 (keys' y)) (in w2 emptyset))))
(assert (=> (eq (keys' y) emptyset) (iff (in (key y) (keys' y)) (in (key y) emptyset))))
(assert (=> (eq (keys' y) emptyset) (iff (in (priority y) (keys' y)) (in (priority y) emptyset))))
(assert (=> (eq (keys' y) (singleton (key y))) (iff (in k (keys' y)) (in k (singleton (key y))))))
(assert (=> (eq (keys' y) (singleton (key y))) (iff (in p (keys' y)) (in p (singleton (key y))))))
(assert (=> (eq (keys' y) (singleton (key y))) (iff (in w1 (keys' y)) (in w1 (singleton (key y))))))
(assert (=> (eq (keys' y) (singleton (key y))) (iff (in w2 (keys' y)) (in w2 (singleton (key y))))))
(assert (=> (eq (keys' y) (singleton (key y))) (iff (in (key y) (keys' y)) (in (key y) (singleton (key y))))))
(assert (=> (eq (keys' y) (singleton (key y))) (iff (in (priority y) (keys' y)) (in (priority y) (singleton (key y))))))
(assert (=> (eq (keys' y) (union (keys' (l' y)) (singleton (key y)))) (iff (in k (keys' y)) (in k (union (keys' (l' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (l' y)) (singleton (key y)))) (iff (in p (keys' y)) (in p (union (keys' (l' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (l' y)) (singleton (key y)))) (iff (in w1 (keys' y)) (in w1 (union (keys' (l' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (l' y)) (singleton (key y)))) (iff (in w2 (keys' y)) (in w2 (union (keys' (l' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (l' y)) (singleton (key y)))) (iff (in (key y) (keys' y)) (in (key y) (union (keys' (l' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (l' y)) (singleton (key y)))) (iff (in (priority y) (keys' y)) (in (priority y) (union (keys' (l' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (r' y)) (singleton (key y)))) (iff (in k (keys' y)) (in k (union (keys' (r' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (r' y)) (singleton (key y)))) (iff (in p (keys' y)) (in p (union (keys' (r' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (r' y)) (singleton (key y)))) (iff (in w1 (keys' y)) (in w1 (union (keys' (r' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (r' y)) (singleton (key y)))) (iff (in w2 (keys' y)) (in w2 (union (keys' (r' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (r' y)) (singleton (key y)))) (iff (in (key y) (keys' y)) (in (key y) (union (keys' (r' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (keys' (r' y)) (singleton (key y)))) (iff (in (priority y) (keys' y)) (in (priority y) (union (keys' (r' y)) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (iff (in k (keys' y)) (in k (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (iff (in p (keys' y)) (in p (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (iff (in w1 (keys' y)) (in w1 (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (iff (in w2 (keys' y)) (in w2 (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (iff (in (key y) (keys' y)) (in (key y) (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))))))
(assert (=> (eq (keys' y) (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))) (iff (in (priority y) (keys' y)) (in (priority y) (union (union (keys' (l' y)) (keys' (r' y))) (singleton (key y)))))))
(assert (=> (eq (priorities' y) emptyset) (iff (in k (priorities' y)) (in k emptyset))))
(assert (=> (eq (priorities' y) emptyset) (iff (in p (priorities' y)) (in p emptyset))))
(assert (=> (eq (priorities' y) emptyset) (iff (in w1 (priorities' y)) (in w1 emptyset))))
(assert (=> (eq (priorities' y) emptyset) (iff (in w2 (priorities' y)) (in w2 emptyset))))
(assert (=> (eq (priorities' y) emptyset) (iff (in (key y) (priorities' y)) (in (key y) emptyset))))
(assert (=> (eq (priorities' y) emptyset) (iff (in (priority y) (priorities' y)) (in (priority y) emptyset))))
(assert (=> (eq (priorities' y) (singleton (priority y))) (iff (in k (priorities' y)) (in k (singleton (priority y))))))
(assert (=> (eq (priorities' y) (singleton (priority y))) (iff (in p (priorities' y)) (in p (singleton (priority y))))))
(assert (=> (eq (priorities' y) (singleton (priority y))) (iff (in w1 (priorities' y)) (in w1 (singleton (priority y))))))
(assert (=> (eq (priorities' y) (singleton (priority y))) (iff (in w2 (priorities' y)) (in w2 (singleton (priority y))))))
(assert (=> (eq (priorities' y) (singleton (priority y))) (iff (in (key y) (priorities' y)) (in (key y) (singleton (priority y))))))
(assert (=> (eq (priorities' y) (singleton (priority y))) (iff (in (priority y) (priorities' y)) (in (priority y) (singleton (priority y))))))
(assert (=> (eq (priorities' y) (union (priorities' (l' y)) (singleton (priority y)))) (iff (in k (priorities' y)) (in k (union (priorities' (l' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (l' y)) (singleton (priority y)))) (iff (in p (priorities' y)) (in p (union (priorities' (l' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (l' y)) (singleton (priority y)))) (iff (in w1 (priorities' y)) (in w1 (union (priorities' (l' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (l' y)) (singleton (priority y)))) (iff (in w2 (priorities' y)) (in w2 (union (priorities' (l' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (l' y)) (singleton (priority y)))) (iff (in (key y) (priorities' y)) (in (key y) (union (priorities' (l' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (l' y)) (singleton (priority y)))) (iff (in (priority y) (priorities' y)) (in (priority y) (union (priorities' (l' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (r' y)) (singleton (priority y)))) (iff (in k (priorities' y)) (in k (union (priorities' (r' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (r' y)) (singleton (priority y)))) (iff (in p (priorities' y)) (in p (union (priorities' (r' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (r' y)) (singleton (priority y)))) (iff (in w1 (priorities' y)) (in w1 (union (priorities' (r' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (r' y)) (singleton (priority y)))) (iff (in w2 (priorities' y)) (in w2 (union (priorities' (r' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (r' y)) (singleton (priority y)))) (iff (in (key y) (priorities' y)) (in (key y) (union (priorities' (r' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (priorities' (r' y)) (singleton (priority y)))) (iff (in (priority y) (priorities' y)) (in (priority y) (union (priorities' (r' y)) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (iff (in k (priorities' y)) (in k (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (iff (in p (priorities' y)) (in p (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (iff (in w1 (priorities' y)) (in w1 (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (iff (in w2 (priorities' y)) (in w2 (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (iff (in (key y) (priorities' y)) (in (key y) (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))))))
(assert (=> (eq (priorities' y) (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))) (iff (in (priority y) (priorities' y)) (in (priority y) (union (union (priorities' (l' y)) (priorities' (r' y))) (singleton (priority y)))))))
(assert (=> (eq (keys' y) (union (singleton k) (keys x))) (iff (in k (keys' y)) (in k (union (singleton k) (keys x))))))
(assert (=> (eq (keys' y) (union (singleton k) (keys x))) (iff (in p (keys' y)) (in p (union (singleton k) (keys x))))))
(assert (=> (eq (keys' y) (union (singleton k) (keys x))) (iff (in w1 (keys' y)) (in w1 (union (singleton k) (keys x))))))
(assert (=> (eq (keys' y) (union (singleton k) (keys x))) (iff (in w2 (keys' y)) (in w2 (union (singleton k) (keys x))))))
(assert (=> (eq (keys' y) (union (singleton k) (keys x))) (iff (in (key y) (keys' y)) (in (key y) (union (singleton k) (keys x))))))
(assert (=> (eq (keys' y) (union (singleton k) (keys x))) (iff (in (priority y) (keys' y)) (in (priority y) (union (singleton k) (keys x))))))
(assert (=> (eq (priorities' y) (union (singleton p) (priorities x))) (iff (in k (priorities' y)) (in k (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' y) (union (singleton p) (priorities x))) (iff (in p (priorities' y)) (in p (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' y) (union (singleton p) (priorities x))) (iff (in w1 (priorities' y)) (in w1 (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' y) (union (singleton p) (priorities x))) (iff (in w2 (priorities' y)) (in w2 (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' y) (union (singleton p) (priorities x))) (iff (in (key y) (priorities' y)) (in (key y) (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' y) (union (singleton p) (priorities x))) (iff (in (priority y) (priorities' y)) (in (priority y) (union (singleton p) (priorities x))))))

(assert (=> (disjoint (priorities' (l' y)) (priorities' (r' y))) (not (and (in k (priorities' (l' y))) (in k (priorities' (r' y)))))))
(assert (=> (disjoint (priorities' (l' y)) (priorities' (r' y))) (not (and (in p (priorities' (l' y))) (in p (priorities' (r' y)))))))
(assert (=> (disjoint (priorities' (l' y)) (priorities' (r' y))) (not (and (in w1 (priorities' (l' y))) (in w1 (priorities' (r' y)))))))
(assert (=> (disjoint (priorities' (l' y)) (priorities' (r' y))) (not (and (in w2 (priorities' (l' y))) (in w2 (priorities' (r' y)))))))
(assert (=> (disjoint (priorities' (l' y)) (priorities' (r' y))) (not (and (in (key y) (priorities' (l' y))) (in (key y) (priorities' (r' y)))))))
(assert (=> (disjoint (priorities' (l' y)) (priorities' (r' y))) (not (and (in (priority y) (priorities' (l' y))) (in (priority y) (priorities' (r' y)))))))

(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in k (singleton (priority y))) (in k (priorities' (l' y)))) (< k k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in k (singleton (priority y))) (in p (priorities' (l' y)))) (< k p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in k (singleton (priority y))) (in w1 (priorities' (l' y)))) (< k w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in k (singleton (priority y))) (in w2 (priorities' (l' y)))) (< k w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in k (singleton (priority y))) (in (key y) (priorities' (l' y)))) (< k (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in k (singleton (priority y))) (in (priority y) (priorities' (l' y)))) (< k (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in p (singleton (priority y))) (in k (priorities' (l' y)))) (< p k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in p (singleton (priority y))) (in p (priorities' (l' y)))) (< p p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in p (singleton (priority y))) (in w1 (priorities' (l' y)))) (< p w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in p (singleton (priority y))) (in w2 (priorities' (l' y)))) (< p w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in p (singleton (priority y))) (in (key y) (priorities' (l' y)))) (< p (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in p (singleton (priority y))) (in (priority y) (priorities' (l' y)))) (< p (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w1 (singleton (priority y))) (in k (priorities' (l' y)))) (< w1 k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w1 (singleton (priority y))) (in p (priorities' (l' y)))) (< w1 p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w1 (singleton (priority y))) (in w1 (priorities' (l' y)))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w1 (singleton (priority y))) (in w2 (priorities' (l' y)))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w1 (singleton (priority y))) (in (key y) (priorities' (l' y)))) (< w1 (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w1 (singleton (priority y))) (in (priority y) (priorities' (l' y)))) (< w1 (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w2 (singleton (priority y))) (in k (priorities' (l' y)))) (< w2 k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w2 (singleton (priority y))) (in p (priorities' (l' y)))) (< w2 p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w2 (singleton (priority y))) (in w1 (priorities' (l' y)))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w2 (singleton (priority y))) (in w2 (priorities' (l' y)))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w2 (singleton (priority y))) (in (key y) (priorities' (l' y)))) (< w2 (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in w2 (singleton (priority y))) (in (priority y) (priorities' (l' y)))) (< w2 (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (key y) (singleton (priority y))) (in k (priorities' (l' y)))) (< (key y) k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (key y) (singleton (priority y))) (in p (priorities' (l' y)))) (< (key y) p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (key y) (singleton (priority y))) (in w1 (priorities' (l' y)))) (< (key y) w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (key y) (singleton (priority y))) (in w2 (priorities' (l' y)))) (< (key y) w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (key y) (singleton (priority y))) (in (key y) (priorities' (l' y)))) (< (key y) (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (key y) (singleton (priority y))) (in (priority y) (priorities' (l' y)))) (< (key y) (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (priority y) (singleton (priority y))) (in k (priorities' (l' y)))) (< (priority y) k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (priority y) (singleton (priority y))) (in p (priorities' (l' y)))) (< (priority y) p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (priority y) (singleton (priority y))) (in w1 (priorities' (l' y)))) (< (priority y) w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (priority y) (singleton (priority y))) (in w2 (priorities' (l' y)))) (< (priority y) w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (priority y) (singleton (priority y))) (in (key y) (priorities' (l' y)))) (< (priority y) (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (l' y))) (=> (and (in (priority y) (singleton (priority y))) (in (priority y) (priorities' (l' y)))) (< (priority y) (priority y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in k (keys' (l' y))) (in k (singleton (key y)))) (< k k ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in k (keys' (l' y))) (in p (singleton (key y)))) (< k p ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in k (keys' (l' y))) (in w1 (singleton (key y)))) (< k w1 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in k (keys' (l' y))) (in w2 (singleton (key y)))) (< k w2 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in k (keys' (l' y))) (in (key y) (singleton (key y)))) (< k (key y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in k (keys' (l' y))) (in (priority y) (singleton (key y)))) (< k (priority y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in p (keys' (l' y))) (in k (singleton (key y)))) (< p k ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in p (keys' (l' y))) (in p (singleton (key y)))) (< p p ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in p (keys' (l' y))) (in w1 (singleton (key y)))) (< p w1 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in p (keys' (l' y))) (in w2 (singleton (key y)))) (< p w2 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in p (keys' (l' y))) (in (key y) (singleton (key y)))) (< p (key y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in p (keys' (l' y))) (in (priority y) (singleton (key y)))) (< p (priority y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w1 (keys' (l' y))) (in k (singleton (key y)))) (< w1 k ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w1 (keys' (l' y))) (in p (singleton (key y)))) (< w1 p ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w1 (keys' (l' y))) (in w1 (singleton (key y)))) (< w1 w1 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w1 (keys' (l' y))) (in w2 (singleton (key y)))) (< w1 w2 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w1 (keys' (l' y))) (in (key y) (singleton (key y)))) (< w1 (key y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w1 (keys' (l' y))) (in (priority y) (singleton (key y)))) (< w1 (priority y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w2 (keys' (l' y))) (in k (singleton (key y)))) (< w2 k ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w2 (keys' (l' y))) (in p (singleton (key y)))) (< w2 p ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w2 (keys' (l' y))) (in w1 (singleton (key y)))) (< w2 w1 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w2 (keys' (l' y))) (in w2 (singleton (key y)))) (< w2 w2 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w2 (keys' (l' y))) (in (key y) (singleton (key y)))) (< w2 (key y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in w2 (keys' (l' y))) (in (priority y) (singleton (key y)))) (< w2 (priority y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (key y) (keys' (l' y))) (in k (singleton (key y)))) (< (key y) k ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (key y) (keys' (l' y))) (in p (singleton (key y)))) (< (key y) p ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (key y) (keys' (l' y))) (in w1 (singleton (key y)))) (< (key y) w1 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (key y) (keys' (l' y))) (in w2 (singleton (key y)))) (< (key y) w2 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (key y) (keys' (l' y))) (in (key y) (singleton (key y)))) (< (key y) (key y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (key y) (keys' (l' y))) (in (priority y) (singleton (key y)))) (< (key y) (priority y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (priority y) (keys' (l' y))) (in k (singleton (key y)))) (< (priority y) k ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (priority y) (keys' (l' y))) (in p (singleton (key y)))) (< (priority y) p ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (priority y) (keys' (l' y))) (in w1 (singleton (key y)))) (< (priority y) w1 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (priority y) (keys' (l' y))) (in w2 (singleton (key y)))) (< (priority y) w2 ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (priority y) (keys' (l' y))) (in (key y) (singleton (key y)))) (< (priority y) (key y) ))))
(assert (=> (lt (keys' (l' y)) (singleton (key y))) (=> (and (in (priority y) (keys' (l' y))) (in (priority y) (singleton (key y)))) (< (priority y) (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in k (singleton (priority y))) (in k (priorities' (r' y)))) (< k k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in k (singleton (priority y))) (in p (priorities' (r' y)))) (< k p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in k (singleton (priority y))) (in w1 (priorities' (r' y)))) (< k w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in k (singleton (priority y))) (in w2 (priorities' (r' y)))) (< k w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in k (singleton (priority y))) (in (key y) (priorities' (r' y)))) (< k (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in k (singleton (priority y))) (in (priority y) (priorities' (r' y)))) (< k (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in p (singleton (priority y))) (in k (priorities' (r' y)))) (< p k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in p (singleton (priority y))) (in p (priorities' (r' y)))) (< p p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in p (singleton (priority y))) (in w1 (priorities' (r' y)))) (< p w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in p (singleton (priority y))) (in w2 (priorities' (r' y)))) (< p w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in p (singleton (priority y))) (in (key y) (priorities' (r' y)))) (< p (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in p (singleton (priority y))) (in (priority y) (priorities' (r' y)))) (< p (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w1 (singleton (priority y))) (in k (priorities' (r' y)))) (< w1 k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w1 (singleton (priority y))) (in p (priorities' (r' y)))) (< w1 p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w1 (singleton (priority y))) (in w1 (priorities' (r' y)))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w1 (singleton (priority y))) (in w2 (priorities' (r' y)))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w1 (singleton (priority y))) (in (key y) (priorities' (r' y)))) (< w1 (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w1 (singleton (priority y))) (in (priority y) (priorities' (r' y)))) (< w1 (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w2 (singleton (priority y))) (in k (priorities' (r' y)))) (< w2 k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w2 (singleton (priority y))) (in p (priorities' (r' y)))) (< w2 p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w2 (singleton (priority y))) (in w1 (priorities' (r' y)))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w2 (singleton (priority y))) (in w2 (priorities' (r' y)))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w2 (singleton (priority y))) (in (key y) (priorities' (r' y)))) (< w2 (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in w2 (singleton (priority y))) (in (priority y) (priorities' (r' y)))) (< w2 (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (key y) (singleton (priority y))) (in k (priorities' (r' y)))) (< (key y) k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (key y) (singleton (priority y))) (in p (priorities' (r' y)))) (< (key y) p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (key y) (singleton (priority y))) (in w1 (priorities' (r' y)))) (< (key y) w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (key y) (singleton (priority y))) (in w2 (priorities' (r' y)))) (< (key y) w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (key y) (singleton (priority y))) (in (key y) (priorities' (r' y)))) (< (key y) (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (key y) (singleton (priority y))) (in (priority y) (priorities' (r' y)))) (< (key y) (priority y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (priority y) (singleton (priority y))) (in k (priorities' (r' y)))) (< (priority y) k ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (priority y) (singleton (priority y))) (in p (priorities' (r' y)))) (< (priority y) p ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (priority y) (singleton (priority y))) (in w1 (priorities' (r' y)))) (< (priority y) w1 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (priority y) (singleton (priority y))) (in w2 (priorities' (r' y)))) (< (priority y) w2 ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (priority y) (singleton (priority y))) (in (key y) (priorities' (r' y)))) (< (priority y) (key y) ))))
(assert (=> (lt (singleton (priority y)) (priorities' (r' y))) (=> (and (in (priority y) (singleton (priority y))) (in (priority y) (priorities' (r' y)))) (< (priority y) (priority y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in k (singleton (key y))) (in k (keys' (r' y)))) (< k k ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in k (singleton (key y))) (in p (keys' (r' y)))) (< k p ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in k (singleton (key y))) (in w1 (keys' (r' y)))) (< k w1 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in k (singleton (key y))) (in w2 (keys' (r' y)))) (< k w2 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in k (singleton (key y))) (in (key y) (keys' (r' y)))) (< k (key y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in k (singleton (key y))) (in (priority y) (keys' (r' y)))) (< k (priority y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in p (singleton (key y))) (in k (keys' (r' y)))) (< p k ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in p (singleton (key y))) (in p (keys' (r' y)))) (< p p ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in p (singleton (key y))) (in w1 (keys' (r' y)))) (< p w1 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in p (singleton (key y))) (in w2 (keys' (r' y)))) (< p w2 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in p (singleton (key y))) (in (key y) (keys' (r' y)))) (< p (key y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in p (singleton (key y))) (in (priority y) (keys' (r' y)))) (< p (priority y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w1 (singleton (key y))) (in k (keys' (r' y)))) (< w1 k ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w1 (singleton (key y))) (in p (keys' (r' y)))) (< w1 p ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w1 (singleton (key y))) (in w1 (keys' (r' y)))) (< w1 w1 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w1 (singleton (key y))) (in w2 (keys' (r' y)))) (< w1 w2 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w1 (singleton (key y))) (in (key y) (keys' (r' y)))) (< w1 (key y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w1 (singleton (key y))) (in (priority y) (keys' (r' y)))) (< w1 (priority y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w2 (singleton (key y))) (in k (keys' (r' y)))) (< w2 k ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w2 (singleton (key y))) (in p (keys' (r' y)))) (< w2 p ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w2 (singleton (key y))) (in w1 (keys' (r' y)))) (< w2 w1 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w2 (singleton (key y))) (in w2 (keys' (r' y)))) (< w2 w2 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w2 (singleton (key y))) (in (key y) (keys' (r' y)))) (< w2 (key y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in w2 (singleton (key y))) (in (priority y) (keys' (r' y)))) (< w2 (priority y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (key y) (singleton (key y))) (in k (keys' (r' y)))) (< (key y) k ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (key y) (singleton (key y))) (in p (keys' (r' y)))) (< (key y) p ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (key y) (singleton (key y))) (in w1 (keys' (r' y)))) (< (key y) w1 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (key y) (singleton (key y))) (in w2 (keys' (r' y)))) (< (key y) w2 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (key y) (singleton (key y))) (in (key y) (keys' (r' y)))) (< (key y) (key y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (key y) (singleton (key y))) (in (priority y) (keys' (r' y)))) (< (key y) (priority y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (priority y) (singleton (key y))) (in k (keys' (r' y)))) (< (priority y) k ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (priority y) (singleton (key y))) (in p (keys' (r' y)))) (< (priority y) p ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (priority y) (singleton (key y))) (in w1 (keys' (r' y)))) (< (priority y) w1 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (priority y) (singleton (key y))) (in w2 (keys' (r' y)))) (< (priority y) w2 ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (priority y) (singleton (key y))) (in (key y) (keys' (r' y)))) (< (priority y) (key y) ))))
(assert (=> (lt (singleton (key y)) (keys' (r' y))) (=> (and (in (priority y) (singleton (key y))) (in (priority y) (keys' (r' y)))) (< (priority y) (priority y) ))))


(assert (not (in k emptyset)))
(assert (not (in p emptyset)))
(assert (not (in w1 emptyset)))
(assert (not (in w2 emptyset)))
(assert (not (in (key y) emptyset)))
(assert (not (in (priority y) emptyset)))

(define (unroll-keys (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (keys arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
      (eq (keys arg0) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (eq (keys arg0) (union (keys (l arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (eq (keys arg0) (union (keys (r arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (eq (keys arg0) (union (union (keys (l arg0)) (keys (r arg0))) (singleton (key arg0))))
    )
))

(define (unroll-keys' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (keys' arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
      (eq (keys' arg0) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (eq (keys' arg0) (union (keys' (l' arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (eq (keys' arg0) (union (keys' (r' arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (eq (keys' arg0) (union (union (keys' (l' arg0)) (keys' (r' arg0))) (singleton (key arg0))))
    )
))

(define (unroll-keys1 (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (keys1 arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l1 arg0) nil)
      (= (r1 arg0) nil)
      (eq (keys1 arg0) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (= (r1 arg0) nil)
      (not (= arg0 (l1 arg0)))
      (eq (keys1 arg0) (union (keys1 (l1 arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r1 arg0) nil))
      (= (l1 arg0) nil)
      (not (= arg0 (r1 arg0)))
      (eq (keys1 arg0) (union (keys1 (r1 arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (not (= (r1 arg0) nil))
      (not (= arg0 (l1 arg0)))
      (not (= arg0 (r1 arg0)))
      (not (= (l1 arg0) (r1 arg0)))
      (eq (keys1 arg0) (union (union (keys1 (l1 arg0)) (keys1 (r1 arg0))) (singleton (key arg0))))
    )
))

(define (unroll-priorities (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (priorities arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
      (eq (priorities arg0) (singleton (priority arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (eq (priorities arg0) (union (priorities (l arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (eq (priorities arg0) (union (priorities (r arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (eq (priorities arg0) (union (union (priorities (l arg0)) (priorities (r arg0))) (singleton (priority arg0))))
    )
))

(define (unroll-priorities' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (priorities' arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
      (eq (priorities' arg0) (singleton (priority arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (eq (priorities' arg0) (union (priorities' (l' arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (eq (priorities' arg0) (union (priorities' (r' arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (eq (priorities' arg0) (union (union (priorities' (l' arg0)) (priorities' (r' arg0))) (singleton (priority arg0))))
    )
))

(define (unroll-priorities1 (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (priorities1 arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l1 arg0) nil)
      (= (r1 arg0) nil)
      (eq (priorities1 arg0) (singleton (priority arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (= (r1 arg0) nil)
      (not (= arg0 (l1 arg0)))
      (eq (priorities1 arg0) (union (priorities1 (l1 arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r1 arg0) nil))
      (= (l1 arg0) nil)
      (not (= arg0 (r1 arg0)))
      (eq (priorities1 arg0) (union (priorities1 (r1 arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (not (= (r1 arg0) nil))
      (not (= arg0 (l1 arg0)))
      (not (= arg0 (r1 arg0)))
      (not (= (l1 arg0) (r1 arg0)))
      (eq (priorities1 arg0) (union (union (priorities1 (l1 arg0)) (priorities1 (r1 arg0))) (singleton (priority arg0))))
    )
))

(define (unroll-treap (arg0 Loc))
  (or
    (= arg0 nil) 
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (treap (l arg0))
      (lt (singleton (priority arg0)) (priorities (l arg0)))
      (lt (keys (l arg0)) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (treap (r arg0))
      (lt (singleton (priority arg0)) (priorities (r arg0)))
      (lt (singleton (key arg0)) (keys (r arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (treap (l arg0))
      (treap (r arg0))
      (lt (singleton (priority arg0)) (priorities (l arg0)))
      (lt (singleton (priority arg0)) (priorities (r arg0)))
      (lt (keys (l arg0)) (singleton (key arg0)))
      (lt (singleton (key arg0)) (keys (r arg0)))
      (disjoint (priorities (l arg0)) (priorities (r arg0)))
    )
))

(define (unroll-treap' (arg0 Loc))
  (or 
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (treap' (l' arg0))
      (lt (singleton (priority arg0)) (priorities' (l' arg0)))
      (lt (keys' (l' arg0)) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (treap' (r' arg0))
      (lt (singleton (priority arg0)) (priorities' (r' arg0)))
      (lt (singleton (key arg0)) (keys' (r' arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (treap' (l' arg0))
      (treap' (r' arg0))
      (lt (singleton (priority arg0)) (priorities' (l' arg0)))
      (lt (singleton (priority arg0)) (priorities' (r' arg0)))
      (lt (keys' (l' arg0)) (singleton (key arg0)))
      (lt (singleton (key arg0)) (keys' (r' arg0)))
      (disjoint (priorities' (l' arg0)) (priorities' (r' arg0)))
    )
))

(define (unroll-negtreap' (arg0 Loc))
  (or 
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (or 
         (not (treap' (l' arg0)))
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (l' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (l' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (keys' (l' arg0)) (singleton (key arg0))))
            (<= w1 w2)
            (in w1 (singleton (key arg0)))
            (in w2 (keys' (l' arg0)))
         )
      )
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (or 
         (not (treap' (r' arg0)))
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (r' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (r' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (singleton (key arg0)) (keys' (r' arg0))))
            (<= w1 w2)
            (in w1 (keys' (r' arg0)))
            (in w2 (singleton (key arg0)))
         )
      )
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (or 
         (not (treap' (l' arg0)))
         (not (treap' (r' arg0)))
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (l' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (l' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (r' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (r' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (keys' (l' arg0)) (singleton (key arg0))))
            (<= w1 w2)
            (in w1 (singleton (key arg0)))
            (in w2 (keys' (l' arg0)))
         )
         (and 
            (not (lt (singleton (key arg0)) (keys' (r' arg0))))
            (<= w1 w2)
            (in w1 (keys' (r' arg0)))
            (in w2 (singleton (key arg0)))
         )
         (and 
            (not (disjoint (priorities' (l' arg0)) (priorities' (r' arg0))))
            (in w1 (priorities' (l' arg0)))
            (in w1 (priorities' (r' arg0)))
         )
      )
    )
))

(define (unroll-treap1 (arg0 Loc))
  (or 
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (= (l1 arg0) nil)
      (= (r1 arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (= (r1 arg0) nil)
      (not (= arg0 (l1 arg0)))
      (treap1 (l1 arg0))
      (lt (singleton (priority arg0)) (priorities1 (l1 arg0)))
      (lt (keys1 (l1 arg0)) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r1 arg0) nil))
      (= (l1 arg0) nil)
      (not (= arg0 (r1 arg0)))
      (treap1 (r1 arg0))
      (lt (singleton (priority arg0)) (priorities1 (r1 arg0)))
      (lt (singleton (key arg0)) (keys1 (r1 arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (not (= (r1 arg0) nil))
      (not (= arg0 (l1 arg0)))
      (not (= arg0 (r1 arg0)))
      (not (= (l1 arg0) (r1 arg0)))
      (treap1 (l1 arg0))
      (treap1 (r1 arg0))
      (lt (singleton (priority arg0)) (priorities1 (l1 arg0)))
      (lt (singleton (priority arg0)) (priorities1 (r1 arg0)))
      (lt (keys1 (l1 arg0)) (singleton (key arg0)))
      (lt (singleton (key arg0)) (keys1 (r1 arg0)))
      (disjoint (priorities1 (l1 arg0)) (priorities1 (r1 arg0)))
    )
))


(define (precondition (arg0 Loc))
  (and
     (treap arg0)
     (not (in k (keys arg0)))
     (not (in p (priorities arg0)))
  )     
)

(define (postcondition (arg0 Loc) (arg1 Loc))
  (and
     (not (= arg1 nil))
     (treap' arg1)
     (eq (keys' arg1) (union (singleton k) (keys arg0)))
     (eq (priorities' arg1) (union (singleton p) (priorities arg0)))
  )   
)

(define (postcondition1 (arg0 Loc) (arg1 Loc))
  (and
     (not (= arg1 nil))
     (treap1 arg1)
     (eq (keys1 arg1) (union (singleton k) (keys arg0)))
     (eq (priorities1 arg1) (union (singleton p) (priorities arg0)))
  )   
)

(define (negpostcondition (arg0 Loc) (arg1 Loc))
  (or
     (= arg1 nil)
     (not (treap' arg1))
     (and
        (not (eq (keys' arg1) (union (singleton k) (keys arg0))))
        (or
           (and (in w1 (keys' arg1)) (not (in w1 (union (singleton k) (keys arg0)))))
           (and (not (in w1 (keys' arg1))) (in w1 (union (singleton k) (keys arg0))))
        )
     )
     (and 
        (not (eq (priorities' arg1) (union (singleton p) (priorities arg0))))
        (or
           (and (in w1 (priorities' arg1)) (not (in w1 (union (singleton p) (priorities arg0)))))
           (and (not (in w1 (priorities' arg1))) (in w1 (union (singleton p) (priorities arg0))))
        )
     )
  )   
)

; Path1

(declare-fun p1vc1 () Bool)
(assert (iff p1vc1
  (=>
     (and 
        (precondition x)
        (= x nil)
        (not (= y nil))
        (= (l' y) nil)
        (= (r' y) nil)
        (= (key y) k)
        (= (priority y) p)
        (unroll-keys' y)
        (unroll-priorities' y)
        (=> (treap' y) (unroll-treap' y))
        (=> (not (treap' y)) (unroll-negtreap' y))
     )
     (not (negpostcondition x y))
  )
))



(assert (not p1vc1))
(check-sat)
(model)