(set-logic QF-UFLIA)


(declare-sort Loc)
(declare-sort Set)

(declare-fun singleton (Int) Set)
(declare-fun union (Set Set) Set)
(declare-fun inter (Set Set) Set)
(declare-fun emptyset () Set)
(declare-fun in (Int Set) Bool)
(declare-fun subset (Set Set) Bool)
(declare-fun lt (Set Set) Bool)
(declare-fun eq (Set Set) Bool)
(declare-fun disjoint (Set Set) Bool)


(declare-fun nil () Loc)
(declare-fun key (Loc) Int)
(declare-fun priority (Loc) Int)
(declare-fun l (Loc) Loc)
(declare-fun r (Loc) Loc)
(declare-fun l' (Loc) Loc)
(declare-fun r' (Loc) Loc)
(declare-fun l1 (Loc) Loc)
(declare-fun r1 (Loc) Loc)
(declare-fun treap (Loc) Bool)
(declare-fun treap' (Loc) Bool)
(declare-fun treap1 (Loc) Bool)


(declare-fun keys (Loc) Set)
(declare-fun keys' (Loc) Set)
(declare-fun keys1 (Loc) Set)
(declare-fun priorities (Loc) Set)
(declare-fun priorities' (Loc) Set)
(declare-fun priorities1 (Loc) Set)


(assert (treap nil))
(assert (treap' nil))
(assert (treap1 nil))
(assert (eq (keys nil) emptyset))
(assert (eq (keys' nil) emptyset))
(assert (eq (keys1 nil) emptyset))
(assert (eq (priorities nil) emptyset))
(assert (eq (priorities' nil) emptyset))
(assert (eq (priorities1 nil) emptyset))


; Vars
(declare-fun x () Loc)
(declare-fun k () Int)
(declare-fun p () Int)
(declare-fun w1 () Int)
(declare-fun w2 () Int)


(assert (iff (in k (union (keys (l x)) (singleton (key x)))) (or (in k (keys (l x))) (in k (singleton (key x))))))
(assert (iff (in p (union (keys (l x)) (singleton (key x)))) (or (in p (keys (l x))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (keys (l x)) (singleton (key x)))) (or (in w1 (keys (l x))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (keys (l x)) (singleton (key x)))) (or (in w2 (keys (l x))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (keys (l x)) (singleton (key x)))) (or (in (key x) (keys (l x))) (in (key x) (singleton (key x))))))
(assert (iff (in (priority x) (union (keys (l x)) (singleton (key x)))) (or (in (priority x) (keys (l x))) (in (priority x) (singleton (key x))))))
(assert (iff (in k (union (keys (r x)) (singleton (key x)))) (or (in k (keys (r x))) (in k (singleton (key x))))))
(assert (iff (in p (union (keys (r x)) (singleton (key x)))) (or (in p (keys (r x))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (keys (r x)) (singleton (key x)))) (or (in w1 (keys (r x))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (keys (r x)) (singleton (key x)))) (or (in w2 (keys (r x))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (keys (r x)) (singleton (key x)))) (or (in (key x) (keys (r x))) (in (key x) (singleton (key x))))))
(assert (iff (in (priority x) (union (keys (r x)) (singleton (key x)))) (or (in (priority x) (keys (r x))) (in (priority x) (singleton (key x))))))
(assert (iff (in k (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in k (union (keys (l x)) (keys (r x)))) (in k (singleton (key x))))))
(assert (iff (in p (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in p (union (keys (l x)) (keys (r x)))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in w1 (union (keys (l x)) (keys (r x)))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in w2 (union (keys (l x)) (keys (r x)))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in (key x) (union (keys (l x)) (keys (r x)))) (in (key x) (singleton (key x))))))
(assert (iff (in (priority x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in (priority x) (union (keys (l x)) (keys (r x)))) (in (priority x) (singleton (key x))))))
(assert (iff (in k (union (keys (l x)) (keys (r x)))) (or (in k (keys (l x))) (in k (keys (r x))))))
(assert (iff (in p (union (keys (l x)) (keys (r x)))) (or (in p (keys (l x))) (in p (keys (r x))))))
(assert (iff (in w1 (union (keys (l x)) (keys (r x)))) (or (in w1 (keys (l x))) (in w1 (keys (r x))))))
(assert (iff (in w2 (union (keys (l x)) (keys (r x)))) (or (in w2 (keys (l x))) (in w2 (keys (r x))))))
(assert (iff (in (key x) (union (keys (l x)) (keys (r x)))) (or (in (key x) (keys (l x))) (in (key x) (keys (r x))))))
(assert (iff (in (priority x) (union (keys (l x)) (keys (r x)))) (or (in (priority x) (keys (l x))) (in (priority x) (keys (r x))))))
(assert (iff (in k (union (priorities (l x)) (singleton (priority x)))) (or (in k (priorities (l x))) (in k (singleton (priority x))))))
(assert (iff (in p (union (priorities (l x)) (singleton (priority x)))) (or (in p (priorities (l x))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (priorities (l x)) (singleton (priority x)))) (or (in w1 (priorities (l x))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (priorities (l x)) (singleton (priority x)))) (or (in w2 (priorities (l x))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (priorities (l x)) (singleton (priority x)))) (or (in (key x) (priorities (l x))) (in (key x) (singleton (priority x))))))
(assert (iff (in (priority x) (union (priorities (l x)) (singleton (priority x)))) (or (in (priority x) (priorities (l x))) (in (priority x) (singleton (priority x))))))
(assert (iff (in k (union (priorities (r x)) (singleton (priority x)))) (or (in k (priorities (r x))) (in k (singleton (priority x))))))
(assert (iff (in p (union (priorities (r x)) (singleton (priority x)))) (or (in p (priorities (r x))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (priorities (r x)) (singleton (priority x)))) (or (in w1 (priorities (r x))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (priorities (r x)) (singleton (priority x)))) (or (in w2 (priorities (r x))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (priorities (r x)) (singleton (priority x)))) (or (in (key x) (priorities (r x))) (in (key x) (singleton (priority x))))))
(assert (iff (in (priority x) (union (priorities (r x)) (singleton (priority x)))) (or (in (priority x) (priorities (r x))) (in (priority x) (singleton (priority x))))))
(assert (iff (in k (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in k (union (priorities (l x)) (priorities (r x)))) (in k (singleton (priority x))))))
(assert (iff (in p (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in p (union (priorities (l x)) (priorities (r x)))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in w1 (union (priorities (l x)) (priorities (r x)))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in w2 (union (priorities (l x)) (priorities (r x)))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in (key x) (union (priorities (l x)) (priorities (r x)))) (in (key x) (singleton (priority x))))))
(assert (iff (in (priority x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in (priority x) (union (priorities (l x)) (priorities (r x)))) (in (priority x) (singleton (priority x))))))
(assert (iff (in k (union (priorities (l x)) (priorities (r x)))) (or (in k (priorities (l x))) (in k (priorities (r x))))))
(assert (iff (in p (union (priorities (l x)) (priorities (r x)))) (or (in p (priorities (l x))) (in p (priorities (r x))))))
(assert (iff (in w1 (union (priorities (l x)) (priorities (r x)))) (or (in w1 (priorities (l x))) (in w1 (priorities (r x))))))
(assert (iff (in w2 (union (priorities (l x)) (priorities (r x)))) (or (in w2 (priorities (l x))) (in w2 (priorities (r x))))))
(assert (iff (in (key x) (union (priorities (l x)) (priorities (r x)))) (or (in (key x) (priorities (l x))) (in (key x) (priorities (r x))))))
(assert (iff (in (priority x) (union (priorities (l x)) (priorities (r x)))) (or (in (priority x) (priorities (l x))) (in (priority x) (priorities (r x))))))



(assert (iff (in k (singleton (key x))) (= k (key x))))
(assert (iff (in p (singleton (key x))) (= p (key x))))
(assert (iff (in w1 (singleton (key x))) (= w1 (key x))))
(assert (iff (in w2 (singleton (key x))) (= w2 (key x))))
(assert (iff (in (key x) (singleton (key x))) (= (key x) (key x))))
(assert (iff (in (priority x) (singleton (key x))) (= (priority x) (key x))))
(assert (iff (in k (singleton (priority x))) (= k (priority x))))
(assert (iff (in p (singleton (priority x))) (= p (priority x))))
(assert (iff (in w1 (singleton (priority x))) (= w1 (priority x))))
(assert (iff (in w2 (singleton (priority x))) (= w2 (priority x))))
(assert (iff (in (key x) (singleton (priority x))) (= (key x) (priority x))))
(assert (iff (in (priority x) (singleton (priority x))) (= (priority x) (priority x))))
(assert (iff (in k (singleton k)) (= k k)))
(assert (iff (in p (singleton k)) (= p k)))
(assert (iff (in w1 (singleton k)) (= w1 k)))
(assert (iff (in w2 (singleton k)) (= w2 k)))
(assert (iff (in (key x) (singleton k)) (= (key x) k)))
(assert (iff (in (priority x) (singleton k)) (= (priority x) k)))
(assert (iff (in k (singleton p)) (= k p)))
(assert (iff (in p (singleton p)) (= p p)))
(assert (iff (in w1 (singleton p)) (= w1 p)))
(assert (iff (in w2 (singleton p)) (= w2 p)))
(assert (iff (in (key x) (singleton p)) (= (key x) p)))
(assert (iff (in (priority x) (singleton p)) (= (priority x) p)))


(assert (=> (eq (keys nil) emptyset) (iff (in k (keys nil)) (in k emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in p (keys nil)) (in p emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in w1 (keys nil)) (in w1 emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in w2 (keys nil)) (in w2 emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in (key x) (keys nil)) (in (key x) emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in (priority x) (keys nil)) (in (priority x) emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in k (keys' nil)) (in k emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in p (keys' nil)) (in p emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in w1 (keys' nil)) (in w1 emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in w2 (keys' nil)) (in w2 emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in (key x) (keys' nil)) (in (key x) emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in (priority x) (keys' nil)) (in (priority x) emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in k (keys1 nil)) (in k emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in p (keys1 nil)) (in p emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in w1 (keys1 nil)) (in w1 emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in w2 (keys1 nil)) (in w2 emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in (key x) (keys1 nil)) (in (key x) emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in (priority x) (keys1 nil)) (in (priority x) emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in k (priorities nil)) (in k emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in p (priorities nil)) (in p emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in w1 (priorities nil)) (in w1 emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in w2 (priorities nil)) (in w2 emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in (key x) (priorities nil)) (in (key x) emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in (priority x) (priorities nil)) (in (priority x) emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in k (priorities' nil)) (in k emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in p (priorities' nil)) (in p emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in w1 (priorities' nil)) (in w1 emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in w2 (priorities' nil)) (in w2 emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in (key x) (priorities' nil)) (in (key x) emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in (priority x) (priorities' nil)) (in (priority x) emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in k (priorities1 nil)) (in k emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in p (priorities1 nil)) (in p emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in w1 (priorities1 nil)) (in w1 emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in w2 (priorities1 nil)) (in w2 emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in (key x) (priorities1 nil)) (in (key x) emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in (priority x) (priorities1 nil)) (in (priority x) emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in k (keys x)) (in k emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in p (keys x)) (in p emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in w1 (keys x)) (in w1 emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in w2 (keys x)) (in w2 emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in (key x) (keys x)) (in (key x) emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in (priority x) (keys x)) (in (priority x) emptyset))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in k (keys x)) (in k (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in p (keys x)) (in p (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in w1 (keys x)) (in w1 (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in w2 (keys x)) (in w2 (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in (key x) (keys x)) (in (key x) (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in (priority x) (keys x)) (in (priority x) (singleton (key x))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in k (keys x)) (in k (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in p (keys x)) (in p (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in w1 (keys x)) (in w1 (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in w2 (keys x)) (in w2 (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in (key x) (keys x)) (in (key x) (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in (priority x) (keys x)) (in (priority x) (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in k (keys x)) (in k (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in p (keys x)) (in p (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in w1 (keys x)) (in w1 (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in w2 (keys x)) (in w2 (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in (key x) (keys x)) (in (key x) (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in (priority x) (keys x)) (in (priority x) (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in k (keys x)) (in k (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in p (keys x)) (in p (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in w1 (keys x)) (in w1 (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in w2 (keys x)) (in w2 (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in (key x) (keys x)) (in (key x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in (priority x) (keys x)) (in (priority x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (priorities x) emptyset) (iff (in k (priorities x)) (in k emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in p (priorities x)) (in p emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in w1 (priorities x)) (in w1 emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in w2 (priorities x)) (in w2 emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in (key x) (priorities x)) (in (key x) emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in (priority x) (priorities x)) (in (priority x) emptyset))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in k (priorities x)) (in k (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in p (priorities x)) (in p (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in w1 (priorities x)) (in w1 (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in w2 (priorities x)) (in w2 (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in (key x) (priorities x)) (in (key x) (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in (priority x) (priorities x)) (in (priority x) (singleton (priority x))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in k (priorities x)) (in k (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in p (priorities x)) (in p (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in w1 (priorities x)) (in w1 (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in w2 (priorities x)) (in w2 (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in (key x) (priorities x)) (in (key x) (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in (priority x) (priorities x)) (in (priority x) (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in k (priorities x)) (in k (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in p (priorities x)) (in p (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in w1 (priorities x)) (in w1 (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in w2 (priorities x)) (in w2 (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in (key x) (priorities x)) (in (key x) (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in (priority x) (priorities x)) (in (priority x) (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in k (priorities x)) (in k (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in p (priorities x)) (in p (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in w1 (priorities x)) (in w1 (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in w2 (priorities x)) (in w2 (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in (key x) (priorities x)) (in (key x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in (priority x) (priorities x)) (in (priority x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))

(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in k (priorities (l x))) (in k (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in p (priorities (l x))) (in p (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in w1 (priorities (l x))) (in w1 (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in w2 (priorities (l x))) (in w2 (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in (key x) (priorities (l x))) (in (key x) (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in (priority x) (priorities (l x))) (in (priority x) (priorities (r x)))))))

(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in k (priorities (l x)))) (< k k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in p (priorities (l x)))) (< k p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in w1 (priorities (l x)))) (< k w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in w2 (priorities (l x)))) (< k w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in (key x) (priorities (l x)))) (< k (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in (priority x) (priorities (l x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in k (priorities (l x)))) (< p k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in p (priorities (l x)))) (< p p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in w1 (priorities (l x)))) (< p w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in w2 (priorities (l x)))) (< p w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in (key x) (priorities (l x)))) (< p (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in (priority x) (priorities (l x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in k (priorities (l x)))) (< w1 k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in p (priorities (l x)))) (< w1 p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in w1 (priorities (l x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in w2 (priorities (l x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in (key x) (priorities (l x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in (priority x) (priorities (l x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in k (priorities (l x)))) (< w2 k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in p (priorities (l x)))) (< w2 p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in w1 (priorities (l x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in w2 (priorities (l x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in (key x) (priorities (l x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in (priority x) (priorities (l x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in k (priorities (l x)))) (< (key x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in p (priorities (l x)))) (< (key x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in w1 (priorities (l x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in w2 (priorities (l x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in (key x) (priorities (l x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in (priority x) (priorities (l x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in k (priorities (l x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in p (priorities (l x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in w1 (priorities (l x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in w2 (priorities (l x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in (key x) (priorities (l x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority x) (priorities (l x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in k (singleton (key x)))) (< k k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in p (singleton (key x)))) (< k p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in w1 (singleton (key x)))) (< k w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in w2 (singleton (key x)))) (< k w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in (key x) (singleton (key x)))) (< k (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in (priority x) (singleton (key x)))) (< k (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in k (singleton (key x)))) (< p k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in p (singleton (key x)))) (< p p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in w1 (singleton (key x)))) (< p w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in w2 (singleton (key x)))) (< p w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in (key x) (singleton (key x)))) (< p (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in (priority x) (singleton (key x)))) (< p (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in k (singleton (key x)))) (< w1 k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in p (singleton (key x)))) (< w1 p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in w1 (singleton (key x)))) (< w1 w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in w2 (singleton (key x)))) (< w1 w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in (key x) (singleton (key x)))) (< w1 (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in (priority x) (singleton (key x)))) (< w1 (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in k (singleton (key x)))) (< w2 k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in p (singleton (key x)))) (< w2 p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in w1 (singleton (key x)))) (< w2 w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in w2 (singleton (key x)))) (< w2 w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in (key x) (singleton (key x)))) (< w2 (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in (priority x) (singleton (key x)))) (< w2 (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in k (singleton (key x)))) (< (key x) k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in p (singleton (key x)))) (< (key x) p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in w1 (singleton (key x)))) (< (key x) w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in w2 (singleton (key x)))) (< (key x) w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in (key x) (singleton (key x)))) (< (key x) (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in (priority x) (singleton (key x)))) (< (key x) (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in k (singleton (key x)))) (< (priority x) k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in p (singleton (key x)))) (< (priority x) p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in w1 (singleton (key x)))) (< (priority x) w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in w2 (singleton (key x)))) (< (priority x) w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in (key x) (singleton (key x)))) (< (priority x) (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in (priority x) (singleton (key x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in k (priorities (r x)))) (< k k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in p (priorities (r x)))) (< k p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in w1 (priorities (r x)))) (< k w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in w2 (priorities (r x)))) (< k w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in (key x) (priorities (r x)))) (< k (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in (priority x) (priorities (r x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in k (priorities (r x)))) (< p k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in p (priorities (r x)))) (< p p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in w1 (priorities (r x)))) (< p w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in w2 (priorities (r x)))) (< p w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in (key x) (priorities (r x)))) (< p (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in (priority x) (priorities (r x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in k (priorities (r x)))) (< w1 k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in p (priorities (r x)))) (< w1 p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in w1 (priorities (r x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in w2 (priorities (r x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in (key x) (priorities (r x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in (priority x) (priorities (r x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in k (priorities (r x)))) (< w2 k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in p (priorities (r x)))) (< w2 p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in w1 (priorities (r x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in w2 (priorities (r x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in (key x) (priorities (r x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in (priority x) (priorities (r x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in k (priorities (r x)))) (< (key x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in p (priorities (r x)))) (< (key x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in w1 (priorities (r x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in w2 (priorities (r x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in (key x) (priorities (r x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in (priority x) (priorities (r x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in k (priorities (r x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in p (priorities (r x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in w1 (priorities (r x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in w2 (priorities (r x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in (key x) (priorities (r x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority x) (priorities (r x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in k (keys (r x)))) (< k k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in p (keys (r x)))) (< k p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in w1 (keys (r x)))) (< k w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in w2 (keys (r x)))) (< k w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in (key x) (keys (r x)))) (< k (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in (priority x) (keys (r x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in k (keys (r x)))) (< p k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in p (keys (r x)))) (< p p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in w1 (keys (r x)))) (< p w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in w2 (keys (r x)))) (< p w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in (key x) (keys (r x)))) (< p (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in (priority x) (keys (r x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in k (keys (r x)))) (< w1 k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in p (keys (r x)))) (< w1 p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in w1 (keys (r x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in w2 (keys (r x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in (key x) (keys (r x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in (priority x) (keys (r x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in k (keys (r x)))) (< w2 k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in p (keys (r x)))) (< w2 p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in w1 (keys (r x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in w2 (keys (r x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in (key x) (keys (r x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in (priority x) (keys (r x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in k (keys (r x)))) (< (key x) k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in p (keys (r x)))) (< (key x) p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in w1 (keys (r x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in w2 (keys (r x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in (key x) (keys (r x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in (priority x) (keys (r x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in k (keys (r x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in p (keys (r x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in w1 (keys (r x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in w2 (keys (r x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in (key x) (keys (r x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in (priority x) (keys (r x)))) (< (priority x) (priority x) ))))


(assert (not (in k emptyset)))
(assert (not (in p emptyset)))
(assert (not (in w1 emptyset)))
(assert (not (in w2 emptyset)))
(assert (not (in (key x) emptyset)))
(assert (not (in (priority x) emptyset)))

(define (unroll-keys (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (keys arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
      (eq (keys arg0) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (eq (keys arg0) (union (keys (l arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (eq (keys arg0) (union (keys (r arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (eq (keys arg0) (union (union (keys (l arg0)) (keys (r arg0))) (singleton (key arg0))))
    )
))

(define (unroll-keys' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (keys' arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
      (eq (keys' arg0) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (eq (keys' arg0) (union (keys' (l' arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (eq (keys' arg0) (union (keys' (r' arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (eq (keys' arg0) (union (union (keys' (l' arg0)) (keys' (r' arg0))) (singleton (key arg0))))
    )
))

(define (unroll-keys1 (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (keys1 arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l1 arg0) nil)
      (= (r1 arg0) nil)
      (eq (keys1 arg0) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (= (r1 arg0) nil)
      (not (= arg0 (l1 arg0)))
      (eq (keys1 arg0) (union (keys1 (l1 arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r1 arg0) nil))
      (= (l1 arg0) nil)
      (not (= arg0 (r1 arg0)))
      (eq (keys1 arg0) (union (keys1 (r1 arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (not (= (r1 arg0) nil))
      (not (= arg0 (l1 arg0)))
      (not (= arg0 (r1 arg0)))
      (not (= (l1 arg0) (r1 arg0)))
      (eq (keys1 arg0) (union (union (keys1 (l1 arg0)) (keys1 (r1 arg0))) (singleton (key arg0))))
    )
))

(define (unroll-priorities (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (priorities arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
      (eq (priorities arg0) (singleton (priority arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (eq (priorities arg0) (union (priorities (l arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (eq (priorities arg0) (union (priorities (r arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (eq (priorities arg0) (union (union (priorities (l arg0)) (priorities (r arg0))) (singleton (priority arg0))))
    )
))

(define (unroll-priorities' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (priorities' arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
      (eq (priorities' arg0) (singleton (priority arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (eq (priorities' arg0) (union (priorities' (l' arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (eq (priorities' arg0) (union (priorities' (r' arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (eq (priorities' arg0) (union (union (priorities' (l' arg0)) (priorities' (r' arg0))) (singleton (priority arg0))))
    )
))

(define (unroll-priorities1 (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (priorities1 arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l1 arg0) nil)
      (= (r1 arg0) nil)
      (eq (priorities1 arg0) (singleton (priority arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (= (r1 arg0) nil)
      (not (= arg0 (l1 arg0)))
      (eq (priorities1 arg0) (union (priorities1 (l1 arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r1 arg0) nil))
      (= (l1 arg0) nil)
      (not (= arg0 (r1 arg0)))
      (eq (priorities1 arg0) (union (priorities1 (r1 arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (not (= (r1 arg0) nil))
      (not (= arg0 (l1 arg0)))
      (not (= arg0 (r1 arg0)))
      (not (= (l1 arg0) (r1 arg0)))
      (eq (priorities1 arg0) (union (union (priorities1 (l1 arg0)) (priorities1 (r1 arg0))) (singleton (priority arg0))))
    )
))

(define (unroll-treap (arg0 Loc))
  (or
    (= arg0 nil) 
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (treap (l arg0))
      (lt (singleton (priority arg0)) (priorities (l arg0)))
      (lt (keys (l arg0)) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (treap (r arg0))
      (lt (singleton (priority arg0)) (priorities (r arg0)))
      (lt (singleton (key arg0)) (keys (r arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (treap (l arg0))
      (treap (r arg0))
      (lt (singleton (priority arg0)) (priorities (l arg0)))
      (lt (singleton (priority arg0)) (priorities (r arg0)))
      (lt (keys (l arg0)) (singleton (key arg0)))
      (lt (singleton (key arg0)) (keys (r arg0)))
      (disjoint (priorities (l arg0)) (priorities (r arg0)))
    )
))

(define (unroll-treap' (arg0 Loc))
  (or 
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (treap' (l' arg0))
      (lt (singleton (priority arg0)) (priorities' (l' arg0)))
      (lt (keys' (l' arg0)) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (treap' (r' arg0))
      (lt (singleton (priority arg0)) (priorities' (r' arg0)))
      (lt (singleton (key arg0)) (keys' (r' arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (treap' (l' arg0))
      (treap' (r' arg0))
      (lt (singleton (priority arg0)) (priorities' (l' arg0)))
      (lt (singleton (priority arg0)) (priorities' (r' arg0)))
      (lt (keys' (l' arg0)) (singleton (key arg0)))
      (lt (singleton (key arg0)) (keys' (r' arg0)))
      (disjoint (priorities' (l' arg0)) (priorities' (r' arg0)))
    )
))

(define (unroll-negtreap' (arg0 Loc))
  (or 
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (or 
         (not (treap' (l' arg0)))
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (l' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (l' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (keys' (l' arg0)) (singleton (key arg0))))
            (<= w1 w2)
            (in w1 (singleton (key arg0)))
            (in w2 (keys' (l' arg0)))
         )
      )
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (or 
         (not (treap' (r' arg0)))
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (r' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (r' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (singleton (key arg0)) (keys' (r' arg0))))
            (<= w1 w2)
            (in w1 (keys' (r' arg0)))
            (in w2 (singleton (key arg0)))
         )
      )
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (or 
         (not (treap' (l' arg0)))
         (not (treap' (r' arg0)))
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (l' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (l' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (r' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (r' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (keys' (l' arg0)) (singleton (key arg0))))
            (<= w1 w2)
            (in w1 (singleton (key arg0)))
            (in w2 (keys' (l' arg0)))
         )
         (and 
            (not (lt (singleton (key arg0)) (keys' (r' arg0))))
            (<= w1 w2)
            (in w1 (keys' (r' arg0)))
            (in w2 (singleton (key arg0)))
         )
         (and 
            (not (disjoint (priorities' (l' arg0)) (priorities' (r' arg0))))
            (in w1 (priorities' (l' arg0)))
            (in w1 (priorities' (r' arg0)))
         )
      )
    )
))

(define (unroll-treap1 (arg0 Loc))
  (or 
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (= (l1 arg0) nil)
      (= (r1 arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (= (r1 arg0) nil)
      (not (= arg0 (l1 arg0)))
      (treap1 (l1 arg0))
      (lt (singleton (priority arg0)) (priorities1 (l1 arg0)))
      (lt (keys1 (l1 arg0)) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r1 arg0) nil))
      (= (l1 arg0) nil)
      (not (= arg0 (r1 arg0)))
      (treap1 (r1 arg0))
      (lt (singleton (priority arg0)) (priorities1 (r1 arg0)))
      (lt (singleton (key arg0)) (keys1 (r1 arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (not (= (r1 arg0) nil))
      (not (= arg0 (l1 arg0)))
      (not (= arg0 (r1 arg0)))
      (not (= (l1 arg0) (r1 arg0)))
      (treap1 (l1 arg0))
      (treap1 (r1 arg0))
      (lt (singleton (priority arg0)) (priorities1 (l1 arg0)))
      (lt (singleton (priority arg0)) (priorities1 (r1 arg0)))
      (lt (keys1 (l1 arg0)) (singleton (key arg0)))
      (lt (singleton (key arg0)) (keys1 (r1 arg0)))
      (disjoint (priorities1 (l1 arg0)) (priorities1 (r1 arg0)))
    )
))


(define (precondition (arg0 Loc))
  (and
     (treap arg0)
     (not (in k (keys arg0)))
     (not (in p (priorities arg0)))
  )     
)

(define (postcondition (arg0 Loc) (arg1 Loc))
  (and
     (not (= arg1 nil))
     (treap' arg1)
     (eq (keys' arg1) (union (singleton k) (keys arg0)))
     (eq (priorities' arg1) (union (singleton p) (priorities arg0)))
  )   
)

(define (postcondition1 (arg0 Loc) (arg1 Loc))
  (and
     (not (= arg1 nil))
     (treap1 arg1)
     (eq (keys1 arg1) (union (singleton k) (keys arg0)))
     (eq (priorities1 arg1) (union (singleton p) (priorities arg0)))
  )   
)

(define (negpostcondition (arg0 Loc) (arg1 Loc))
  (or
     (= arg1 nil)
     (not (treap' arg1))
     (and
        (not (eq (keys' arg1) (union (singleton k) (keys arg0))))
        (or
           (and (in w1 (keys' arg1)) (not (in w1 (union (singleton k) (keys arg0)))))
           (and (not (in w1 (keys' arg1))) (in w1 (union (singleton k) (keys arg0))))
        )
     )
     (and 
        (not (eq (priorities' arg1) (union (singleton p) (priorities arg0))))
        (or
           (and (in w1 (priorities' arg1)) (not (in w1 (union (singleton p) (priorities arg0)))))
           (and (not (in w1 (priorities' arg1))) (in w1 (union (singleton p) (priorities arg0))))
        )
     )
  )   
)


; Path3

(declare-fun p3vc1 () Bool)
(assert (iff p3vc1
  (=>
     (and
        (precondition x)
        (not (= x nil))
        (< k (key x))
        (unroll-keys x)
        (unroll-priorities x)
        (=> (treap x) (unroll-treap x))
     )
     (precondition (l x))
  )
))



(assert (not p3vc1))
(check-sat)
(model)