(set-logic QF-UFLIA)


(declare-sort Loc)
(declare-sort Set)

(declare-fun singleton (Int) Set)
(declare-fun union (Set Set) Set)
(declare-fun inter (Set Set) Set)
(declare-fun emptyset () Set)
(declare-fun in (Int Set) Bool)
(declare-fun subset (Set Set) Bool)
(declare-fun lt (Set Set) Bool)
(declare-fun eq (Set Set) Bool)
(declare-fun disjoint (Set Set) Bool)


(declare-fun nil () Loc)
(declare-fun key (Loc) Int)
(declare-fun priority (Loc) Int)
(declare-fun l (Loc) Loc)
(declare-fun r (Loc) Loc)
(declare-fun l' (Loc) Loc)
(declare-fun r' (Loc) Loc)
(declare-fun l1 (Loc) Loc)
(declare-fun r1 (Loc) Loc)
(declare-fun treap (Loc) Bool)
(declare-fun treap' (Loc) Bool)
(declare-fun treap1 (Loc) Bool)


(declare-fun keys (Loc) Set)
(declare-fun keys' (Loc) Set)
(declare-fun keys1 (Loc) Set)
(declare-fun priorities (Loc) Set)
(declare-fun priorities' (Loc) Set)
(declare-fun priorities1 (Loc) Set)


(assert (treap nil))
(assert (treap' nil))
(assert (treap1 nil))
(assert (eq (keys nil) emptyset))
(assert (eq (keys' nil) emptyset))
(assert (eq (keys1 nil) emptyset))
(assert (eq (priorities nil) emptyset))
(assert (eq (priorities' nil) emptyset))
(assert (eq (priorities1 nil) emptyset))


; Vars
(declare-fun x () Loc)
(declare-fun k () Int)
(declare-fun p () Int)
(declare-fun w1 () Int)
(declare-fun w2 () Int)


(assert (iff (in k (union (keys (l x)) (singleton (key x)))) (or (in k (keys (l x))) (in k (singleton (key x))))))
(assert (iff (in p (union (keys (l x)) (singleton (key x)))) (or (in p (keys (l x))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (keys (l x)) (singleton (key x)))) (or (in w1 (keys (l x))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (keys (l x)) (singleton (key x)))) (or (in w2 (keys (l x))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (keys (l x)) (singleton (key x)))) (or (in (key x) (keys (l x))) (in (key x) (singleton (key x))))))
(assert (iff (in (key (r1 x)) (union (keys (l x)) (singleton (key x)))) (or (in (key (r1 x)) (keys (l x))) (in (key (r1 x)) (singleton (key x))))))
(assert (iff (in (key (l x)) (union (keys (l x)) (singleton (key x)))) (or (in (key (l x)) (keys (l x))) (in (key (l x)) (singleton (key x))))))
(assert (iff (in (priority x) (union (keys (l x)) (singleton (key x)))) (or (in (priority x) (keys (l x))) (in (priority x) (singleton (key x))))))
(assert (iff (in (priority (r1 x)) (union (keys (l x)) (singleton (key x)))) (or (in (priority (r1 x)) (keys (l x))) (in (priority (r1 x)) (singleton (key x))))))
(assert (iff (in (priority (l x)) (union (keys (l x)) (singleton (key x)))) (or (in (priority (l x)) (keys (l x))) (in (priority (l x)) (singleton (key x))))))
(assert (iff (in k (union (keys (r x)) (singleton (key x)))) (or (in k (keys (r x))) (in k (singleton (key x))))))
(assert (iff (in p (union (keys (r x)) (singleton (key x)))) (or (in p (keys (r x))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (keys (r x)) (singleton (key x)))) (or (in w1 (keys (r x))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (keys (r x)) (singleton (key x)))) (or (in w2 (keys (r x))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (keys (r x)) (singleton (key x)))) (or (in (key x) (keys (r x))) (in (key x) (singleton (key x))))))
(assert (iff (in (key (r1 x)) (union (keys (r x)) (singleton (key x)))) (or (in (key (r1 x)) (keys (r x))) (in (key (r1 x)) (singleton (key x))))))
(assert (iff (in (key (l x)) (union (keys (r x)) (singleton (key x)))) (or (in (key (l x)) (keys (r x))) (in (key (l x)) (singleton (key x))))))
(assert (iff (in (priority x) (union (keys (r x)) (singleton (key x)))) (or (in (priority x) (keys (r x))) (in (priority x) (singleton (key x))))))
(assert (iff (in (priority (r1 x)) (union (keys (r x)) (singleton (key x)))) (or (in (priority (r1 x)) (keys (r x))) (in (priority (r1 x)) (singleton (key x))))))
(assert (iff (in (priority (l x)) (union (keys (r x)) (singleton (key x)))) (or (in (priority (l x)) (keys (r x))) (in (priority (l x)) (singleton (key x))))))
(assert (iff (in k (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in k (union (keys (l x)) (keys (r x)))) (in k (singleton (key x))))))
(assert (iff (in p (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in p (union (keys (l x)) (keys (r x)))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in w1 (union (keys (l x)) (keys (r x)))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in w2 (union (keys (l x)) (keys (r x)))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in (key x) (union (keys (l x)) (keys (r x)))) (in (key x) (singleton (key x))))))
(assert (iff (in (key (r1 x)) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in (key (r1 x)) (union (keys (l x)) (keys (r x)))) (in (key (r1 x)) (singleton (key x))))))
(assert (iff (in (key (l x)) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in (key (l x)) (union (keys (l x)) (keys (r x)))) (in (key (l x)) (singleton (key x))))))
(assert (iff (in (priority x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in (priority x) (union (keys (l x)) (keys (r x)))) (in (priority x) (singleton (key x))))))
(assert (iff (in (priority (r1 x)) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in (priority (r1 x)) (union (keys (l x)) (keys (r x)))) (in (priority (r1 x)) (singleton (key x))))))
(assert (iff (in (priority (l x)) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (or (in (priority (l x)) (union (keys (l x)) (keys (r x)))) (in (priority (l x)) (singleton (key x))))))
(assert (iff (in k (union (keys (l x)) (keys (r x)))) (or (in k (keys (l x))) (in k (keys (r x))))))
(assert (iff (in p (union (keys (l x)) (keys (r x)))) (or (in p (keys (l x))) (in p (keys (r x))))))
(assert (iff (in w1 (union (keys (l x)) (keys (r x)))) (or (in w1 (keys (l x))) (in w1 (keys (r x))))))
(assert (iff (in w2 (union (keys (l x)) (keys (r x)))) (or (in w2 (keys (l x))) (in w2 (keys (r x))))))
(assert (iff (in (key x) (union (keys (l x)) (keys (r x)))) (or (in (key x) (keys (l x))) (in (key x) (keys (r x))))))
(assert (iff (in (key (r1 x)) (union (keys (l x)) (keys (r x)))) (or (in (key (r1 x)) (keys (l x))) (in (key (r1 x)) (keys (r x))))))
(assert (iff (in (key (l x)) (union (keys (l x)) (keys (r x)))) (or (in (key (l x)) (keys (l x))) (in (key (l x)) (keys (r x))))))
(assert (iff (in (priority x) (union (keys (l x)) (keys (r x)))) (or (in (priority x) (keys (l x))) (in (priority x) (keys (r x))))))
(assert (iff (in (priority (r1 x)) (union (keys (l x)) (keys (r x)))) (or (in (priority (r1 x)) (keys (l x))) (in (priority (r1 x)) (keys (r x))))))
(assert (iff (in (priority (l x)) (union (keys (l x)) (keys (r x)))) (or (in (priority (l x)) (keys (l x))) (in (priority (l x)) (keys (r x))))))
(assert (iff (in k (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (or (in k (keys' (l' (r1 x)))) (in k (singleton (key (r1 x)))))))
(assert (iff (in p (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (or (in p (keys' (l' (r1 x)))) (in p (singleton (key (r1 x)))))))
(assert (iff (in w1 (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (or (in w1 (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x)))))))
(assert (iff (in w2 (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (or (in w2 (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x)))))))
(assert (iff (in (key x) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (or (in (key x) (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (or (in (key (r1 x)) (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (key (l x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (or (in (key (l x)) (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority x) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (or (in (priority x) (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (or (in (priority (r1 x)) (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority (l x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (or (in (priority (l x)) (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x)))))))
(assert (iff (in k (union (keys' (l' x)) (singleton (key x)))) (or (in k (keys' (l' x))) (in k (singleton (key x))))))
(assert (iff (in p (union (keys' (l' x)) (singleton (key x)))) (or (in p (keys' (l' x))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (keys' (l' x)) (singleton (key x)))) (or (in w1 (keys' (l' x))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (keys' (l' x)) (singleton (key x)))) (or (in w2 (keys' (l' x))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (keys' (l' x)) (singleton (key x)))) (or (in (key x) (keys' (l' x))) (in (key x) (singleton (key x))))))
(assert (iff (in (key (r1 x)) (union (keys' (l' x)) (singleton (key x)))) (or (in (key (r1 x)) (keys' (l' x))) (in (key (r1 x)) (singleton (key x))))))
(assert (iff (in (key (l x)) (union (keys' (l' x)) (singleton (key x)))) (or (in (key (l x)) (keys' (l' x))) (in (key (l x)) (singleton (key x))))))
(assert (iff (in (priority x) (union (keys' (l' x)) (singleton (key x)))) (or (in (priority x) (keys' (l' x))) (in (priority x) (singleton (key x))))))
(assert (iff (in (priority (r1 x)) (union (keys' (l' x)) (singleton (key x)))) (or (in (priority (r1 x)) (keys' (l' x))) (in (priority (r1 x)) (singleton (key x))))))
(assert (iff (in (priority (l x)) (union (keys' (l' x)) (singleton (key x)))) (or (in (priority (l x)) (keys' (l' x))) (in (priority (l x)) (singleton (key x))))))
(assert (iff (in k (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (or (in k (keys' (r' (r1 x)))) (in k (singleton (key (r1 x)))))))
(assert (iff (in p (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (or (in p (keys' (r' (r1 x)))) (in p (singleton (key (r1 x)))))))
(assert (iff (in w1 (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (or (in w1 (keys' (r' (r1 x)))) (in w1 (singleton (key (r1 x)))))))
(assert (iff (in w2 (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (or (in w2 (keys' (r' (r1 x)))) (in w2 (singleton (key (r1 x)))))))
(assert (iff (in (key x) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (or (in (key x) (keys' (r' (r1 x)))) (in (key x) (singleton (key (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (or (in (key (r1 x)) (keys' (r' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (key (l x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (or (in (key (l x)) (keys' (r' (r1 x)))) (in (key (l x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority x) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (or (in (priority x) (keys' (r' (r1 x)))) (in (priority x) (singleton (key (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (or (in (priority (r1 x)) (keys' (r' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority (l x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (or (in (priority (l x)) (keys' (r' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x)))))))
(assert (iff (in k (union (keys' (r' x)) (singleton (key x)))) (or (in k (keys' (r' x))) (in k (singleton (key x))))))
(assert (iff (in p (union (keys' (r' x)) (singleton (key x)))) (or (in p (keys' (r' x))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (keys' (r' x)) (singleton (key x)))) (or (in w1 (keys' (r' x))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (keys' (r' x)) (singleton (key x)))) (or (in w2 (keys' (r' x))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (keys' (r' x)) (singleton (key x)))) (or (in (key x) (keys' (r' x))) (in (key x) (singleton (key x))))))
(assert (iff (in (key (r1 x)) (union (keys' (r' x)) (singleton (key x)))) (or (in (key (r1 x)) (keys' (r' x))) (in (key (r1 x)) (singleton (key x))))))
(assert (iff (in (key (l x)) (union (keys' (r' x)) (singleton (key x)))) (or (in (key (l x)) (keys' (r' x))) (in (key (l x)) (singleton (key x))))))
(assert (iff (in (priority x) (union (keys' (r' x)) (singleton (key x)))) (or (in (priority x) (keys' (r' x))) (in (priority x) (singleton (key x))))))
(assert (iff (in (priority (r1 x)) (union (keys' (r' x)) (singleton (key x)))) (or (in (priority (r1 x)) (keys' (r' x))) (in (priority (r1 x)) (singleton (key x))))))
(assert (iff (in (priority (l x)) (union (keys' (r' x)) (singleton (key x)))) (or (in (priority (l x)) (keys' (r' x))) (in (priority (l x)) (singleton (key x))))))
(assert (iff (in k (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (or (in k (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (in k (singleton (key (r1 x)))))))
(assert (iff (in p (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (or (in p (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (in p (singleton (key (r1 x)))))))
(assert (iff (in w1 (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (or (in w1 (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (in w1 (singleton (key (r1 x)))))))
(assert (iff (in w2 (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (or (in w2 (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (in w2 (singleton (key (r1 x)))))))
(assert (iff (in (key x) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (or (in (key x) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (in (key x) (singleton (key (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (or (in (key (r1 x)) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (in (key (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (key (l x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (or (in (key (l x)) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (in (key (l x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority x) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (or (in (priority x) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (in (priority x) (singleton (key (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (or (in (priority (r1 x)) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (in (priority (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority (l x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (or (in (priority (l x)) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (in (priority (l x)) (singleton (key (r1 x)))))))
(assert (iff (in k (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (or (in k (union (keys' (l' x)) (keys' (r' x)))) (in k (singleton (key x))))))
(assert (iff (in p (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (or (in p (union (keys' (l' x)) (keys' (r' x)))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (or (in w1 (union (keys' (l' x)) (keys' (r' x)))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (or (in w2 (union (keys' (l' x)) (keys' (r' x)))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (or (in (key x) (union (keys' (l' x)) (keys' (r' x)))) (in (key x) (singleton (key x))))))
(assert (iff (in (key (r1 x)) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (or (in (key (r1 x)) (union (keys' (l' x)) (keys' (r' x)))) (in (key (r1 x)) (singleton (key x))))))
(assert (iff (in (key (l x)) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (or (in (key (l x)) (union (keys' (l' x)) (keys' (r' x)))) (in (key (l x)) (singleton (key x))))))
(assert (iff (in (priority x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (or (in (priority x) (union (keys' (l' x)) (keys' (r' x)))) (in (priority x) (singleton (key x))))))
(assert (iff (in (priority (r1 x)) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (or (in (priority (r1 x)) (union (keys' (l' x)) (keys' (r' x)))) (in (priority (r1 x)) (singleton (key x))))))
(assert (iff (in (priority (l x)) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (or (in (priority (l x)) (union (keys' (l' x)) (keys' (r' x)))) (in (priority (l x)) (singleton (key x))))))
(assert (iff (in k (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (or (in k (keys' (l' (r1 x)))) (in k (keys' (r' (r1 x)))))))
(assert (iff (in p (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (or (in p (keys' (l' (r1 x)))) (in p (keys' (r' (r1 x)))))))
(assert (iff (in w1 (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (or (in w1 (keys' (l' (r1 x)))) (in w1 (keys' (r' (r1 x)))))))
(assert (iff (in w2 (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (or (in w2 (keys' (l' (r1 x)))) (in w2 (keys' (r' (r1 x)))))))
(assert (iff (in (key x) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (or (in (key x) (keys' (l' (r1 x)))) (in (key x) (keys' (r' (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (or (in (key (r1 x)) (keys' (l' (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x)))))))
(assert (iff (in (key (l x)) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (or (in (key (l x)) (keys' (l' (r1 x)))) (in (key (l x)) (keys' (r' (r1 x)))))))
(assert (iff (in (priority x) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (or (in (priority x) (keys' (l' (r1 x)))) (in (priority x) (keys' (r' (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (or (in (priority (r1 x)) (keys' (l' (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x)))))))
(assert (iff (in (priority (l x)) (union (keys' (l' (r1 x))) (keys' (r' (r1 x))))) (or (in (priority (l x)) (keys' (l' (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x)))))))
(assert (iff (in k (union (keys' (l' x)) (keys' (r' x)))) (or (in k (keys' (l' x))) (in k (keys' (r' x))))))
(assert (iff (in p (union (keys' (l' x)) (keys' (r' x)))) (or (in p (keys' (l' x))) (in p (keys' (r' x))))))
(assert (iff (in w1 (union (keys' (l' x)) (keys' (r' x)))) (or (in w1 (keys' (l' x))) (in w1 (keys' (r' x))))))
(assert (iff (in w2 (union (keys' (l' x)) (keys' (r' x)))) (or (in w2 (keys' (l' x))) (in w2 (keys' (r' x))))))
(assert (iff (in (key x) (union (keys' (l' x)) (keys' (r' x)))) (or (in (key x) (keys' (l' x))) (in (key x) (keys' (r' x))))))
(assert (iff (in (key (r1 x)) (union (keys' (l' x)) (keys' (r' x)))) (or (in (key (r1 x)) (keys' (l' x))) (in (key (r1 x)) (keys' (r' x))))))
(assert (iff (in (key (l x)) (union (keys' (l' x)) (keys' (r' x)))) (or (in (key (l x)) (keys' (l' x))) (in (key (l x)) (keys' (r' x))))))
(assert (iff (in (priority x) (union (keys' (l' x)) (keys' (r' x)))) (or (in (priority x) (keys' (l' x))) (in (priority x) (keys' (r' x))))))
(assert (iff (in (priority (r1 x)) (union (keys' (l' x)) (keys' (r' x)))) (or (in (priority (r1 x)) (keys' (l' x))) (in (priority (r1 x)) (keys' (r' x))))))
(assert (iff (in (priority (l x)) (union (keys' (l' x)) (keys' (r' x)))) (or (in (priority (l x)) (keys' (l' x))) (in (priority (l x)) (keys' (r' x))))))
(assert (iff (in k (union (keys1 (l1 x)) (singleton (key x)))) (or (in k (keys1 (l1 x))) (in k (singleton (key x))))))
(assert (iff (in p (union (keys1 (l1 x)) (singleton (key x)))) (or (in p (keys1 (l1 x))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (keys1 (l1 x)) (singleton (key x)))) (or (in w1 (keys1 (l1 x))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (keys1 (l1 x)) (singleton (key x)))) (or (in w2 (keys1 (l1 x))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (keys1 (l1 x)) (singleton (key x)))) (or (in (key x) (keys1 (l1 x))) (in (key x) (singleton (key x))))))
(assert (iff (in (key (r1 x)) (union (keys1 (l1 x)) (singleton (key x)))) (or (in (key (r1 x)) (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x))))))
(assert (iff (in (key (l x)) (union (keys1 (l1 x)) (singleton (key x)))) (or (in (key (l x)) (keys1 (l1 x))) (in (key (l x)) (singleton (key x))))))
(assert (iff (in (priority x) (union (keys1 (l1 x)) (singleton (key x)))) (or (in (priority x) (keys1 (l1 x))) (in (priority x) (singleton (key x))))))
(assert (iff (in (priority (r1 x)) (union (keys1 (l1 x)) (singleton (key x)))) (or (in (priority (r1 x)) (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x))))))
(assert (iff (in (priority (l x)) (union (keys1 (l1 x)) (singleton (key x)))) (or (in (priority (l x)) (keys1 (l1 x))) (in (priority (l x)) (singleton (key x))))))
(assert (iff (in k (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (or (in k (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x)))))))
(assert (iff (in p (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (or (in p (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x)))))))
(assert (iff (in w1 (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (or (in w1 (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x)))))))
(assert (iff (in w2 (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (or (in w2 (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x)))))))
(assert (iff (in (key x) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (or (in (key x) (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (or (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (key (l x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (or (in (key (l x)) (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority x) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (or (in (priority x) (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (or (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority (l x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (or (in (priority (l x)) (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x)))))))
(assert (iff (in k (union (keys1 (r1 x)) (singleton (key x)))) (or (in k (keys1 (r1 x))) (in k (singleton (key x))))))
(assert (iff (in p (union (keys1 (r1 x)) (singleton (key x)))) (or (in p (keys1 (r1 x))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (keys1 (r1 x)) (singleton (key x)))) (or (in w1 (keys1 (r1 x))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (keys1 (r1 x)) (singleton (key x)))) (or (in w2 (keys1 (r1 x))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (keys1 (r1 x)) (singleton (key x)))) (or (in (key x) (keys1 (r1 x))) (in (key x) (singleton (key x))))))
(assert (iff (in (key (r1 x)) (union (keys1 (r1 x)) (singleton (key x)))) (or (in (key (r1 x)) (keys1 (r1 x))) (in (key (r1 x)) (singleton (key x))))))
(assert (iff (in (key (l x)) (union (keys1 (r1 x)) (singleton (key x)))) (or (in (key (l x)) (keys1 (r1 x))) (in (key (l x)) (singleton (key x))))))
(assert (iff (in (priority x) (union (keys1 (r1 x)) (singleton (key x)))) (or (in (priority x) (keys1 (r1 x))) (in (priority x) (singleton (key x))))))
(assert (iff (in (priority (r1 x)) (union (keys1 (r1 x)) (singleton (key x)))) (or (in (priority (r1 x)) (keys1 (r1 x))) (in (priority (r1 x)) (singleton (key x))))))
(assert (iff (in (priority (l x)) (union (keys1 (r1 x)) (singleton (key x)))) (or (in (priority (l x)) (keys1 (r1 x))) (in (priority (l x)) (singleton (key x))))))
(assert (iff (in k (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (or (in k (keys1 (r1 (r1 x)))) (in k (singleton (key (r1 x)))))))
(assert (iff (in p (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (or (in p (keys1 (r1 (r1 x)))) (in p (singleton (key (r1 x)))))))
(assert (iff (in w1 (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (or (in w1 (keys1 (r1 (r1 x)))) (in w1 (singleton (key (r1 x)))))))
(assert (iff (in w2 (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (or (in w2 (keys1 (r1 (r1 x)))) (in w2 (singleton (key (r1 x)))))))
(assert (iff (in (key x) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (or (in (key x) (keys1 (r1 (r1 x)))) (in (key x) (singleton (key (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (or (in (key (r1 x)) (keys1 (r1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (key (l x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (or (in (key (l x)) (keys1 (r1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority x) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (or (in (priority x) (keys1 (r1 (r1 x)))) (in (priority x) (singleton (key (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (or (in (priority (r1 x)) (keys1 (r1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority (l x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (or (in (priority (l x)) (keys1 (r1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x)))))))
(assert (iff (in k (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (or (in k (union (keys1 (l1 x)) (keys1 (r1 x)))) (in k (singleton (key x))))))
(assert (iff (in p (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (or (in p (union (keys1 (l1 x)) (keys1 (r1 x)))) (in p (singleton (key x))))))
(assert (iff (in w1 (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (or (in w1 (union (keys1 (l1 x)) (keys1 (r1 x)))) (in w1 (singleton (key x))))))
(assert (iff (in w2 (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (or (in w2 (union (keys1 (l1 x)) (keys1 (r1 x)))) (in w2 (singleton (key x))))))
(assert (iff (in (key x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (or (in (key x) (union (keys1 (l1 x)) (keys1 (r1 x)))) (in (key x) (singleton (key x))))))
(assert (iff (in (key (r1 x)) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (or (in (key (r1 x)) (union (keys1 (l1 x)) (keys1 (r1 x)))) (in (key (r1 x)) (singleton (key x))))))
(assert (iff (in (key (l x)) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (or (in (key (l x)) (union (keys1 (l1 x)) (keys1 (r1 x)))) (in (key (l x)) (singleton (key x))))))
(assert (iff (in (priority x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (or (in (priority x) (union (keys1 (l1 x)) (keys1 (r1 x)))) (in (priority x) (singleton (key x))))))
(assert (iff (in (priority (r1 x)) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (or (in (priority (r1 x)) (union (keys1 (l1 x)) (keys1 (r1 x)))) (in (priority (r1 x)) (singleton (key x))))))
(assert (iff (in (priority (l x)) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (or (in (priority (l x)) (union (keys1 (l1 x)) (keys1 (r1 x)))) (in (priority (l x)) (singleton (key x))))))
(assert (iff (in k (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (or (in k (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (in k (singleton (key (r1 x)))))))
(assert (iff (in p (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (or (in p (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (in p (singleton (key (r1 x)))))))
(assert (iff (in w1 (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (or (in w1 (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (in w1 (singleton (key (r1 x)))))))
(assert (iff (in w2 (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (or (in w2 (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (in w2 (singleton (key (r1 x)))))))
(assert (iff (in (key x) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (or (in (key x) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (in (key x) (singleton (key (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (or (in (key (r1 x)) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (in (key (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (key (l x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (or (in (key (l x)) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (in (key (l x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority x) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (or (in (priority x) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (in (priority x) (singleton (key (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (or (in (priority (r1 x)) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (in (priority (r1 x)) (singleton (key (r1 x)))))))
(assert (iff (in (priority (l x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (or (in (priority (l x)) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (in (priority (l x)) (singleton (key (r1 x)))))))
(assert (iff (in k (union (keys1 (l1 x)) (keys1 (r1 x)))) (or (in k (keys1 (l1 x))) (in k (keys1 (r1 x))))))
(assert (iff (in p (union (keys1 (l1 x)) (keys1 (r1 x)))) (or (in p (keys1 (l1 x))) (in p (keys1 (r1 x))))))
(assert (iff (in w1 (union (keys1 (l1 x)) (keys1 (r1 x)))) (or (in w1 (keys1 (l1 x))) (in w1 (keys1 (r1 x))))))
(assert (iff (in w2 (union (keys1 (l1 x)) (keys1 (r1 x)))) (or (in w2 (keys1 (l1 x))) (in w2 (keys1 (r1 x))))))
(assert (iff (in (key x) (union (keys1 (l1 x)) (keys1 (r1 x)))) (or (in (key x) (keys1 (l1 x))) (in (key x) (keys1 (r1 x))))))
(assert (iff (in (key (r1 x)) (union (keys1 (l1 x)) (keys1 (r1 x)))) (or (in (key (r1 x)) (keys1 (l1 x))) (in (key (r1 x)) (keys1 (r1 x))))))
(assert (iff (in (key (l x)) (union (keys1 (l1 x)) (keys1 (r1 x)))) (or (in (key (l x)) (keys1 (l1 x))) (in (key (l x)) (keys1 (r1 x))))))
(assert (iff (in (priority x) (union (keys1 (l1 x)) (keys1 (r1 x)))) (or (in (priority x) (keys1 (l1 x))) (in (priority x) (keys1 (r1 x))))))
(assert (iff (in (priority (r1 x)) (union (keys1 (l1 x)) (keys1 (r1 x)))) (or (in (priority (r1 x)) (keys1 (l1 x))) (in (priority (r1 x)) (keys1 (r1 x))))))
(assert (iff (in (priority (l x)) (union (keys1 (l1 x)) (keys1 (r1 x)))) (or (in (priority (l x)) (keys1 (l1 x))) (in (priority (l x)) (keys1 (r1 x))))))
(assert (iff (in k (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (or (in k (keys1 (l1 (r1 x)))) (in k (keys1 (r1 (r1 x)))))))
(assert (iff (in p (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (or (in p (keys1 (l1 (r1 x)))) (in p (keys1 (r1 (r1 x)))))))
(assert (iff (in w1 (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (or (in w1 (keys1 (l1 (r1 x)))) (in w1 (keys1 (r1 (r1 x)))))))
(assert (iff (in w2 (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (or (in w2 (keys1 (l1 (r1 x)))) (in w2 (keys1 (r1 (r1 x)))))))
(assert (iff (in (key x) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (or (in (key x) (keys1 (l1 (r1 x)))) (in (key x) (keys1 (r1 (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (or (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x)))))))
(assert (iff (in (key (l x)) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (or (in (key (l x)) (keys1 (l1 (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x)))))))
(assert (iff (in (priority x) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (or (in (priority x) (keys1 (l1 (r1 x)))) (in (priority x) (keys1 (r1 (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (or (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x)))))))
(assert (iff (in (priority (l x)) (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x))))) (or (in (priority (l x)) (keys1 (l1 (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x)))))))
(assert (iff (in k (union (priorities (l x)) (singleton (priority x)))) (or (in k (priorities (l x))) (in k (singleton (priority x))))))
(assert (iff (in p (union (priorities (l x)) (singleton (priority x)))) (or (in p (priorities (l x))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (priorities (l x)) (singleton (priority x)))) (or (in w1 (priorities (l x))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (priorities (l x)) (singleton (priority x)))) (or (in w2 (priorities (l x))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (priorities (l x)) (singleton (priority x)))) (or (in (key x) (priorities (l x))) (in (key x) (singleton (priority x))))))
(assert (iff (in (key (r1 x)) (union (priorities (l x)) (singleton (priority x)))) (or (in (key (r1 x)) (priorities (l x))) (in (key (r1 x)) (singleton (priority x))))))
(assert (iff (in (key (l x)) (union (priorities (l x)) (singleton (priority x)))) (or (in (key (l x)) (priorities (l x))) (in (key (l x)) (singleton (priority x))))))
(assert (iff (in (priority x) (union (priorities (l x)) (singleton (priority x)))) (or (in (priority x) (priorities (l x))) (in (priority x) (singleton (priority x))))))
(assert (iff (in (priority (r1 x)) (union (priorities (l x)) (singleton (priority x)))) (or (in (priority (r1 x)) (priorities (l x))) (in (priority (r1 x)) (singleton (priority x))))))
(assert (iff (in (priority (l x)) (union (priorities (l x)) (singleton (priority x)))) (or (in (priority (l x)) (priorities (l x))) (in (priority (l x)) (singleton (priority x))))))
(assert (iff (in k (union (priorities (r x)) (singleton (priority x)))) (or (in k (priorities (r x))) (in k (singleton (priority x))))))
(assert (iff (in p (union (priorities (r x)) (singleton (priority x)))) (or (in p (priorities (r x))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (priorities (r x)) (singleton (priority x)))) (or (in w1 (priorities (r x))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (priorities (r x)) (singleton (priority x)))) (or (in w2 (priorities (r x))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (priorities (r x)) (singleton (priority x)))) (or (in (key x) (priorities (r x))) (in (key x) (singleton (priority x))))))
(assert (iff (in (key (r1 x)) (union (priorities (r x)) (singleton (priority x)))) (or (in (key (r1 x)) (priorities (r x))) (in (key (r1 x)) (singleton (priority x))))))
(assert (iff (in (key (l x)) (union (priorities (r x)) (singleton (priority x)))) (or (in (key (l x)) (priorities (r x))) (in (key (l x)) (singleton (priority x))))))
(assert (iff (in (priority x) (union (priorities (r x)) (singleton (priority x)))) (or (in (priority x) (priorities (r x))) (in (priority x) (singleton (priority x))))))
(assert (iff (in (priority (r1 x)) (union (priorities (r x)) (singleton (priority x)))) (or (in (priority (r1 x)) (priorities (r x))) (in (priority (r1 x)) (singleton (priority x))))))
(assert (iff (in (priority (l x)) (union (priorities (r x)) (singleton (priority x)))) (or (in (priority (l x)) (priorities (r x))) (in (priority (l x)) (singleton (priority x))))))
(assert (iff (in k (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in k (union (priorities (l x)) (priorities (r x)))) (in k (singleton (priority x))))))
(assert (iff (in p (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in p (union (priorities (l x)) (priorities (r x)))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in w1 (union (priorities (l x)) (priorities (r x)))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in w2 (union (priorities (l x)) (priorities (r x)))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in (key x) (union (priorities (l x)) (priorities (r x)))) (in (key x) (singleton (priority x))))))
(assert (iff (in (key (r1 x)) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in (key (r1 x)) (union (priorities (l x)) (priorities (r x)))) (in (key (r1 x)) (singleton (priority x))))))
(assert (iff (in (key (l x)) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in (key (l x)) (union (priorities (l x)) (priorities (r x)))) (in (key (l x)) (singleton (priority x))))))
(assert (iff (in (priority x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in (priority x) (union (priorities (l x)) (priorities (r x)))) (in (priority x) (singleton (priority x))))))
(assert (iff (in (priority (r1 x)) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in (priority (r1 x)) (union (priorities (l x)) (priorities (r x)))) (in (priority (r1 x)) (singleton (priority x))))))
(assert (iff (in (priority (l x)) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (or (in (priority (l x)) (union (priorities (l x)) (priorities (r x)))) (in (priority (l x)) (singleton (priority x))))))
(assert (iff (in k (union (priorities (l x)) (priorities (r x)))) (or (in k (priorities (l x))) (in k (priorities (r x))))))
(assert (iff (in p (union (priorities (l x)) (priorities (r x)))) (or (in p (priorities (l x))) (in p (priorities (r x))))))
(assert (iff (in w1 (union (priorities (l x)) (priorities (r x)))) (or (in w1 (priorities (l x))) (in w1 (priorities (r x))))))
(assert (iff (in w2 (union (priorities (l x)) (priorities (r x)))) (or (in w2 (priorities (l x))) (in w2 (priorities (r x))))))
(assert (iff (in (key x) (union (priorities (l x)) (priorities (r x)))) (or (in (key x) (priorities (l x))) (in (key x) (priorities (r x))))))
(assert (iff (in (key (r1 x)) (union (priorities (l x)) (priorities (r x)))) (or (in (key (r1 x)) (priorities (l x))) (in (key (r1 x)) (priorities (r x))))))
(assert (iff (in (key (l x)) (union (priorities (l x)) (priorities (r x)))) (or (in (key (l x)) (priorities (l x))) (in (key (l x)) (priorities (r x))))))
(assert (iff (in (priority x) (union (priorities (l x)) (priorities (r x)))) (or (in (priority x) (priorities (l x))) (in (priority x) (priorities (r x))))))
(assert (iff (in (priority (r1 x)) (union (priorities (l x)) (priorities (r x)))) (or (in (priority (r1 x)) (priorities (l x))) (in (priority (r1 x)) (priorities (r x))))))
(assert (iff (in (priority (l x)) (union (priorities (l x)) (priorities (r x)))) (or (in (priority (l x)) (priorities (l x))) (in (priority (l x)) (priorities (r x))))))
(assert (iff (in k (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (or (in k (priorities' (l' (r1 x)))) (in k (singleton (priority (r1 x)))))))
(assert (iff (in p (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (or (in p (priorities' (l' (r1 x)))) (in p (singleton (priority (r1 x)))))))
(assert (iff (in w1 (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (or (in w1 (priorities' (l' (r1 x)))) (in w1 (singleton (priority (r1 x)))))))
(assert (iff (in w2 (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (or (in w2 (priorities' (l' (r1 x)))) (in w2 (singleton (priority (r1 x)))))))
(assert (iff (in (key x) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (or (in (key x) (priorities' (l' (r1 x)))) (in (key x) (singleton (priority (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (or (in (key (r1 x)) (priorities' (l' (r1 x)))) (in (key (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (key (l x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (or (in (key (l x)) (priorities' (l' (r1 x)))) (in (key (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority x) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (or (in (priority x) (priorities' (l' (r1 x)))) (in (priority x) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (or (in (priority (r1 x)) (priorities' (l' (r1 x)))) (in (priority (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (l x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (or (in (priority (l x)) (priorities' (l' (r1 x)))) (in (priority (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in k (union (priorities' (l' x)) (singleton (priority x)))) (or (in k (priorities' (l' x))) (in k (singleton (priority x))))))
(assert (iff (in p (union (priorities' (l' x)) (singleton (priority x)))) (or (in p (priorities' (l' x))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (priorities' (l' x)) (singleton (priority x)))) (or (in w1 (priorities' (l' x))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (priorities' (l' x)) (singleton (priority x)))) (or (in w2 (priorities' (l' x))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (priorities' (l' x)) (singleton (priority x)))) (or (in (key x) (priorities' (l' x))) (in (key x) (singleton (priority x))))))
(assert (iff (in (key (r1 x)) (union (priorities' (l' x)) (singleton (priority x)))) (or (in (key (r1 x)) (priorities' (l' x))) (in (key (r1 x)) (singleton (priority x))))))
(assert (iff (in (key (l x)) (union (priorities' (l' x)) (singleton (priority x)))) (or (in (key (l x)) (priorities' (l' x))) (in (key (l x)) (singleton (priority x))))))
(assert (iff (in (priority x) (union (priorities' (l' x)) (singleton (priority x)))) (or (in (priority x) (priorities' (l' x))) (in (priority x) (singleton (priority x))))))
(assert (iff (in (priority (r1 x)) (union (priorities' (l' x)) (singleton (priority x)))) (or (in (priority (r1 x)) (priorities' (l' x))) (in (priority (r1 x)) (singleton (priority x))))))
(assert (iff (in (priority (l x)) (union (priorities' (l' x)) (singleton (priority x)))) (or (in (priority (l x)) (priorities' (l' x))) (in (priority (l x)) (singleton (priority x))))))
(assert (iff (in k (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (or (in k (priorities' (r' (r1 x)))) (in k (singleton (priority (r1 x)))))))
(assert (iff (in p (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (or (in p (priorities' (r' (r1 x)))) (in p (singleton (priority (r1 x)))))))
(assert (iff (in w1 (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (or (in w1 (priorities' (r' (r1 x)))) (in w1 (singleton (priority (r1 x)))))))
(assert (iff (in w2 (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (or (in w2 (priorities' (r' (r1 x)))) (in w2 (singleton (priority (r1 x)))))))
(assert (iff (in (key x) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (or (in (key x) (priorities' (r' (r1 x)))) (in (key x) (singleton (priority (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (or (in (key (r1 x)) (priorities' (r' (r1 x)))) (in (key (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (key (l x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (or (in (key (l x)) (priorities' (r' (r1 x)))) (in (key (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority x) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (or (in (priority x) (priorities' (r' (r1 x)))) (in (priority x) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (or (in (priority (r1 x)) (priorities' (r' (r1 x)))) (in (priority (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (l x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (or (in (priority (l x)) (priorities' (r' (r1 x)))) (in (priority (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in k (union (priorities' (r' x)) (singleton (priority x)))) (or (in k (priorities' (r' x))) (in k (singleton (priority x))))))
(assert (iff (in p (union (priorities' (r' x)) (singleton (priority x)))) (or (in p (priorities' (r' x))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (priorities' (r' x)) (singleton (priority x)))) (or (in w1 (priorities' (r' x))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (priorities' (r' x)) (singleton (priority x)))) (or (in w2 (priorities' (r' x))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (priorities' (r' x)) (singleton (priority x)))) (or (in (key x) (priorities' (r' x))) (in (key x) (singleton (priority x))))))
(assert (iff (in (key (r1 x)) (union (priorities' (r' x)) (singleton (priority x)))) (or (in (key (r1 x)) (priorities' (r' x))) (in (key (r1 x)) (singleton (priority x))))))
(assert (iff (in (key (l x)) (union (priorities' (r' x)) (singleton (priority x)))) (or (in (key (l x)) (priorities' (r' x))) (in (key (l x)) (singleton (priority x))))))
(assert (iff (in (priority x) (union (priorities' (r' x)) (singleton (priority x)))) (or (in (priority x) (priorities' (r' x))) (in (priority x) (singleton (priority x))))))
(assert (iff (in (priority (r1 x)) (union (priorities' (r' x)) (singleton (priority x)))) (or (in (priority (r1 x)) (priorities' (r' x))) (in (priority (r1 x)) (singleton (priority x))))))
(assert (iff (in (priority (l x)) (union (priorities' (r' x)) (singleton (priority x)))) (or (in (priority (l x)) (priorities' (r' x))) (in (priority (l x)) (singleton (priority x))))))
(assert (iff (in k (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (or (in k (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (in k (singleton (priority (r1 x)))))))
(assert (iff (in p (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (or (in p (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (in p (singleton (priority (r1 x)))))))
(assert (iff (in w1 (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (or (in w1 (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (in w1 (singleton (priority (r1 x)))))))
(assert (iff (in w2 (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (or (in w2 (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (in w2 (singleton (priority (r1 x)))))))
(assert (iff (in (key x) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (or (in (key x) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (in (key x) (singleton (priority (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (or (in (key (r1 x)) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (in (key (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (key (l x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (or (in (key (l x)) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (in (key (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority x) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (or (in (priority x) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (in (priority x) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (or (in (priority (r1 x)) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (in (priority (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (l x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (or (in (priority (l x)) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (in (priority (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in k (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (or (in k (union (priorities' (l' x)) (priorities' (r' x)))) (in k (singleton (priority x))))))
(assert (iff (in p (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (or (in p (union (priorities' (l' x)) (priorities' (r' x)))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (or (in w1 (union (priorities' (l' x)) (priorities' (r' x)))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (or (in w2 (union (priorities' (l' x)) (priorities' (r' x)))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (or (in (key x) (union (priorities' (l' x)) (priorities' (r' x)))) (in (key x) (singleton (priority x))))))
(assert (iff (in (key (r1 x)) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (or (in (key (r1 x)) (union (priorities' (l' x)) (priorities' (r' x)))) (in (key (r1 x)) (singleton (priority x))))))
(assert (iff (in (key (l x)) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (or (in (key (l x)) (union (priorities' (l' x)) (priorities' (r' x)))) (in (key (l x)) (singleton (priority x))))))
(assert (iff (in (priority x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (or (in (priority x) (union (priorities' (l' x)) (priorities' (r' x)))) (in (priority x) (singleton (priority x))))))
(assert (iff (in (priority (r1 x)) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (or (in (priority (r1 x)) (union (priorities' (l' x)) (priorities' (r' x)))) (in (priority (r1 x)) (singleton (priority x))))))
(assert (iff (in (priority (l x)) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (or (in (priority (l x)) (union (priorities' (l' x)) (priorities' (r' x)))) (in (priority (l x)) (singleton (priority x))))))
(assert (iff (in k (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (or (in k (priorities' (l' (r1 x)))) (in k (priorities' (r' (r1 x)))))))
(assert (iff (in p (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (or (in p (priorities' (l' (r1 x)))) (in p (priorities' (r' (r1 x)))))))
(assert (iff (in w1 (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (or (in w1 (priorities' (l' (r1 x)))) (in w1 (priorities' (r' (r1 x)))))))
(assert (iff (in w2 (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (or (in w2 (priorities' (l' (r1 x)))) (in w2 (priorities' (r' (r1 x)))))))
(assert (iff (in (key x) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (or (in (key x) (priorities' (l' (r1 x)))) (in (key x) (priorities' (r' (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (or (in (key (r1 x)) (priorities' (l' (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x)))))))
(assert (iff (in (key (l x)) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (or (in (key (l x)) (priorities' (l' (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x)))))))
(assert (iff (in (priority x) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (or (in (priority x) (priorities' (l' (r1 x)))) (in (priority x) (priorities' (r' (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (or (in (priority (r1 x)) (priorities' (l' (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x)))))))
(assert (iff (in (priority (l x)) (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x))))) (or (in (priority (l x)) (priorities' (l' (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x)))))))
(assert (iff (in k (union (priorities' (l' x)) (priorities' (r' x)))) (or (in k (priorities' (l' x))) (in k (priorities' (r' x))))))
(assert (iff (in p (union (priorities' (l' x)) (priorities' (r' x)))) (or (in p (priorities' (l' x))) (in p (priorities' (r' x))))))
(assert (iff (in w1 (union (priorities' (l' x)) (priorities' (r' x)))) (or (in w1 (priorities' (l' x))) (in w1 (priorities' (r' x))))))
(assert (iff (in w2 (union (priorities' (l' x)) (priorities' (r' x)))) (or (in w2 (priorities' (l' x))) (in w2 (priorities' (r' x))))))
(assert (iff (in (key x) (union (priorities' (l' x)) (priorities' (r' x)))) (or (in (key x) (priorities' (l' x))) (in (key x) (priorities' (r' x))))))
(assert (iff (in (key (r1 x)) (union (priorities' (l' x)) (priorities' (r' x)))) (or (in (key (r1 x)) (priorities' (l' x))) (in (key (r1 x)) (priorities' (r' x))))))
(assert (iff (in (key (l x)) (union (priorities' (l' x)) (priorities' (r' x)))) (or (in (key (l x)) (priorities' (l' x))) (in (key (l x)) (priorities' (r' x))))))
(assert (iff (in (priority x) (union (priorities' (l' x)) (priorities' (r' x)))) (or (in (priority x) (priorities' (l' x))) (in (priority x) (priorities' (r' x))))))
(assert (iff (in (priority (r1 x)) (union (priorities' (l' x)) (priorities' (r' x)))) (or (in (priority (r1 x)) (priorities' (l' x))) (in (priority (r1 x)) (priorities' (r' x))))))
(assert (iff (in (priority (l x)) (union (priorities' (l' x)) (priorities' (r' x)))) (or (in (priority (l x)) (priorities' (l' x))) (in (priority (l x)) (priorities' (r' x))))))
(assert (iff (in k (union (priorities1 (l1 x)) (singleton (priority x)))) (or (in k (priorities1 (l1 x))) (in k (singleton (priority x))))))
(assert (iff (in p (union (priorities1 (l1 x)) (singleton (priority x)))) (or (in p (priorities1 (l1 x))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (priorities1 (l1 x)) (singleton (priority x)))) (or (in w1 (priorities1 (l1 x))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (priorities1 (l1 x)) (singleton (priority x)))) (or (in w2 (priorities1 (l1 x))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (priorities1 (l1 x)) (singleton (priority x)))) (or (in (key x) (priorities1 (l1 x))) (in (key x) (singleton (priority x))))))
(assert (iff (in (key (r1 x)) (union (priorities1 (l1 x)) (singleton (priority x)))) (or (in (key (r1 x)) (priorities1 (l1 x))) (in (key (r1 x)) (singleton (priority x))))))
(assert (iff (in (key (l x)) (union (priorities1 (l1 x)) (singleton (priority x)))) (or (in (key (l x)) (priorities1 (l1 x))) (in (key (l x)) (singleton (priority x))))))
(assert (iff (in (priority x) (union (priorities1 (l1 x)) (singleton (priority x)))) (or (in (priority x) (priorities1 (l1 x))) (in (priority x) (singleton (priority x))))))
(assert (iff (in (priority (r1 x)) (union (priorities1 (l1 x)) (singleton (priority x)))) (or (in (priority (r1 x)) (priorities1 (l1 x))) (in (priority (r1 x)) (singleton (priority x))))))
(assert (iff (in (priority (l x)) (union (priorities1 (l1 x)) (singleton (priority x)))) (or (in (priority (l x)) (priorities1 (l1 x))) (in (priority (l x)) (singleton (priority x))))))
(assert (iff (in k (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (or (in k (priorities1 (l1 (r1 x)))) (in k (singleton (priority (r1 x)))))))
(assert (iff (in p (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (or (in p (priorities1 (l1 (r1 x)))) (in p (singleton (priority (r1 x)))))))
(assert (iff (in w1 (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (or (in w1 (priorities1 (l1 (r1 x)))) (in w1 (singleton (priority (r1 x)))))))
(assert (iff (in w2 (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (or (in w2 (priorities1 (l1 (r1 x)))) (in w2 (singleton (priority (r1 x)))))))
(assert (iff (in (key x) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (or (in (key x) (priorities1 (l1 (r1 x)))) (in (key x) (singleton (priority (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (or (in (key (r1 x)) (priorities1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (key (l x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (or (in (key (l x)) (priorities1 (l1 (r1 x)))) (in (key (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority x) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (or (in (priority x) (priorities1 (l1 (r1 x)))) (in (priority x) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (or (in (priority (r1 x)) (priorities1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (l x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (or (in (priority (l x)) (priorities1 (l1 (r1 x)))) (in (priority (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in k (union (priorities1 (r1 x)) (singleton (priority x)))) (or (in k (priorities1 (r1 x))) (in k (singleton (priority x))))))
(assert (iff (in p (union (priorities1 (r1 x)) (singleton (priority x)))) (or (in p (priorities1 (r1 x))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (priorities1 (r1 x)) (singleton (priority x)))) (or (in w1 (priorities1 (r1 x))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (priorities1 (r1 x)) (singleton (priority x)))) (or (in w2 (priorities1 (r1 x))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (priorities1 (r1 x)) (singleton (priority x)))) (or (in (key x) (priorities1 (r1 x))) (in (key x) (singleton (priority x))))))
(assert (iff (in (key (r1 x)) (union (priorities1 (r1 x)) (singleton (priority x)))) (or (in (key (r1 x)) (priorities1 (r1 x))) (in (key (r1 x)) (singleton (priority x))))))
(assert (iff (in (key (l x)) (union (priorities1 (r1 x)) (singleton (priority x)))) (or (in (key (l x)) (priorities1 (r1 x))) (in (key (l x)) (singleton (priority x))))))
(assert (iff (in (priority x) (union (priorities1 (r1 x)) (singleton (priority x)))) (or (in (priority x) (priorities1 (r1 x))) (in (priority x) (singleton (priority x))))))
(assert (iff (in (priority (r1 x)) (union (priorities1 (r1 x)) (singleton (priority x)))) (or (in (priority (r1 x)) (priorities1 (r1 x))) (in (priority (r1 x)) (singleton (priority x))))))
(assert (iff (in (priority (l x)) (union (priorities1 (r1 x)) (singleton (priority x)))) (or (in (priority (l x)) (priorities1 (r1 x))) (in (priority (l x)) (singleton (priority x))))))
(assert (iff (in k (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (or (in k (priorities1 (r1 (r1 x)))) (in k (singleton (priority (r1 x)))))))
(assert (iff (in p (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (or (in p (priorities1 (r1 (r1 x)))) (in p (singleton (priority (r1 x)))))))
(assert (iff (in w1 (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (or (in w1 (priorities1 (r1 (r1 x)))) (in w1 (singleton (priority (r1 x)))))))
(assert (iff (in w2 (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (or (in w2 (priorities1 (r1 (r1 x)))) (in w2 (singleton (priority (r1 x)))))))
(assert (iff (in (key x) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (or (in (key x) (priorities1 (r1 (r1 x)))) (in (key x) (singleton (priority (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (or (in (key (r1 x)) (priorities1 (r1 (r1 x)))) (in (key (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (key (l x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (or (in (key (l x)) (priorities1 (r1 (r1 x)))) (in (key (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority x) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (or (in (priority x) (priorities1 (r1 (r1 x)))) (in (priority x) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (or (in (priority (r1 x)) (priorities1 (r1 (r1 x)))) (in (priority (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (l x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (or (in (priority (l x)) (priorities1 (r1 (r1 x)))) (in (priority (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in k (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (or (in k (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (in k (singleton (priority x))))))
(assert (iff (in p (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (or (in p (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (in p (singleton (priority x))))))
(assert (iff (in w1 (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (or (in w1 (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (in w1 (singleton (priority x))))))
(assert (iff (in w2 (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (or (in w2 (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (in w2 (singleton (priority x))))))
(assert (iff (in (key x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (or (in (key x) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (in (key x) (singleton (priority x))))))
(assert (iff (in (key (r1 x)) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (or (in (key (r1 x)) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (in (key (r1 x)) (singleton (priority x))))))
(assert (iff (in (key (l x)) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (or (in (key (l x)) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (in (key (l x)) (singleton (priority x))))))
(assert (iff (in (priority x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (or (in (priority x) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (in (priority x) (singleton (priority x))))))
(assert (iff (in (priority (r1 x)) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (or (in (priority (r1 x)) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (in (priority (r1 x)) (singleton (priority x))))))
(assert (iff (in (priority (l x)) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (or (in (priority (l x)) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (in (priority (l x)) (singleton (priority x))))))
(assert (iff (in k (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (or (in k (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (in k (singleton (priority (r1 x)))))))
(assert (iff (in p (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (or (in p (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (in p (singleton (priority (r1 x)))))))
(assert (iff (in w1 (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (or (in w1 (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (in w1 (singleton (priority (r1 x)))))))
(assert (iff (in w2 (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (or (in w2 (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (in w2 (singleton (priority (r1 x)))))))
(assert (iff (in (key x) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (or (in (key x) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (in (key x) (singleton (priority (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (or (in (key (r1 x)) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (in (key (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (key (l x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (or (in (key (l x)) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (in (key (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority x) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (or (in (priority x) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (in (priority x) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (or (in (priority (r1 x)) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (in (priority (r1 x)) (singleton (priority (r1 x)))))))
(assert (iff (in (priority (l x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (or (in (priority (l x)) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (in (priority (l x)) (singleton (priority (r1 x)))))))
(assert (iff (in k (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (or (in k (priorities1 (l1 x))) (in k (priorities1 (r1 x))))))
(assert (iff (in p (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (or (in p (priorities1 (l1 x))) (in p (priorities1 (r1 x))))))
(assert (iff (in w1 (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (or (in w1 (priorities1 (l1 x))) (in w1 (priorities1 (r1 x))))))
(assert (iff (in w2 (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (or (in w2 (priorities1 (l1 x))) (in w2 (priorities1 (r1 x))))))
(assert (iff (in (key x) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (or (in (key x) (priorities1 (l1 x))) (in (key x) (priorities1 (r1 x))))))
(assert (iff (in (key (r1 x)) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (or (in (key (r1 x)) (priorities1 (l1 x))) (in (key (r1 x)) (priorities1 (r1 x))))))
(assert (iff (in (key (l x)) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (or (in (key (l x)) (priorities1 (l1 x))) (in (key (l x)) (priorities1 (r1 x))))))
(assert (iff (in (priority x) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (or (in (priority x) (priorities1 (l1 x))) (in (priority x) (priorities1 (r1 x))))))
(assert (iff (in (priority (r1 x)) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (or (in (priority (r1 x)) (priorities1 (l1 x))) (in (priority (r1 x)) (priorities1 (r1 x))))))
(assert (iff (in (priority (l x)) (union (priorities1 (l1 x)) (priorities1 (r1 x)))) (or (in (priority (l x)) (priorities1 (l1 x))) (in (priority (l x)) (priorities1 (r1 x))))))
(assert (iff (in k (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (or (in k (priorities1 (l1 (r1 x)))) (in k (priorities1 (r1 (r1 x)))))))
(assert (iff (in p (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (or (in p (priorities1 (l1 (r1 x)))) (in p (priorities1 (r1 (r1 x)))))))
(assert (iff (in w1 (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (or (in w1 (priorities1 (l1 (r1 x)))) (in w1 (priorities1 (r1 (r1 x)))))))
(assert (iff (in w2 (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (or (in w2 (priorities1 (l1 (r1 x)))) (in w2 (priorities1 (r1 (r1 x)))))))
(assert (iff (in (key x) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (or (in (key x) (priorities1 (l1 (r1 x)))) (in (key x) (priorities1 (r1 (r1 x)))))))
(assert (iff (in (key (r1 x)) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (or (in (key (r1 x)) (priorities1 (l1 (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x)))))))
(assert (iff (in (key (l x)) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (or (in (key (l x)) (priorities1 (l1 (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x)))))))
(assert (iff (in (priority x) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (or (in (priority x) (priorities1 (l1 (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x)))))))
(assert (iff (in (priority (r1 x)) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (or (in (priority (r1 x)) (priorities1 (l1 (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x)))))))
(assert (iff (in (priority (l x)) (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x))))) (or (in (priority (l x)) (priorities1 (l1 (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x)))))))
(assert (iff (in k (union (singleton k) (keys (r x)))) (or (in k (singleton k)) (in k (keys (r x))))))
(assert (iff (in p (union (singleton k) (keys (r x)))) (or (in p (singleton k)) (in p (keys (r x))))))
(assert (iff (in w1 (union (singleton k) (keys (r x)))) (or (in w1 (singleton k)) (in w1 (keys (r x))))))
(assert (iff (in w2 (union (singleton k) (keys (r x)))) (or (in w2 (singleton k)) (in w2 (keys (r x))))))
(assert (iff (in (key x) (union (singleton k) (keys (r x)))) (or (in (key x) (singleton k)) (in (key x) (keys (r x))))))
(assert (iff (in (key (r1 x)) (union (singleton k) (keys (r x)))) (or (in (key (r1 x)) (singleton k)) (in (key (r1 x)) (keys (r x))))))
(assert (iff (in (key (l x)) (union (singleton k) (keys (r x)))) (or (in (key (l x)) (singleton k)) (in (key (l x)) (keys (r x))))))
(assert (iff (in (priority x) (union (singleton k) (keys (r x)))) (or (in (priority x) (singleton k)) (in (priority x) (keys (r x))))))
(assert (iff (in (priority (r1 x)) (union (singleton k) (keys (r x)))) (or (in (priority (r1 x)) (singleton k)) (in (priority (r1 x)) (keys (r x))))))
(assert (iff (in (priority (l x)) (union (singleton k) (keys (r x)))) (or (in (priority (l x)) (singleton k)) (in (priority (l x)) (keys (r x))))))
(assert (iff (in k (union (singleton p) (priorities (r x)))) (or (in k (singleton p)) (in k (priorities (r x))))))
(assert (iff (in p (union (singleton p) (priorities (r x)))) (or (in p (singleton p)) (in p (priorities (r x))))))
(assert (iff (in w1 (union (singleton p) (priorities (r x)))) (or (in w1 (singleton p)) (in w1 (priorities (r x))))))
(assert (iff (in w2 (union (singleton p) (priorities (r x)))) (or (in w2 (singleton p)) (in w2 (priorities (r x))))))
(assert (iff (in (key x) (union (singleton p) (priorities (r x)))) (or (in (key x) (singleton p)) (in (key x) (priorities (r x))))))
(assert (iff (in (key (r1 x)) (union (singleton p) (priorities (r x)))) (or (in (key (r1 x)) (singleton p)) (in (key (r1 x)) (priorities (r x))))))
(assert (iff (in (key (l x)) (union (singleton p) (priorities (r x)))) (or (in (key (l x)) (singleton p)) (in (key (l x)) (priorities (r x))))))
(assert (iff (in (priority x) (union (singleton p) (priorities (r x)))) (or (in (priority x) (singleton p)) (in (priority x) (priorities (r x))))))
(assert (iff (in (priority (r1 x)) (union (singleton p) (priorities (r x)))) (or (in (priority (r1 x)) (singleton p)) (in (priority (r1 x)) (priorities (r x))))))
(assert (iff (in (priority (l x)) (union (singleton p) (priorities (r x)))) (or (in (priority (l x)) (singleton p)) (in (priority (l x)) (priorities (r x))))))
(assert (iff (in k (union (singleton k) (keys x))) (or (in k (singleton k)) (in k (keys x)))))
(assert (iff (in p (union (singleton k) (keys x))) (or (in p (singleton k)) (in p (keys x)))))
(assert (iff (in w1 (union (singleton k) (keys x))) (or (in w1 (singleton k)) (in w1 (keys x)))))
(assert (iff (in w2 (union (singleton k) (keys x))) (or (in w2 (singleton k)) (in w2 (keys x)))))
(assert (iff (in (key x) (union (singleton k) (keys x))) (or (in (key x) (singleton k)) (in (key x) (keys x)))))
(assert (iff (in (key (r1 x)) (union (singleton k) (keys x))) (or (in (key (r1 x)) (singleton k)) (in (key (r1 x)) (keys x)))))
(assert (iff (in (key (l x)) (union (singleton k) (keys x))) (or (in (key (l x)) (singleton k)) (in (key (l x)) (keys x)))))
(assert (iff (in (priority x) (union (singleton k) (keys x))) (or (in (priority x) (singleton k)) (in (priority x) (keys x)))))
(assert (iff (in (priority (r1 x)) (union (singleton k) (keys x))) (or (in (priority (r1 x)) (singleton k)) (in (priority (r1 x)) (keys x)))))
(assert (iff (in (priority (l x)) (union (singleton k) (keys x))) (or (in (priority (l x)) (singleton k)) (in (priority (l x)) (keys x)))))
(assert (iff (in k (union (singleton p) (priorities x))) (or (in k (singleton p)) (in k (priorities x)))))
(assert (iff (in p (union (singleton p) (priorities x))) (or (in p (singleton p)) (in p (priorities x)))))
(assert (iff (in w1 (union (singleton p) (priorities x))) (or (in w1 (singleton p)) (in w1 (priorities x)))))
(assert (iff (in w2 (union (singleton p) (priorities x))) (or (in w2 (singleton p)) (in w2 (priorities x)))))
(assert (iff (in (key x) (union (singleton p) (priorities x))) (or (in (key x) (singleton p)) (in (key x) (priorities x)))))
(assert (iff (in (key (r1 x)) (union (singleton p) (priorities x))) (or (in (key (r1 x)) (singleton p)) (in (key (r1 x)) (priorities x)))))
(assert (iff (in (key (l x)) (union (singleton p) (priorities x))) (or (in (key (l x)) (singleton p)) (in (key (l x)) (priorities x)))))
(assert (iff (in (priority x) (union (singleton p) (priorities x))) (or (in (priority x) (singleton p)) (in (priority x) (priorities x)))))
(assert (iff (in (priority (r1 x)) (union (singleton p) (priorities x))) (or (in (priority (r1 x)) (singleton p)) (in (priority (r1 x)) (priorities x)))))
(assert (iff (in (priority (l x)) (union (singleton p) (priorities x))) (or (in (priority (l x)) (singleton p)) (in (priority (l x)) (priorities x)))))



(assert (iff (in k (singleton (key x))) (= k (key x))))
(assert (iff (in p (singleton (key x))) (= p (key x))))
(assert (iff (in w1 (singleton (key x))) (= w1 (key x))))
(assert (iff (in w2 (singleton (key x))) (= w2 (key x))))
(assert (iff (in (key x) (singleton (key x))) (= (key x) (key x))))
(assert (iff (in (key (r1 x)) (singleton (key x))) (= (key (r1 x)) (key x))))
(assert (iff (in (key (l x)) (singleton (key x))) (= (key (l x)) (key x))))
(assert (iff (in (priority x) (singleton (key x))) (= (priority x) (key x))))
(assert (iff (in (priority (r1 x)) (singleton (key x))) (= (priority (r1 x)) (key x))))
(assert (iff (in (priority (l x)) (singleton (key x))) (= (priority (l x)) (key x))))
(assert (iff (in k (singleton (key (r1 x)))) (= k (key (r1 x)))))
(assert (iff (in p (singleton (key (r1 x)))) (= p (key (r1 x)))))
(assert (iff (in w1 (singleton (key (r1 x)))) (= w1 (key (r1 x)))))
(assert (iff (in w2 (singleton (key (r1 x)))) (= w2 (key (r1 x)))))
(assert (iff (in (key x) (singleton (key (r1 x)))) (= (key x) (key (r1 x)))))
(assert (iff (in (key (r1 x)) (singleton (key (r1 x)))) (= (key (r1 x)) (key (r1 x)))))
(assert (iff (in (key (l x)) (singleton (key (r1 x)))) (= (key (l x)) (key (r1 x)))))
(assert (iff (in (priority x) (singleton (key (r1 x)))) (= (priority x) (key (r1 x)))))
(assert (iff (in (priority (r1 x)) (singleton (key (r1 x)))) (= (priority (r1 x)) (key (r1 x)))))
(assert (iff (in (priority (l x)) (singleton (key (r1 x)))) (= (priority (l x)) (key (r1 x)))))
(assert (iff (in k (singleton (priority x))) (= k (priority x))))
(assert (iff (in p (singleton (priority x))) (= p (priority x))))
(assert (iff (in w1 (singleton (priority x))) (= w1 (priority x))))
(assert (iff (in w2 (singleton (priority x))) (= w2 (priority x))))
(assert (iff (in (key x) (singleton (priority x))) (= (key x) (priority x))))
(assert (iff (in (key (r1 x)) (singleton (priority x))) (= (key (r1 x)) (priority x))))
(assert (iff (in (key (l x)) (singleton (priority x))) (= (key (l x)) (priority x))))
(assert (iff (in (priority x) (singleton (priority x))) (= (priority x) (priority x))))
(assert (iff (in (priority (r1 x)) (singleton (priority x))) (= (priority (r1 x)) (priority x))))
(assert (iff (in (priority (l x)) (singleton (priority x))) (= (priority (l x)) (priority x))))
(assert (iff (in k (singleton (priority (r1 x)))) (= k (priority (r1 x)))))
(assert (iff (in p (singleton (priority (r1 x)))) (= p (priority (r1 x)))))
(assert (iff (in w1 (singleton (priority (r1 x)))) (= w1 (priority (r1 x)))))
(assert (iff (in w2 (singleton (priority (r1 x)))) (= w2 (priority (r1 x)))))
(assert (iff (in (key x) (singleton (priority (r1 x)))) (= (key x) (priority (r1 x)))))
(assert (iff (in (key (r1 x)) (singleton (priority (r1 x)))) (= (key (r1 x)) (priority (r1 x)))))
(assert (iff (in (key (l x)) (singleton (priority (r1 x)))) (= (key (l x)) (priority (r1 x)))))
(assert (iff (in (priority x) (singleton (priority (r1 x)))) (= (priority x) (priority (r1 x)))))
(assert (iff (in (priority (r1 x)) (singleton (priority (r1 x)))) (= (priority (r1 x)) (priority (r1 x)))))
(assert (iff (in (priority (l x)) (singleton (priority (r1 x)))) (= (priority (l x)) (priority (r1 x)))))
(assert (iff (in k (singleton (priority (l x)))) (= k (priority (l x)))))
(assert (iff (in p (singleton (priority (l x)))) (= p (priority (l x)))))
(assert (iff (in w1 (singleton (priority (l x)))) (= w1 (priority (l x)))))
(assert (iff (in w2 (singleton (priority (l x)))) (= w2 (priority (l x)))))
(assert (iff (in (key x) (singleton (priority (l x)))) (= (key x) (priority (l x)))))
(assert (iff (in (key (r1 x)) (singleton (priority (l x)))) (= (key (r1 x)) (priority (l x)))))
(assert (iff (in (key (l x)) (singleton (priority (l x)))) (= (key (l x)) (priority (l x)))))
(assert (iff (in (priority x) (singleton (priority (l x)))) (= (priority x) (priority (l x)))))
(assert (iff (in (priority (r1 x)) (singleton (priority (l x)))) (= (priority (r1 x)) (priority (l x)))))
(assert (iff (in (priority (l x)) (singleton (priority (l x)))) (= (priority (l x)) (priority (l x)))))
(assert (iff (in k (singleton (key (l x)))) (= k (key (l x)))))
(assert (iff (in p (singleton (key (l x)))) (= p (key (l x)))))
(assert (iff (in w1 (singleton (key (l x)))) (= w1 (key (l x)))))
(assert (iff (in w2 (singleton (key (l x)))) (= w2 (key (l x)))))
(assert (iff (in (key x) (singleton (key (l x)))) (= (key x) (key (l x)))))
(assert (iff (in (key (r1 x)) (singleton (key (l x)))) (= (key (r1 x)) (key (l x)))))
(assert (iff (in (key (l x)) (singleton (key (l x)))) (= (key (l x)) (key (l x)))))
(assert (iff (in (priority x) (singleton (key (l x)))) (= (priority x) (key (l x)))))
(assert (iff (in (priority (r1 x)) (singleton (key (l x)))) (= (priority (r1 x)) (key (l x)))))
(assert (iff (in (priority (l x)) (singleton (key (l x)))) (= (priority (l x)) (key (l x)))))
(assert (iff (in k (singleton k)) (= k k)))
(assert (iff (in p (singleton k)) (= p k)))
(assert (iff (in w1 (singleton k)) (= w1 k)))
(assert (iff (in w2 (singleton k)) (= w2 k)))
(assert (iff (in (key x) (singleton k)) (= (key x) k)))
(assert (iff (in (key (r1 x)) (singleton k)) (= (key (r1 x)) k)))
(assert (iff (in (key (l x)) (singleton k)) (= (key (l x)) k)))
(assert (iff (in (priority x) (singleton k)) (= (priority x) k)))
(assert (iff (in (priority (r1 x)) (singleton k)) (= (priority (r1 x)) k)))
(assert (iff (in (priority (l x)) (singleton k)) (= (priority (l x)) k)))
(assert (iff (in k (singleton p)) (= k p)))
(assert (iff (in p (singleton p)) (= p p)))
(assert (iff (in w1 (singleton p)) (= w1 p)))
(assert (iff (in w2 (singleton p)) (= w2 p)))
(assert (iff (in (key x) (singleton p)) (= (key x) p)))
(assert (iff (in (key (r1 x)) (singleton p)) (= (key (r1 x)) p)))
(assert (iff (in (key (l x)) (singleton p)) (= (key (l x)) p)))
(assert (iff (in (priority x) (singleton p)) (= (priority x) p)))
(assert (iff (in (priority (r1 x)) (singleton p)) (= (priority (r1 x)) p)))
(assert (iff (in (priority (l x)) (singleton p)) (= (priority (l x)) p)))


(assert (=> (eq (keys nil) emptyset) (iff (in k (keys nil)) (in k emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in p (keys nil)) (in p emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in w1 (keys nil)) (in w1 emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in w2 (keys nil)) (in w2 emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in (key x) (keys nil)) (in (key x) emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in (key (r1 x)) (keys nil)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in (key (l x)) (keys nil)) (in (key (l x)) emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in (priority x) (keys nil)) (in (priority x) emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in (priority (r1 x)) (keys nil)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (keys nil) emptyset) (iff (in (priority (l x)) (keys nil)) (in (priority (l x)) emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in k (keys' nil)) (in k emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in p (keys' nil)) (in p emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in w1 (keys' nil)) (in w1 emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in w2 (keys' nil)) (in w2 emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in (key x) (keys' nil)) (in (key x) emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in (key (r1 x)) (keys' nil)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in (key (l x)) (keys' nil)) (in (key (l x)) emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in (priority x) (keys' nil)) (in (priority x) emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in (priority (r1 x)) (keys' nil)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (keys' nil) emptyset) (iff (in (priority (l x)) (keys' nil)) (in (priority (l x)) emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in k (keys1 nil)) (in k emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in p (keys1 nil)) (in p emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in w1 (keys1 nil)) (in w1 emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in w2 (keys1 nil)) (in w2 emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in (key x) (keys1 nil)) (in (key x) emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in (key (r1 x)) (keys1 nil)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in (key (l x)) (keys1 nil)) (in (key (l x)) emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in (priority x) (keys1 nil)) (in (priority x) emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in (priority (r1 x)) (keys1 nil)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (keys1 nil) emptyset) (iff (in (priority (l x)) (keys1 nil)) (in (priority (l x)) emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in k (priorities nil)) (in k emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in p (priorities nil)) (in p emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in w1 (priorities nil)) (in w1 emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in w2 (priorities nil)) (in w2 emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in (key x) (priorities nil)) (in (key x) emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in (key (r1 x)) (priorities nil)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in (key (l x)) (priorities nil)) (in (key (l x)) emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in (priority x) (priorities nil)) (in (priority x) emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in (priority (r1 x)) (priorities nil)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (priorities nil) emptyset) (iff (in (priority (l x)) (priorities nil)) (in (priority (l x)) emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in k (priorities' nil)) (in k emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in p (priorities' nil)) (in p emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in w1 (priorities' nil)) (in w1 emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in w2 (priorities' nil)) (in w2 emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in (key x) (priorities' nil)) (in (key x) emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in (key (r1 x)) (priorities' nil)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in (key (l x)) (priorities' nil)) (in (key (l x)) emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in (priority x) (priorities' nil)) (in (priority x) emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in (priority (r1 x)) (priorities' nil)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (priorities' nil) emptyset) (iff (in (priority (l x)) (priorities' nil)) (in (priority (l x)) emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in k (priorities1 nil)) (in k emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in p (priorities1 nil)) (in p emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in w1 (priorities1 nil)) (in w1 emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in w2 (priorities1 nil)) (in w2 emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in (key x) (priorities1 nil)) (in (key x) emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in (key (r1 x)) (priorities1 nil)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in (key (l x)) (priorities1 nil)) (in (key (l x)) emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in (priority x) (priorities1 nil)) (in (priority x) emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in (priority (r1 x)) (priorities1 nil)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (priorities1 nil) emptyset) (iff (in (priority (l x)) (priorities1 nil)) (in (priority (l x)) emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in k (keys x)) (in k emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in p (keys x)) (in p emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in w1 (keys x)) (in w1 emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in w2 (keys x)) (in w2 emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in (key x) (keys x)) (in (key x) emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in (key (r1 x)) (keys x)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in (key (l x)) (keys x)) (in (key (l x)) emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in (priority x) (keys x)) (in (priority x) emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in (priority (r1 x)) (keys x)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (keys x) emptyset) (iff (in (priority (l x)) (keys x)) (in (priority (l x)) emptyset))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in k (keys x)) (in k (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in p (keys x)) (in p (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in w1 (keys x)) (in w1 (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in w2 (keys x)) (in w2 (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in (key x) (keys x)) (in (key x) (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in (key (r1 x)) (keys x)) (in (key (r1 x)) (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in (key (l x)) (keys x)) (in (key (l x)) (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in (priority x) (keys x)) (in (priority x) (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in (priority (r1 x)) (keys x)) (in (priority (r1 x)) (singleton (key x))))))
(assert (=> (eq (keys x) (singleton (key x))) (iff (in (priority (l x)) (keys x)) (in (priority (l x)) (singleton (key x))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in k (keys x)) (in k (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in p (keys x)) (in p (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in w1 (keys x)) (in w1 (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in w2 (keys x)) (in w2 (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in (key x) (keys x)) (in (key x) (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in (key (r1 x)) (keys x)) (in (key (r1 x)) (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in (key (l x)) (keys x)) (in (key (l x)) (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in (priority x) (keys x)) (in (priority x) (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in (priority (r1 x)) (keys x)) (in (priority (r1 x)) (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (l x)) (singleton (key x)))) (iff (in (priority (l x)) (keys x)) (in (priority (l x)) (union (keys (l x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in k (keys x)) (in k (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in p (keys x)) (in p (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in w1 (keys x)) (in w1 (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in w2 (keys x)) (in w2 (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in (key x) (keys x)) (in (key x) (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in (key (r1 x)) (keys x)) (in (key (r1 x)) (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in (key (l x)) (keys x)) (in (key (l x)) (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in (priority x) (keys x)) (in (priority x) (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in (priority (r1 x)) (keys x)) (in (priority (r1 x)) (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (keys (r x)) (singleton (key x)))) (iff (in (priority (l x)) (keys x)) (in (priority (l x)) (union (keys (r x)) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in k (keys x)) (in k (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in p (keys x)) (in p (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in w1 (keys x)) (in w1 (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in w2 (keys x)) (in w2 (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in (key x) (keys x)) (in (key x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in (key (r1 x)) (keys x)) (in (key (r1 x)) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in (key (l x)) (keys x)) (in (key (l x)) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in (priority x) (keys x)) (in (priority x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in (priority (r1 x)) (keys x)) (in (priority (r1 x)) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys x) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))) (iff (in (priority (l x)) (keys x)) (in (priority (l x)) (union (union (keys (l x)) (keys (r x))) (singleton (key x)))))))
(assert (=> (eq (keys' (r1 x)) emptyset) (iff (in k (keys' (r1 x))) (in k emptyset))))
(assert (=> (eq (keys' (r1 x)) emptyset) (iff (in p (keys' (r1 x))) (in p emptyset))))
(assert (=> (eq (keys' (r1 x)) emptyset) (iff (in w1 (keys' (r1 x))) (in w1 emptyset))))
(assert (=> (eq (keys' (r1 x)) emptyset) (iff (in w2 (keys' (r1 x))) (in w2 emptyset))))
(assert (=> (eq (keys' (r1 x)) emptyset) (iff (in (key x) (keys' (r1 x))) (in (key x) emptyset))))
(assert (=> (eq (keys' (r1 x)) emptyset) (iff (in (key (r1 x)) (keys' (r1 x))) (in (key (r1 x)) emptyset))))
(assert (=> (eq (keys' (r1 x)) emptyset) (iff (in (key (l x)) (keys' (r1 x))) (in (key (l x)) emptyset))))
(assert (=> (eq (keys' (r1 x)) emptyset) (iff (in (priority x) (keys' (r1 x))) (in (priority x) emptyset))))
(assert (=> (eq (keys' (r1 x)) emptyset) (iff (in (priority (r1 x)) (keys' (r1 x))) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (keys' (r1 x)) emptyset) (iff (in (priority (l x)) (keys' (r1 x))) (in (priority (l x)) emptyset))))
(assert (=> (eq (keys' x) emptyset) (iff (in k (keys' x)) (in k emptyset))))
(assert (=> (eq (keys' x) emptyset) (iff (in p (keys' x)) (in p emptyset))))
(assert (=> (eq (keys' x) emptyset) (iff (in w1 (keys' x)) (in w1 emptyset))))
(assert (=> (eq (keys' x) emptyset) (iff (in w2 (keys' x)) (in w2 emptyset))))
(assert (=> (eq (keys' x) emptyset) (iff (in (key x) (keys' x)) (in (key x) emptyset))))
(assert (=> (eq (keys' x) emptyset) (iff (in (key (r1 x)) (keys' x)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (keys' x) emptyset) (iff (in (key (l x)) (keys' x)) (in (key (l x)) emptyset))))
(assert (=> (eq (keys' x) emptyset) (iff (in (priority x) (keys' x)) (in (priority x) emptyset))))
(assert (=> (eq (keys' x) emptyset) (iff (in (priority (r1 x)) (keys' x)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (keys' x) emptyset) (iff (in (priority (l x)) (keys' x)) (in (priority (l x)) emptyset))))
(assert (=> (eq (keys' (r1 x)) (singleton (key (r1 x)))) (iff (in k (keys' (r1 x))) (in k (singleton (key (r1 x)))))))
(assert (=> (eq (keys' (r1 x)) (singleton (key (r1 x)))) (iff (in p (keys' (r1 x))) (in p (singleton (key (r1 x)))))))
(assert (=> (eq (keys' (r1 x)) (singleton (key (r1 x)))) (iff (in w1 (keys' (r1 x))) (in w1 (singleton (key (r1 x)))))))
(assert (=> (eq (keys' (r1 x)) (singleton (key (r1 x)))) (iff (in w2 (keys' (r1 x))) (in w2 (singleton (key (r1 x)))))))
(assert (=> (eq (keys' (r1 x)) (singleton (key (r1 x)))) (iff (in (key x) (keys' (r1 x))) (in (key x) (singleton (key (r1 x)))))))
(assert (=> (eq (keys' (r1 x)) (singleton (key (r1 x)))) (iff (in (key (r1 x)) (keys' (r1 x))) (in (key (r1 x)) (singleton (key (r1 x)))))))
(assert (=> (eq (keys' (r1 x)) (singleton (key (r1 x)))) (iff (in (key (l x)) (keys' (r1 x))) (in (key (l x)) (singleton (key (r1 x)))))))
(assert (=> (eq (keys' (r1 x)) (singleton (key (r1 x)))) (iff (in (priority x) (keys' (r1 x))) (in (priority x) (singleton (key (r1 x)))))))
(assert (=> (eq (keys' (r1 x)) (singleton (key (r1 x)))) (iff (in (priority (r1 x)) (keys' (r1 x))) (in (priority (r1 x)) (singleton (key (r1 x)))))))
(assert (=> (eq (keys' (r1 x)) (singleton (key (r1 x)))) (iff (in (priority (l x)) (keys' (r1 x))) (in (priority (l x)) (singleton (key (r1 x)))))))
(assert (=> (eq (keys' x) (singleton (key x))) (iff (in k (keys' x)) (in k (singleton (key x))))))
(assert (=> (eq (keys' x) (singleton (key x))) (iff (in p (keys' x)) (in p (singleton (key x))))))
(assert (=> (eq (keys' x) (singleton (key x))) (iff (in w1 (keys' x)) (in w1 (singleton (key x))))))
(assert (=> (eq (keys' x) (singleton (key x))) (iff (in w2 (keys' x)) (in w2 (singleton (key x))))))
(assert (=> (eq (keys' x) (singleton (key x))) (iff (in (key x) (keys' x)) (in (key x) (singleton (key x))))))
(assert (=> (eq (keys' x) (singleton (key x))) (iff (in (key (r1 x)) (keys' x)) (in (key (r1 x)) (singleton (key x))))))
(assert (=> (eq (keys' x) (singleton (key x))) (iff (in (key (l x)) (keys' x)) (in (key (l x)) (singleton (key x))))))
(assert (=> (eq (keys' x) (singleton (key x))) (iff (in (priority x) (keys' x)) (in (priority x) (singleton (key x))))))
(assert (=> (eq (keys' x) (singleton (key x))) (iff (in (priority (r1 x)) (keys' x)) (in (priority (r1 x)) (singleton (key x))))))
(assert (=> (eq (keys' x) (singleton (key x))) (iff (in (priority (l x)) (keys' x)) (in (priority (l x)) (singleton (key x))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (iff (in k (keys' (r1 x))) (in k (union (keys' (l' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (iff (in p (keys' (r1 x))) (in p (union (keys' (l' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (iff (in w1 (keys' (r1 x))) (in w1 (union (keys' (l' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (iff (in w2 (keys' (r1 x))) (in w2 (union (keys' (l' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (iff (in (key x) (keys' (r1 x))) (in (key x) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (iff (in (key (r1 x)) (keys' (r1 x))) (in (key (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (iff (in (key (l x)) (keys' (r1 x))) (in (key (l x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (iff (in (priority x) (keys' (r1 x))) (in (priority x) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (iff (in (priority (r1 x)) (keys' (r1 x))) (in (priority (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))) (iff (in (priority (l x)) (keys' (r1 x))) (in (priority (l x)) (union (keys' (l' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' x) (union (keys' (l' x)) (singleton (key x)))) (iff (in k (keys' x)) (in k (union (keys' (l' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (l' x)) (singleton (key x)))) (iff (in p (keys' x)) (in p (union (keys' (l' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (l' x)) (singleton (key x)))) (iff (in w1 (keys' x)) (in w1 (union (keys' (l' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (l' x)) (singleton (key x)))) (iff (in w2 (keys' x)) (in w2 (union (keys' (l' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (l' x)) (singleton (key x)))) (iff (in (key x) (keys' x)) (in (key x) (union (keys' (l' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (l' x)) (singleton (key x)))) (iff (in (key (r1 x)) (keys' x)) (in (key (r1 x)) (union (keys' (l' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (l' x)) (singleton (key x)))) (iff (in (key (l x)) (keys' x)) (in (key (l x)) (union (keys' (l' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (l' x)) (singleton (key x)))) (iff (in (priority x) (keys' x)) (in (priority x) (union (keys' (l' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (l' x)) (singleton (key x)))) (iff (in (priority (r1 x)) (keys' x)) (in (priority (r1 x)) (union (keys' (l' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (l' x)) (singleton (key x)))) (iff (in (priority (l x)) (keys' x)) (in (priority (l x)) (union (keys' (l' x)) (singleton (key x)))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (iff (in k (keys' (r1 x))) (in k (union (keys' (r' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (iff (in p (keys' (r1 x))) (in p (union (keys' (r' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (iff (in w1 (keys' (r1 x))) (in w1 (union (keys' (r' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (iff (in w2 (keys' (r1 x))) (in w2 (union (keys' (r' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (iff (in (key x) (keys' (r1 x))) (in (key x) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (iff (in (key (r1 x)) (keys' (r1 x))) (in (key (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (iff (in (key (l x)) (keys' (r1 x))) (in (key (l x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (iff (in (priority x) (keys' (r1 x))) (in (priority x) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (iff (in (priority (r1 x)) (keys' (r1 x))) (in (priority (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))) (iff (in (priority (l x)) (keys' (r1 x))) (in (priority (l x)) (union (keys' (r' (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' x) (union (keys' (r' x)) (singleton (key x)))) (iff (in k (keys' x)) (in k (union (keys' (r' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (r' x)) (singleton (key x)))) (iff (in p (keys' x)) (in p (union (keys' (r' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (r' x)) (singleton (key x)))) (iff (in w1 (keys' x)) (in w1 (union (keys' (r' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (r' x)) (singleton (key x)))) (iff (in w2 (keys' x)) (in w2 (union (keys' (r' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (r' x)) (singleton (key x)))) (iff (in (key x) (keys' x)) (in (key x) (union (keys' (r' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (r' x)) (singleton (key x)))) (iff (in (key (r1 x)) (keys' x)) (in (key (r1 x)) (union (keys' (r' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (r' x)) (singleton (key x)))) (iff (in (key (l x)) (keys' x)) (in (key (l x)) (union (keys' (r' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (r' x)) (singleton (key x)))) (iff (in (priority x) (keys' x)) (in (priority x) (union (keys' (r' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (r' x)) (singleton (key x)))) (iff (in (priority (r1 x)) (keys' x)) (in (priority (r1 x)) (union (keys' (r' x)) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (keys' (r' x)) (singleton (key x)))) (iff (in (priority (l x)) (keys' x)) (in (priority (l x)) (union (keys' (r' x)) (singleton (key x)))))))
(assert (=> (eq (keys' (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (iff (in k (keys' (r1 x))) (in k (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (iff (in p (keys' (r1 x))) (in p (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (iff (in w1 (keys' (r1 x))) (in w1 (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (iff (in w2 (keys' (r1 x))) (in w2 (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (iff (in (key x) (keys' (r1 x))) (in (key x) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (iff (in (key (r1 x)) (keys' (r1 x))) (in (key (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (iff (in (key (l x)) (keys' (r1 x))) (in (key (l x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (iff (in (priority x) (keys' (r1 x))) (in (priority x) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (iff (in (priority (r1 x)) (keys' (r1 x))) (in (priority (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' (r1 x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))) (iff (in (priority (l x)) (keys' (r1 x))) (in (priority (l x)) (union (union (keys' (l' (r1 x))) (keys' (r' (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys' x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (iff (in k (keys' x)) (in k (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (iff (in p (keys' x)) (in p (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (iff (in w1 (keys' x)) (in w1 (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (iff (in w2 (keys' x)) (in w2 (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (iff (in (key x) (keys' x)) (in (key x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (iff (in (key (r1 x)) (keys' x)) (in (key (r1 x)) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (iff (in (key (l x)) (keys' x)) (in (key (l x)) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (iff (in (priority x) (keys' x)) (in (priority x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (iff (in (priority (r1 x)) (keys' x)) (in (priority (r1 x)) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))))))
(assert (=> (eq (keys' x) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))) (iff (in (priority (l x)) (keys' x)) (in (priority (l x)) (union (union (keys' (l' x)) (keys' (r' x))) (singleton (key x)))))))
(assert (=> (eq (keys1 x) emptyset) (iff (in k (keys1 x)) (in k emptyset))))
(assert (=> (eq (keys1 x) emptyset) (iff (in p (keys1 x)) (in p emptyset))))
(assert (=> (eq (keys1 x) emptyset) (iff (in w1 (keys1 x)) (in w1 emptyset))))
(assert (=> (eq (keys1 x) emptyset) (iff (in w2 (keys1 x)) (in w2 emptyset))))
(assert (=> (eq (keys1 x) emptyset) (iff (in (key x) (keys1 x)) (in (key x) emptyset))))
(assert (=> (eq (keys1 x) emptyset) (iff (in (key (r1 x)) (keys1 x)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (keys1 x) emptyset) (iff (in (key (l x)) (keys1 x)) (in (key (l x)) emptyset))))
(assert (=> (eq (keys1 x) emptyset) (iff (in (priority x) (keys1 x)) (in (priority x) emptyset))))
(assert (=> (eq (keys1 x) emptyset) (iff (in (priority (r1 x)) (keys1 x)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (keys1 x) emptyset) (iff (in (priority (l x)) (keys1 x)) (in (priority (l x)) emptyset))))
(assert (=> (eq (keys1 (r1 x)) emptyset) (iff (in k (keys1 (r1 x))) (in k emptyset))))
(assert (=> (eq (keys1 (r1 x)) emptyset) (iff (in p (keys1 (r1 x))) (in p emptyset))))
(assert (=> (eq (keys1 (r1 x)) emptyset) (iff (in w1 (keys1 (r1 x))) (in w1 emptyset))))
(assert (=> (eq (keys1 (r1 x)) emptyset) (iff (in w2 (keys1 (r1 x))) (in w2 emptyset))))
(assert (=> (eq (keys1 (r1 x)) emptyset) (iff (in (key x) (keys1 (r1 x))) (in (key x) emptyset))))
(assert (=> (eq (keys1 (r1 x)) emptyset) (iff (in (key (r1 x)) (keys1 (r1 x))) (in (key (r1 x)) emptyset))))
(assert (=> (eq (keys1 (r1 x)) emptyset) (iff (in (key (l x)) (keys1 (r1 x))) (in (key (l x)) emptyset))))
(assert (=> (eq (keys1 (r1 x)) emptyset) (iff (in (priority x) (keys1 (r1 x))) (in (priority x) emptyset))))
(assert (=> (eq (keys1 (r1 x)) emptyset) (iff (in (priority (r1 x)) (keys1 (r1 x))) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (keys1 (r1 x)) emptyset) (iff (in (priority (l x)) (keys1 (r1 x))) (in (priority (l x)) emptyset))))
(assert (=> (eq (keys1 x) (singleton (key x))) (iff (in k (keys1 x)) (in k (singleton (key x))))))
(assert (=> (eq (keys1 x) (singleton (key x))) (iff (in p (keys1 x)) (in p (singleton (key x))))))
(assert (=> (eq (keys1 x) (singleton (key x))) (iff (in w1 (keys1 x)) (in w1 (singleton (key x))))))
(assert (=> (eq (keys1 x) (singleton (key x))) (iff (in w2 (keys1 x)) (in w2 (singleton (key x))))))
(assert (=> (eq (keys1 x) (singleton (key x))) (iff (in (key x) (keys1 x)) (in (key x) (singleton (key x))))))
(assert (=> (eq (keys1 x) (singleton (key x))) (iff (in (key (r1 x)) (keys1 x)) (in (key (r1 x)) (singleton (key x))))))
(assert (=> (eq (keys1 x) (singleton (key x))) (iff (in (key (l x)) (keys1 x)) (in (key (l x)) (singleton (key x))))))
(assert (=> (eq (keys1 x) (singleton (key x))) (iff (in (priority x) (keys1 x)) (in (priority x) (singleton (key x))))))
(assert (=> (eq (keys1 x) (singleton (key x))) (iff (in (priority (r1 x)) (keys1 x)) (in (priority (r1 x)) (singleton (key x))))))
(assert (=> (eq (keys1 x) (singleton (key x))) (iff (in (priority (l x)) (keys1 x)) (in (priority (l x)) (singleton (key x))))))
(assert (=> (eq (keys1 (r1 x)) (singleton (key (r1 x)))) (iff (in k (keys1 (r1 x))) (in k (singleton (key (r1 x)))))))
(assert (=> (eq (keys1 (r1 x)) (singleton (key (r1 x)))) (iff (in p (keys1 (r1 x))) (in p (singleton (key (r1 x)))))))
(assert (=> (eq (keys1 (r1 x)) (singleton (key (r1 x)))) (iff (in w1 (keys1 (r1 x))) (in w1 (singleton (key (r1 x)))))))
(assert (=> (eq (keys1 (r1 x)) (singleton (key (r1 x)))) (iff (in w2 (keys1 (r1 x))) (in w2 (singleton (key (r1 x)))))))
(assert (=> (eq (keys1 (r1 x)) (singleton (key (r1 x)))) (iff (in (key x) (keys1 (r1 x))) (in (key x) (singleton (key (r1 x)))))))
(assert (=> (eq (keys1 (r1 x)) (singleton (key (r1 x)))) (iff (in (key (r1 x)) (keys1 (r1 x))) (in (key (r1 x)) (singleton (key (r1 x)))))))
(assert (=> (eq (keys1 (r1 x)) (singleton (key (r1 x)))) (iff (in (key (l x)) (keys1 (r1 x))) (in (key (l x)) (singleton (key (r1 x)))))))
(assert (=> (eq (keys1 (r1 x)) (singleton (key (r1 x)))) (iff (in (priority x) (keys1 (r1 x))) (in (priority x) (singleton (key (r1 x)))))))
(assert (=> (eq (keys1 (r1 x)) (singleton (key (r1 x)))) (iff (in (priority (r1 x)) (keys1 (r1 x))) (in (priority (r1 x)) (singleton (key (r1 x)))))))
(assert (=> (eq (keys1 (r1 x)) (singleton (key (r1 x)))) (iff (in (priority (l x)) (keys1 (r1 x))) (in (priority (l x)) (singleton (key (r1 x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (l1 x)) (singleton (key x)))) (iff (in k (keys1 x)) (in k (union (keys1 (l1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (l1 x)) (singleton (key x)))) (iff (in p (keys1 x)) (in p (union (keys1 (l1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (l1 x)) (singleton (key x)))) (iff (in w1 (keys1 x)) (in w1 (union (keys1 (l1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (l1 x)) (singleton (key x)))) (iff (in w2 (keys1 x)) (in w2 (union (keys1 (l1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (l1 x)) (singleton (key x)))) (iff (in (key x) (keys1 x)) (in (key x) (union (keys1 (l1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (l1 x)) (singleton (key x)))) (iff (in (key (r1 x)) (keys1 x)) (in (key (r1 x)) (union (keys1 (l1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (l1 x)) (singleton (key x)))) (iff (in (key (l x)) (keys1 x)) (in (key (l x)) (union (keys1 (l1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (l1 x)) (singleton (key x)))) (iff (in (priority x) (keys1 x)) (in (priority x) (union (keys1 (l1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (l1 x)) (singleton (key x)))) (iff (in (priority (r1 x)) (keys1 x)) (in (priority (r1 x)) (union (keys1 (l1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (l1 x)) (singleton (key x)))) (iff (in (priority (l x)) (keys1 x)) (in (priority (l x)) (union (keys1 (l1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (iff (in k (keys1 (r1 x))) (in k (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (iff (in p (keys1 (r1 x))) (in p (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (iff (in w1 (keys1 (r1 x))) (in w1 (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (iff (in w2 (keys1 (r1 x))) (in w2 (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (iff (in (key x) (keys1 (r1 x))) (in (key x) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (iff (in (key (r1 x)) (keys1 (r1 x))) (in (key (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (iff (in (key (l x)) (keys1 (r1 x))) (in (key (l x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (iff (in (priority x) (keys1 (r1 x))) (in (priority x) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (iff (in (priority (r1 x)) (keys1 (r1 x))) (in (priority (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))) (iff (in (priority (l x)) (keys1 (r1 x))) (in (priority (l x)) (union (keys1 (l1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 x) (union (keys1 (r1 x)) (singleton (key x)))) (iff (in k (keys1 x)) (in k (union (keys1 (r1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (r1 x)) (singleton (key x)))) (iff (in p (keys1 x)) (in p (union (keys1 (r1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (r1 x)) (singleton (key x)))) (iff (in w1 (keys1 x)) (in w1 (union (keys1 (r1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (r1 x)) (singleton (key x)))) (iff (in w2 (keys1 x)) (in w2 (union (keys1 (r1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (r1 x)) (singleton (key x)))) (iff (in (key x) (keys1 x)) (in (key x) (union (keys1 (r1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (r1 x)) (singleton (key x)))) (iff (in (key (r1 x)) (keys1 x)) (in (key (r1 x)) (union (keys1 (r1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (r1 x)) (singleton (key x)))) (iff (in (key (l x)) (keys1 x)) (in (key (l x)) (union (keys1 (r1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (r1 x)) (singleton (key x)))) (iff (in (priority x) (keys1 x)) (in (priority x) (union (keys1 (r1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (r1 x)) (singleton (key x)))) (iff (in (priority (r1 x)) (keys1 x)) (in (priority (r1 x)) (union (keys1 (r1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (keys1 (r1 x)) (singleton (key x)))) (iff (in (priority (l x)) (keys1 x)) (in (priority (l x)) (union (keys1 (r1 x)) (singleton (key x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (iff (in k (keys1 (r1 x))) (in k (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (iff (in p (keys1 (r1 x))) (in p (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (iff (in w1 (keys1 (r1 x))) (in w1 (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (iff (in w2 (keys1 (r1 x))) (in w2 (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (iff (in (key x) (keys1 (r1 x))) (in (key x) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (iff (in (key (r1 x)) (keys1 (r1 x))) (in (key (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (iff (in (key (l x)) (keys1 (r1 x))) (in (key (l x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (iff (in (priority x) (keys1 (r1 x))) (in (priority x) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (iff (in (priority (r1 x)) (keys1 (r1 x))) (in (priority (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))) (iff (in (priority (l x)) (keys1 (r1 x))) (in (priority (l x)) (union (keys1 (r1 (r1 x))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (iff (in k (keys1 x)) (in k (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (iff (in p (keys1 x)) (in p (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (iff (in w1 (keys1 x)) (in w1 (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (iff (in w2 (keys1 x)) (in w2 (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (iff (in (key x) (keys1 x)) (in (key x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (iff (in (key (r1 x)) (keys1 x)) (in (key (r1 x)) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (iff (in (key (l x)) (keys1 x)) (in (key (l x)) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (iff (in (priority x) (keys1 x)) (in (priority x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (iff (in (priority (r1 x)) (keys1 x)) (in (priority (r1 x)) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))))))
(assert (=> (eq (keys1 x) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))) (iff (in (priority (l x)) (keys1 x)) (in (priority (l x)) (union (union (keys1 (l1 x)) (keys1 (r1 x))) (singleton (key x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (iff (in k (keys1 (r1 x))) (in k (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (iff (in p (keys1 (r1 x))) (in p (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (iff (in w1 (keys1 (r1 x))) (in w1 (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (iff (in w2 (keys1 (r1 x))) (in w2 (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (iff (in (key x) (keys1 (r1 x))) (in (key x) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (iff (in (key (r1 x)) (keys1 (r1 x))) (in (key (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (iff (in (key (l x)) (keys1 (r1 x))) (in (key (l x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (iff (in (priority x) (keys1 (r1 x))) (in (priority x) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (iff (in (priority (r1 x)) (keys1 (r1 x))) (in (priority (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))) (iff (in (priority (l x)) (keys1 (r1 x))) (in (priority (l x)) (union (union (keys1 (l1 (r1 x))) (keys1 (r1 (r1 x)))) (singleton (key (r1 x))))))))
(assert (=> (eq (priorities x) emptyset) (iff (in k (priorities x)) (in k emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in p (priorities x)) (in p emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in w1 (priorities x)) (in w1 emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in w2 (priorities x)) (in w2 emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in (key x) (priorities x)) (in (key x) emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in (key (r1 x)) (priorities x)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in (key (l x)) (priorities x)) (in (key (l x)) emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in (priority x) (priorities x)) (in (priority x) emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in (priority (r1 x)) (priorities x)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (priorities x) emptyset) (iff (in (priority (l x)) (priorities x)) (in (priority (l x)) emptyset))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in k (priorities x)) (in k (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in p (priorities x)) (in p (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in w1 (priorities x)) (in w1 (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in w2 (priorities x)) (in w2 (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in (key x) (priorities x)) (in (key x) (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in (key (r1 x)) (priorities x)) (in (key (r1 x)) (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in (key (l x)) (priorities x)) (in (key (l x)) (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in (priority x) (priorities x)) (in (priority x) (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in (priority (r1 x)) (priorities x)) (in (priority (r1 x)) (singleton (priority x))))))
(assert (=> (eq (priorities x) (singleton (priority x))) (iff (in (priority (l x)) (priorities x)) (in (priority (l x)) (singleton (priority x))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in k (priorities x)) (in k (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in p (priorities x)) (in p (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in w1 (priorities x)) (in w1 (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in w2 (priorities x)) (in w2 (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in (key x) (priorities x)) (in (key x) (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in (key (r1 x)) (priorities x)) (in (key (r1 x)) (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in (key (l x)) (priorities x)) (in (key (l x)) (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in (priority x) (priorities x)) (in (priority x) (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in (priority (r1 x)) (priorities x)) (in (priority (r1 x)) (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (l x)) (singleton (priority x)))) (iff (in (priority (l x)) (priorities x)) (in (priority (l x)) (union (priorities (l x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in k (priorities x)) (in k (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in p (priorities x)) (in p (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in w1 (priorities x)) (in w1 (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in w2 (priorities x)) (in w2 (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in (key x) (priorities x)) (in (key x) (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in (key (r1 x)) (priorities x)) (in (key (r1 x)) (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in (key (l x)) (priorities x)) (in (key (l x)) (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in (priority x) (priorities x)) (in (priority x) (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in (priority (r1 x)) (priorities x)) (in (priority (r1 x)) (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (priorities (r x)) (singleton (priority x)))) (iff (in (priority (l x)) (priorities x)) (in (priority (l x)) (union (priorities (r x)) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in k (priorities x)) (in k (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in p (priorities x)) (in p (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in w1 (priorities x)) (in w1 (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in w2 (priorities x)) (in w2 (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in (key x) (priorities x)) (in (key x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in (key (r1 x)) (priorities x)) (in (key (r1 x)) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in (key (l x)) (priorities x)) (in (key (l x)) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in (priority x) (priorities x)) (in (priority x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in (priority (r1 x)) (priorities x)) (in (priority (r1 x)) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities x) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))) (iff (in (priority (l x)) (priorities x)) (in (priority (l x)) (union (union (priorities (l x)) (priorities (r x))) (singleton (priority x)))))))
(assert (=> (eq (priorities' (r1 x)) emptyset) (iff (in k (priorities' (r1 x))) (in k emptyset))))
(assert (=> (eq (priorities' (r1 x)) emptyset) (iff (in p (priorities' (r1 x))) (in p emptyset))))
(assert (=> (eq (priorities' (r1 x)) emptyset) (iff (in w1 (priorities' (r1 x))) (in w1 emptyset))))
(assert (=> (eq (priorities' (r1 x)) emptyset) (iff (in w2 (priorities' (r1 x))) (in w2 emptyset))))
(assert (=> (eq (priorities' (r1 x)) emptyset) (iff (in (key x) (priorities' (r1 x))) (in (key x) emptyset))))
(assert (=> (eq (priorities' (r1 x)) emptyset) (iff (in (key (r1 x)) (priorities' (r1 x))) (in (key (r1 x)) emptyset))))
(assert (=> (eq (priorities' (r1 x)) emptyset) (iff (in (key (l x)) (priorities' (r1 x))) (in (key (l x)) emptyset))))
(assert (=> (eq (priorities' (r1 x)) emptyset) (iff (in (priority x) (priorities' (r1 x))) (in (priority x) emptyset))))
(assert (=> (eq (priorities' (r1 x)) emptyset) (iff (in (priority (r1 x)) (priorities' (r1 x))) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (priorities' (r1 x)) emptyset) (iff (in (priority (l x)) (priorities' (r1 x))) (in (priority (l x)) emptyset))))
(assert (=> (eq (priorities' x) emptyset) (iff (in k (priorities' x)) (in k emptyset))))
(assert (=> (eq (priorities' x) emptyset) (iff (in p (priorities' x)) (in p emptyset))))
(assert (=> (eq (priorities' x) emptyset) (iff (in w1 (priorities' x)) (in w1 emptyset))))
(assert (=> (eq (priorities' x) emptyset) (iff (in w2 (priorities' x)) (in w2 emptyset))))
(assert (=> (eq (priorities' x) emptyset) (iff (in (key x) (priorities' x)) (in (key x) emptyset))))
(assert (=> (eq (priorities' x) emptyset) (iff (in (key (r1 x)) (priorities' x)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (priorities' x) emptyset) (iff (in (key (l x)) (priorities' x)) (in (key (l x)) emptyset))))
(assert (=> (eq (priorities' x) emptyset) (iff (in (priority x) (priorities' x)) (in (priority x) emptyset))))
(assert (=> (eq (priorities' x) emptyset) (iff (in (priority (r1 x)) (priorities' x)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (priorities' x) emptyset) (iff (in (priority (l x)) (priorities' x)) (in (priority (l x)) emptyset))))
(assert (=> (eq (priorities' (r1 x)) (singleton (priority (r1 x)))) (iff (in k (priorities' (r1 x))) (in k (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities' (r1 x)) (singleton (priority (r1 x)))) (iff (in p (priorities' (r1 x))) (in p (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities' (r1 x)) (singleton (priority (r1 x)))) (iff (in w1 (priorities' (r1 x))) (in w1 (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities' (r1 x)) (singleton (priority (r1 x)))) (iff (in w2 (priorities' (r1 x))) (in w2 (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities' (r1 x)) (singleton (priority (r1 x)))) (iff (in (key x) (priorities' (r1 x))) (in (key x) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities' (r1 x)) (singleton (priority (r1 x)))) (iff (in (key (r1 x)) (priorities' (r1 x))) (in (key (r1 x)) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities' (r1 x)) (singleton (priority (r1 x)))) (iff (in (key (l x)) (priorities' (r1 x))) (in (key (l x)) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities' (r1 x)) (singleton (priority (r1 x)))) (iff (in (priority x) (priorities' (r1 x))) (in (priority x) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities' (r1 x)) (singleton (priority (r1 x)))) (iff (in (priority (r1 x)) (priorities' (r1 x))) (in (priority (r1 x)) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities' (r1 x)) (singleton (priority (r1 x)))) (iff (in (priority (l x)) (priorities' (r1 x))) (in (priority (l x)) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities' x) (singleton (priority x))) (iff (in k (priorities' x)) (in k (singleton (priority x))))))
(assert (=> (eq (priorities' x) (singleton (priority x))) (iff (in p (priorities' x)) (in p (singleton (priority x))))))
(assert (=> (eq (priorities' x) (singleton (priority x))) (iff (in w1 (priorities' x)) (in w1 (singleton (priority x))))))
(assert (=> (eq (priorities' x) (singleton (priority x))) (iff (in w2 (priorities' x)) (in w2 (singleton (priority x))))))
(assert (=> (eq (priorities' x) (singleton (priority x))) (iff (in (key x) (priorities' x)) (in (key x) (singleton (priority x))))))
(assert (=> (eq (priorities' x) (singleton (priority x))) (iff (in (key (r1 x)) (priorities' x)) (in (key (r1 x)) (singleton (priority x))))))
(assert (=> (eq (priorities' x) (singleton (priority x))) (iff (in (key (l x)) (priorities' x)) (in (key (l x)) (singleton (priority x))))))
(assert (=> (eq (priorities' x) (singleton (priority x))) (iff (in (priority x) (priorities' x)) (in (priority x) (singleton (priority x))))))
(assert (=> (eq (priorities' x) (singleton (priority x))) (iff (in (priority (r1 x)) (priorities' x)) (in (priority (r1 x)) (singleton (priority x))))))
(assert (=> (eq (priorities' x) (singleton (priority x))) (iff (in (priority (l x)) (priorities' x)) (in (priority (l x)) (singleton (priority x))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (iff (in k (priorities' (r1 x))) (in k (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (iff (in p (priorities' (r1 x))) (in p (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (iff (in w1 (priorities' (r1 x))) (in w1 (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (iff (in w2 (priorities' (r1 x))) (in w2 (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (iff (in (key x) (priorities' (r1 x))) (in (key x) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (iff (in (key (r1 x)) (priorities' (r1 x))) (in (key (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (iff (in (key (l x)) (priorities' (r1 x))) (in (key (l x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority x) (priorities' (r1 x))) (in (priority x) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority (r1 x)) (priorities' (r1 x))) (in (priority (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority (l x)) (priorities' (r1 x))) (in (priority (l x)) (union (priorities' (l' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' x) (union (priorities' (l' x)) (singleton (priority x)))) (iff (in k (priorities' x)) (in k (union (priorities' (l' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (l' x)) (singleton (priority x)))) (iff (in p (priorities' x)) (in p (union (priorities' (l' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (l' x)) (singleton (priority x)))) (iff (in w1 (priorities' x)) (in w1 (union (priorities' (l' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (l' x)) (singleton (priority x)))) (iff (in w2 (priorities' x)) (in w2 (union (priorities' (l' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (l' x)) (singleton (priority x)))) (iff (in (key x) (priorities' x)) (in (key x) (union (priorities' (l' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (l' x)) (singleton (priority x)))) (iff (in (key (r1 x)) (priorities' x)) (in (key (r1 x)) (union (priorities' (l' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (l' x)) (singleton (priority x)))) (iff (in (key (l x)) (priorities' x)) (in (key (l x)) (union (priorities' (l' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (l' x)) (singleton (priority x)))) (iff (in (priority x) (priorities' x)) (in (priority x) (union (priorities' (l' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (l' x)) (singleton (priority x)))) (iff (in (priority (r1 x)) (priorities' x)) (in (priority (r1 x)) (union (priorities' (l' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (l' x)) (singleton (priority x)))) (iff (in (priority (l x)) (priorities' x)) (in (priority (l x)) (union (priorities' (l' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (iff (in k (priorities' (r1 x))) (in k (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (iff (in p (priorities' (r1 x))) (in p (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (iff (in w1 (priorities' (r1 x))) (in w1 (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (iff (in w2 (priorities' (r1 x))) (in w2 (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (iff (in (key x) (priorities' (r1 x))) (in (key x) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (iff (in (key (r1 x)) (priorities' (r1 x))) (in (key (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (iff (in (key (l x)) (priorities' (r1 x))) (in (key (l x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority x) (priorities' (r1 x))) (in (priority x) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority (r1 x)) (priorities' (r1 x))) (in (priority (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority (l x)) (priorities' (r1 x))) (in (priority (l x)) (union (priorities' (r' (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' x) (union (priorities' (r' x)) (singleton (priority x)))) (iff (in k (priorities' x)) (in k (union (priorities' (r' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (r' x)) (singleton (priority x)))) (iff (in p (priorities' x)) (in p (union (priorities' (r' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (r' x)) (singleton (priority x)))) (iff (in w1 (priorities' x)) (in w1 (union (priorities' (r' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (r' x)) (singleton (priority x)))) (iff (in w2 (priorities' x)) (in w2 (union (priorities' (r' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (r' x)) (singleton (priority x)))) (iff (in (key x) (priorities' x)) (in (key x) (union (priorities' (r' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (r' x)) (singleton (priority x)))) (iff (in (key (r1 x)) (priorities' x)) (in (key (r1 x)) (union (priorities' (r' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (r' x)) (singleton (priority x)))) (iff (in (key (l x)) (priorities' x)) (in (key (l x)) (union (priorities' (r' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (r' x)) (singleton (priority x)))) (iff (in (priority x) (priorities' x)) (in (priority x) (union (priorities' (r' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (r' x)) (singleton (priority x)))) (iff (in (priority (r1 x)) (priorities' x)) (in (priority (r1 x)) (union (priorities' (r' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (priorities' (r' x)) (singleton (priority x)))) (iff (in (priority (l x)) (priorities' x)) (in (priority (l x)) (union (priorities' (r' x)) (singleton (priority x)))))))
(assert (=> (eq (priorities' (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (iff (in k (priorities' (r1 x))) (in k (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (iff (in p (priorities' (r1 x))) (in p (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (iff (in w1 (priorities' (r1 x))) (in w1 (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (iff (in w2 (priorities' (r1 x))) (in w2 (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (iff (in (key x) (priorities' (r1 x))) (in (key x) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (iff (in (key (r1 x)) (priorities' (r1 x))) (in (key (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (iff (in (key (l x)) (priorities' (r1 x))) (in (key (l x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (iff (in (priority x) (priorities' (r1 x))) (in (priority x) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (iff (in (priority (r1 x)) (priorities' (r1 x))) (in (priority (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' (r1 x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))) (iff (in (priority (l x)) (priorities' (r1 x))) (in (priority (l x)) (union (union (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities' x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (iff (in k (priorities' x)) (in k (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (iff (in p (priorities' x)) (in p (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (iff (in w1 (priorities' x)) (in w1 (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (iff (in w2 (priorities' x)) (in w2 (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (iff (in (key x) (priorities' x)) (in (key x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (iff (in (key (r1 x)) (priorities' x)) (in (key (r1 x)) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (iff (in (key (l x)) (priorities' x)) (in (key (l x)) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (iff (in (priority x) (priorities' x)) (in (priority x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (iff (in (priority (r1 x)) (priorities' x)) (in (priority (r1 x)) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))))))
(assert (=> (eq (priorities' x) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))) (iff (in (priority (l x)) (priorities' x)) (in (priority (l x)) (union (union (priorities' (l' x)) (priorities' (r' x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) emptyset) (iff (in k (priorities1 x)) (in k emptyset))))
(assert (=> (eq (priorities1 x) emptyset) (iff (in p (priorities1 x)) (in p emptyset))))
(assert (=> (eq (priorities1 x) emptyset) (iff (in w1 (priorities1 x)) (in w1 emptyset))))
(assert (=> (eq (priorities1 x) emptyset) (iff (in w2 (priorities1 x)) (in w2 emptyset))))
(assert (=> (eq (priorities1 x) emptyset) (iff (in (key x) (priorities1 x)) (in (key x) emptyset))))
(assert (=> (eq (priorities1 x) emptyset) (iff (in (key (r1 x)) (priorities1 x)) (in (key (r1 x)) emptyset))))
(assert (=> (eq (priorities1 x) emptyset) (iff (in (key (l x)) (priorities1 x)) (in (key (l x)) emptyset))))
(assert (=> (eq (priorities1 x) emptyset) (iff (in (priority x) (priorities1 x)) (in (priority x) emptyset))))
(assert (=> (eq (priorities1 x) emptyset) (iff (in (priority (r1 x)) (priorities1 x)) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (priorities1 x) emptyset) (iff (in (priority (l x)) (priorities1 x)) (in (priority (l x)) emptyset))))
(assert (=> (eq (priorities1 (r1 x)) emptyset) (iff (in k (priorities1 (r1 x))) (in k emptyset))))
(assert (=> (eq (priorities1 (r1 x)) emptyset) (iff (in p (priorities1 (r1 x))) (in p emptyset))))
(assert (=> (eq (priorities1 (r1 x)) emptyset) (iff (in w1 (priorities1 (r1 x))) (in w1 emptyset))))
(assert (=> (eq (priorities1 (r1 x)) emptyset) (iff (in w2 (priorities1 (r1 x))) (in w2 emptyset))))
(assert (=> (eq (priorities1 (r1 x)) emptyset) (iff (in (key x) (priorities1 (r1 x))) (in (key x) emptyset))))
(assert (=> (eq (priorities1 (r1 x)) emptyset) (iff (in (key (r1 x)) (priorities1 (r1 x))) (in (key (r1 x)) emptyset))))
(assert (=> (eq (priorities1 (r1 x)) emptyset) (iff (in (key (l x)) (priorities1 (r1 x))) (in (key (l x)) emptyset))))
(assert (=> (eq (priorities1 (r1 x)) emptyset) (iff (in (priority x) (priorities1 (r1 x))) (in (priority x) emptyset))))
(assert (=> (eq (priorities1 (r1 x)) emptyset) (iff (in (priority (r1 x)) (priorities1 (r1 x))) (in (priority (r1 x)) emptyset))))
(assert (=> (eq (priorities1 (r1 x)) emptyset) (iff (in (priority (l x)) (priorities1 (r1 x))) (in (priority (l x)) emptyset))))
(assert (=> (eq (priorities1 x) (singleton (priority x))) (iff (in k (priorities1 x)) (in k (singleton (priority x))))))
(assert (=> (eq (priorities1 x) (singleton (priority x))) (iff (in p (priorities1 x)) (in p (singleton (priority x))))))
(assert (=> (eq (priorities1 x) (singleton (priority x))) (iff (in w1 (priorities1 x)) (in w1 (singleton (priority x))))))
(assert (=> (eq (priorities1 x) (singleton (priority x))) (iff (in w2 (priorities1 x)) (in w2 (singleton (priority x))))))
(assert (=> (eq (priorities1 x) (singleton (priority x))) (iff (in (key x) (priorities1 x)) (in (key x) (singleton (priority x))))))
(assert (=> (eq (priorities1 x) (singleton (priority x))) (iff (in (key (r1 x)) (priorities1 x)) (in (key (r1 x)) (singleton (priority x))))))
(assert (=> (eq (priorities1 x) (singleton (priority x))) (iff (in (key (l x)) (priorities1 x)) (in (key (l x)) (singleton (priority x))))))
(assert (=> (eq (priorities1 x) (singleton (priority x))) (iff (in (priority x) (priorities1 x)) (in (priority x) (singleton (priority x))))))
(assert (=> (eq (priorities1 x) (singleton (priority x))) (iff (in (priority (r1 x)) (priorities1 x)) (in (priority (r1 x)) (singleton (priority x))))))
(assert (=> (eq (priorities1 x) (singleton (priority x))) (iff (in (priority (l x)) (priorities1 x)) (in (priority (l x)) (singleton (priority x))))))
(assert (=> (eq (priorities1 (r1 x)) (singleton (priority (r1 x)))) (iff (in k (priorities1 (r1 x))) (in k (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities1 (r1 x)) (singleton (priority (r1 x)))) (iff (in p (priorities1 (r1 x))) (in p (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities1 (r1 x)) (singleton (priority (r1 x)))) (iff (in w1 (priorities1 (r1 x))) (in w1 (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities1 (r1 x)) (singleton (priority (r1 x)))) (iff (in w2 (priorities1 (r1 x))) (in w2 (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities1 (r1 x)) (singleton (priority (r1 x)))) (iff (in (key x) (priorities1 (r1 x))) (in (key x) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities1 (r1 x)) (singleton (priority (r1 x)))) (iff (in (key (r1 x)) (priorities1 (r1 x))) (in (key (r1 x)) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities1 (r1 x)) (singleton (priority (r1 x)))) (iff (in (key (l x)) (priorities1 (r1 x))) (in (key (l x)) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities1 (r1 x)) (singleton (priority (r1 x)))) (iff (in (priority x) (priorities1 (r1 x))) (in (priority x) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities1 (r1 x)) (singleton (priority (r1 x)))) (iff (in (priority (r1 x)) (priorities1 (r1 x))) (in (priority (r1 x)) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities1 (r1 x)) (singleton (priority (r1 x)))) (iff (in (priority (l x)) (priorities1 (r1 x))) (in (priority (l x)) (singleton (priority (r1 x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (l1 x)) (singleton (priority x)))) (iff (in k (priorities1 x)) (in k (union (priorities1 (l1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (l1 x)) (singleton (priority x)))) (iff (in p (priorities1 x)) (in p (union (priorities1 (l1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (l1 x)) (singleton (priority x)))) (iff (in w1 (priorities1 x)) (in w1 (union (priorities1 (l1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (l1 x)) (singleton (priority x)))) (iff (in w2 (priorities1 x)) (in w2 (union (priorities1 (l1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (l1 x)) (singleton (priority x)))) (iff (in (key x) (priorities1 x)) (in (key x) (union (priorities1 (l1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (l1 x)) (singleton (priority x)))) (iff (in (key (r1 x)) (priorities1 x)) (in (key (r1 x)) (union (priorities1 (l1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (l1 x)) (singleton (priority x)))) (iff (in (key (l x)) (priorities1 x)) (in (key (l x)) (union (priorities1 (l1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (l1 x)) (singleton (priority x)))) (iff (in (priority x) (priorities1 x)) (in (priority x) (union (priorities1 (l1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (l1 x)) (singleton (priority x)))) (iff (in (priority (r1 x)) (priorities1 x)) (in (priority (r1 x)) (union (priorities1 (l1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (l1 x)) (singleton (priority x)))) (iff (in (priority (l x)) (priorities1 x)) (in (priority (l x)) (union (priorities1 (l1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (iff (in k (priorities1 (r1 x))) (in k (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (iff (in p (priorities1 (r1 x))) (in p (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (iff (in w1 (priorities1 (r1 x))) (in w1 (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (iff (in w2 (priorities1 (r1 x))) (in w2 (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (key x) (priorities1 (r1 x))) (in (key x) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (key (r1 x)) (priorities1 (r1 x))) (in (key (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (key (l x)) (priorities1 (r1 x))) (in (key (l x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority x) (priorities1 (r1 x))) (in (priority x) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority (r1 x)) (priorities1 (r1 x))) (in (priority (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority (l x)) (priorities1 (r1 x))) (in (priority (l x)) (union (priorities1 (l1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (r1 x)) (singleton (priority x)))) (iff (in k (priorities1 x)) (in k (union (priorities1 (r1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (r1 x)) (singleton (priority x)))) (iff (in p (priorities1 x)) (in p (union (priorities1 (r1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (r1 x)) (singleton (priority x)))) (iff (in w1 (priorities1 x)) (in w1 (union (priorities1 (r1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (r1 x)) (singleton (priority x)))) (iff (in w2 (priorities1 x)) (in w2 (union (priorities1 (r1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (r1 x)) (singleton (priority x)))) (iff (in (key x) (priorities1 x)) (in (key x) (union (priorities1 (r1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (r1 x)) (singleton (priority x)))) (iff (in (key (r1 x)) (priorities1 x)) (in (key (r1 x)) (union (priorities1 (r1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (r1 x)) (singleton (priority x)))) (iff (in (key (l x)) (priorities1 x)) (in (key (l x)) (union (priorities1 (r1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (r1 x)) (singleton (priority x)))) (iff (in (priority x) (priorities1 x)) (in (priority x) (union (priorities1 (r1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (r1 x)) (singleton (priority x)))) (iff (in (priority (r1 x)) (priorities1 x)) (in (priority (r1 x)) (union (priorities1 (r1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (priorities1 (r1 x)) (singleton (priority x)))) (iff (in (priority (l x)) (priorities1 x)) (in (priority (l x)) (union (priorities1 (r1 x)) (singleton (priority x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (iff (in k (priorities1 (r1 x))) (in k (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (iff (in p (priorities1 (r1 x))) (in p (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (iff (in w1 (priorities1 (r1 x))) (in w1 (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (iff (in w2 (priorities1 (r1 x))) (in w2 (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (key x) (priorities1 (r1 x))) (in (key x) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (key (r1 x)) (priorities1 (r1 x))) (in (key (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (key (l x)) (priorities1 (r1 x))) (in (key (l x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority x) (priorities1 (r1 x))) (in (priority x) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority (r1 x)) (priorities1 (r1 x))) (in (priority (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))) (iff (in (priority (l x)) (priorities1 (r1 x))) (in (priority (l x)) (union (priorities1 (r1 (r1 x))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (iff (in k (priorities1 x)) (in k (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (iff (in p (priorities1 x)) (in p (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (iff (in w1 (priorities1 x)) (in w1 (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (iff (in w2 (priorities1 x)) (in w2 (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (iff (in (key x) (priorities1 x)) (in (key x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (iff (in (key (r1 x)) (priorities1 x)) (in (key (r1 x)) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (iff (in (key (l x)) (priorities1 x)) (in (key (l x)) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (iff (in (priority x) (priorities1 x)) (in (priority x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (iff (in (priority (r1 x)) (priorities1 x)) (in (priority (r1 x)) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 x) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))) (iff (in (priority (l x)) (priorities1 x)) (in (priority (l x)) (union (union (priorities1 (l1 x)) (priorities1 (r1 x))) (singleton (priority x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (iff (in k (priorities1 (r1 x))) (in k (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (iff (in p (priorities1 (r1 x))) (in p (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (iff (in w1 (priorities1 (r1 x))) (in w1 (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (iff (in w2 (priorities1 (r1 x))) (in w2 (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (iff (in (key x) (priorities1 (r1 x))) (in (key x) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (iff (in (key (r1 x)) (priorities1 (r1 x))) (in (key (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (iff (in (key (l x)) (priorities1 (r1 x))) (in (key (l x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (iff (in (priority x) (priorities1 (r1 x))) (in (priority x) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (iff (in (priority (r1 x)) (priorities1 (r1 x))) (in (priority (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (priorities1 (r1 x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))) (iff (in (priority (l x)) (priorities1 (r1 x))) (in (priority (l x)) (union (union (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (singleton (priority (r1 x))))))))
(assert (=> (eq (keys1 (r1 x)) (union (singleton k) (keys (r x)))) (iff (in k (keys1 (r1 x))) (in k (union (singleton k) (keys (r x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (singleton k) (keys (r x)))) (iff (in p (keys1 (r1 x))) (in p (union (singleton k) (keys (r x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (singleton k) (keys (r x)))) (iff (in w1 (keys1 (r1 x))) (in w1 (union (singleton k) (keys (r x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (singleton k) (keys (r x)))) (iff (in w2 (keys1 (r1 x))) (in w2 (union (singleton k) (keys (r x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (singleton k) (keys (r x)))) (iff (in (key x) (keys1 (r1 x))) (in (key x) (union (singleton k) (keys (r x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (singleton k) (keys (r x)))) (iff (in (key (r1 x)) (keys1 (r1 x))) (in (key (r1 x)) (union (singleton k) (keys (r x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (singleton k) (keys (r x)))) (iff (in (key (l x)) (keys1 (r1 x))) (in (key (l x)) (union (singleton k) (keys (r x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (singleton k) (keys (r x)))) (iff (in (priority x) (keys1 (r1 x))) (in (priority x) (union (singleton k) (keys (r x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (singleton k) (keys (r x)))) (iff (in (priority (r1 x)) (keys1 (r1 x))) (in (priority (r1 x)) (union (singleton k) (keys (r x)))))))
(assert (=> (eq (keys1 (r1 x)) (union (singleton k) (keys (r x)))) (iff (in (priority (l x)) (keys1 (r1 x))) (in (priority (l x)) (union (singleton k) (keys (r x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (singleton p) (priorities (r x)))) (iff (in k (priorities1 (r1 x))) (in k (union (singleton p) (priorities (r x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (singleton p) (priorities (r x)))) (iff (in p (priorities1 (r1 x))) (in p (union (singleton p) (priorities (r x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (singleton p) (priorities (r x)))) (iff (in w1 (priorities1 (r1 x))) (in w1 (union (singleton p) (priorities (r x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (singleton p) (priorities (r x)))) (iff (in w2 (priorities1 (r1 x))) (in w2 (union (singleton p) (priorities (r x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (singleton p) (priorities (r x)))) (iff (in (key x) (priorities1 (r1 x))) (in (key x) (union (singleton p) (priorities (r x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (singleton p) (priorities (r x)))) (iff (in (key (r1 x)) (priorities1 (r1 x))) (in (key (r1 x)) (union (singleton p) (priorities (r x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (singleton p) (priorities (r x)))) (iff (in (key (l x)) (priorities1 (r1 x))) (in (key (l x)) (union (singleton p) (priorities (r x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (singleton p) (priorities (r x)))) (iff (in (priority x) (priorities1 (r1 x))) (in (priority x) (union (singleton p) (priorities (r x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (singleton p) (priorities (r x)))) (iff (in (priority (r1 x)) (priorities1 (r1 x))) (in (priority (r1 x)) (union (singleton p) (priorities (r x)))))))
(assert (=> (eq (priorities1 (r1 x)) (union (singleton p) (priorities (r x)))) (iff (in (priority (l x)) (priorities1 (r1 x))) (in (priority (l x)) (union (singleton p) (priorities (r x)))))))
(assert (=> (eq (keys' (r1 x)) (union (singleton k) (keys x))) (iff (in k (keys' (r1 x))) (in k (union (singleton k) (keys x))))))
(assert (=> (eq (keys' (r1 x)) (union (singleton k) (keys x))) (iff (in p (keys' (r1 x))) (in p (union (singleton k) (keys x))))))
(assert (=> (eq (keys' (r1 x)) (union (singleton k) (keys x))) (iff (in w1 (keys' (r1 x))) (in w1 (union (singleton k) (keys x))))))
(assert (=> (eq (keys' (r1 x)) (union (singleton k) (keys x))) (iff (in w2 (keys' (r1 x))) (in w2 (union (singleton k) (keys x))))))
(assert (=> (eq (keys' (r1 x)) (union (singleton k) (keys x))) (iff (in (key x) (keys' (r1 x))) (in (key x) (union (singleton k) (keys x))))))
(assert (=> (eq (keys' (r1 x)) (union (singleton k) (keys x))) (iff (in (key (r1 x)) (keys' (r1 x))) (in (key (r1 x)) (union (singleton k) (keys x))))))
(assert (=> (eq (keys' (r1 x)) (union (singleton k) (keys x))) (iff (in (key (l x)) (keys' (r1 x))) (in (key (l x)) (union (singleton k) (keys x))))))
(assert (=> (eq (keys' (r1 x)) (union (singleton k) (keys x))) (iff (in (priority x) (keys' (r1 x))) (in (priority x) (union (singleton k) (keys x))))))
(assert (=> (eq (keys' (r1 x)) (union (singleton k) (keys x))) (iff (in (priority (r1 x)) (keys' (r1 x))) (in (priority (r1 x)) (union (singleton k) (keys x))))))
(assert (=> (eq (keys' (r1 x)) (union (singleton k) (keys x))) (iff (in (priority (l x)) (keys' (r1 x))) (in (priority (l x)) (union (singleton k) (keys x))))))
(assert (=> (eq (priorities' (r1 x)) (union (singleton p) (priorities x))) (iff (in k (priorities' (r1 x))) (in k (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' (r1 x)) (union (singleton p) (priorities x))) (iff (in p (priorities' (r1 x))) (in p (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' (r1 x)) (union (singleton p) (priorities x))) (iff (in w1 (priorities' (r1 x))) (in w1 (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' (r1 x)) (union (singleton p) (priorities x))) (iff (in w2 (priorities' (r1 x))) (in w2 (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' (r1 x)) (union (singleton p) (priorities x))) (iff (in (key x) (priorities' (r1 x))) (in (key x) (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' (r1 x)) (union (singleton p) (priorities x))) (iff (in (key (r1 x)) (priorities' (r1 x))) (in (key (r1 x)) (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' (r1 x)) (union (singleton p) (priorities x))) (iff (in (key (l x)) (priorities' (r1 x))) (in (key (l x)) (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' (r1 x)) (union (singleton p) (priorities x))) (iff (in (priority x) (priorities' (r1 x))) (in (priority x) (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' (r1 x)) (union (singleton p) (priorities x))) (iff (in (priority (r1 x)) (priorities' (r1 x))) (in (priority (r1 x)) (union (singleton p) (priorities x))))))
(assert (=> (eq (priorities' (r1 x)) (union (singleton p) (priorities x))) (iff (in (priority (l x)) (priorities' (r1 x))) (in (priority (l x)) (union (singleton p) (priorities x))))))
(assert (=> (eq (keys (l x)) (keys1 (l x))) (iff (in k (keys (l x))) (in k (keys1 (l x))))))
(assert (=> (eq (keys (l x)) (keys1 (l x))) (iff (in p (keys (l x))) (in p (keys1 (l x))))))
(assert (=> (eq (keys (l x)) (keys1 (l x))) (iff (in w1 (keys (l x))) (in w1 (keys1 (l x))))))
(assert (=> (eq (keys (l x)) (keys1 (l x))) (iff (in w2 (keys (l x))) (in w2 (keys1 (l x))))))
(assert (=> (eq (keys (l x)) (keys1 (l x))) (iff (in (key x) (keys (l x))) (in (key x) (keys1 (l x))))))
(assert (=> (eq (keys (l x)) (keys1 (l x))) (iff (in (key (r1 x)) (keys (l x))) (in (key (r1 x)) (keys1 (l x))))))
(assert (=> (eq (keys (l x)) (keys1 (l x))) (iff (in (key (l x)) (keys (l x))) (in (key (l x)) (keys1 (l x))))))
(assert (=> (eq (keys (l x)) (keys1 (l x))) (iff (in (priority x) (keys (l x))) (in (priority x) (keys1 (l x))))))
(assert (=> (eq (keys (l x)) (keys1 (l x))) (iff (in (priority (r1 x)) (keys (l x))) (in (priority (r1 x)) (keys1 (l x))))))
(assert (=> (eq (keys (l x)) (keys1 (l x))) (iff (in (priority (l x)) (keys (l x))) (in (priority (l x)) (keys1 (l x))))))
(assert (=> (eq (priorities (l x)) (priorities1 (l x))) (iff (in k (priorities (l x))) (in k (priorities1 (l x))))))
(assert (=> (eq (priorities (l x)) (priorities1 (l x))) (iff (in p (priorities (l x))) (in p (priorities1 (l x))))))
(assert (=> (eq (priorities (l x)) (priorities1 (l x))) (iff (in w1 (priorities (l x))) (in w1 (priorities1 (l x))))))
(assert (=> (eq (priorities (l x)) (priorities1 (l x))) (iff (in w2 (priorities (l x))) (in w2 (priorities1 (l x))))))
(assert (=> (eq (priorities (l x)) (priorities1 (l x))) (iff (in (key x) (priorities (l x))) (in (key x) (priorities1 (l x))))))
(assert (=> (eq (priorities (l x)) (priorities1 (l x))) (iff (in (key (r1 x)) (priorities (l x))) (in (key (r1 x)) (priorities1 (l x))))))
(assert (=> (eq (priorities (l x)) (priorities1 (l x))) (iff (in (key (l x)) (priorities (l x))) (in (key (l x)) (priorities1 (l x))))))
(assert (=> (eq (priorities (l x)) (priorities1 (l x))) (iff (in (priority x) (priorities (l x))) (in (priority x) (priorities1 (l x))))))
(assert (=> (eq (priorities (l x)) (priorities1 (l x))) (iff (in (priority (r1 x)) (priorities (l x))) (in (priority (r1 x)) (priorities1 (l x))))))
(assert (=> (eq (priorities (l x)) (priorities1 (l x))) (iff (in (priority (l x)) (priorities (l x))) (in (priority (l x)) (priorities1 (l x))))))
(assert (=> (eq (keys' (l x)) (keys1 (l x))) (iff (in k (keys' (l x))) (in k (keys1 (l x))))))
(assert (=> (eq (keys' (l x)) (keys1 (l x))) (iff (in p (keys' (l x))) (in p (keys1 (l x))))))
(assert (=> (eq (keys' (l x)) (keys1 (l x))) (iff (in w1 (keys' (l x))) (in w1 (keys1 (l x))))))
(assert (=> (eq (keys' (l x)) (keys1 (l x))) (iff (in w2 (keys' (l x))) (in w2 (keys1 (l x))))))
(assert (=> (eq (keys' (l x)) (keys1 (l x))) (iff (in (key x) (keys' (l x))) (in (key x) (keys1 (l x))))))
(assert (=> (eq (keys' (l x)) (keys1 (l x))) (iff (in (key (r1 x)) (keys' (l x))) (in (key (r1 x)) (keys1 (l x))))))
(assert (=> (eq (keys' (l x)) (keys1 (l x))) (iff (in (key (l x)) (keys' (l x))) (in (key (l x)) (keys1 (l x))))))
(assert (=> (eq (keys' (l x)) (keys1 (l x))) (iff (in (priority x) (keys' (l x))) (in (priority x) (keys1 (l x))))))
(assert (=> (eq (keys' (l x)) (keys1 (l x))) (iff (in (priority (r1 x)) (keys' (l x))) (in (priority (r1 x)) (keys1 (l x))))))
(assert (=> (eq (keys' (l x)) (keys1 (l x))) (iff (in (priority (l x)) (keys' (l x))) (in (priority (l x)) (keys1 (l x))))))
(assert (=> (eq (priorities' (l x)) (priorities1 (l x))) (iff (in k (priorities' (l x))) (in k (priorities1 (l x))))))
(assert (=> (eq (priorities' (l x)) (priorities1 (l x))) (iff (in p (priorities' (l x))) (in p (priorities1 (l x))))))
(assert (=> (eq (priorities' (l x)) (priorities1 (l x))) (iff (in w1 (priorities' (l x))) (in w1 (priorities1 (l x))))))
(assert (=> (eq (priorities' (l x)) (priorities1 (l x))) (iff (in w2 (priorities' (l x))) (in w2 (priorities1 (l x))))))
(assert (=> (eq (priorities' (l x)) (priorities1 (l x))) (iff (in (key x) (priorities' (l x))) (in (key x) (priorities1 (l x))))))
(assert (=> (eq (priorities' (l x)) (priorities1 (l x))) (iff (in (key (r1 x)) (priorities' (l x))) (in (key (r1 x)) (priorities1 (l x))))))
(assert (=> (eq (priorities' (l x)) (priorities1 (l x))) (iff (in (key (l x)) (priorities' (l x))) (in (key (l x)) (priorities1 (l x))))))
(assert (=> (eq (priorities' (l x)) (priorities1 (l x))) (iff (in (priority x) (priorities' (l x))) (in (priority x) (priorities1 (l x))))))
(assert (=> (eq (priorities' (l x)) (priorities1 (l x))) (iff (in (priority (r1 x)) (priorities' (l x))) (in (priority (r1 x)) (priorities1 (l x))))))
(assert (=> (eq (priorities' (l x)) (priorities1 (l x))) (iff (in (priority (l x)) (priorities' (l x))) (in (priority (l x)) (priorities1 (l x))))))
(assert (=> (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x)))) (iff (in k (keys' (r1 (r1 x)))) (in k (keys1 (r1 (r1 x)))))))
(assert (=> (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x)))) (iff (in p (keys' (r1 (r1 x)))) (in p (keys1 (r1 (r1 x)))))))
(assert (=> (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x)))) (iff (in w1 (keys' (r1 (r1 x)))) (in w1 (keys1 (r1 (r1 x)))))))
(assert (=> (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x)))) (iff (in w2 (keys' (r1 (r1 x)))) (in w2 (keys1 (r1 (r1 x)))))))
(assert (=> (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x)))) (iff (in (key x) (keys' (r1 (r1 x)))) (in (key x) (keys1 (r1 (r1 x)))))))
(assert (=> (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x)))) (iff (in (key (r1 x)) (keys' (r1 (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x)))))))
(assert (=> (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x)))) (iff (in (key (l x)) (keys' (r1 (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x)))))))
(assert (=> (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x)))) (iff (in (priority x) (keys' (r1 (r1 x)))) (in (priority x) (keys1 (r1 (r1 x)))))))
(assert (=> (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x)))) (iff (in (priority (r1 x)) (keys' (r1 (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x)))))))
(assert (=> (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x)))) (iff (in (priority (l x)) (keys' (r1 (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x)))))))
(assert (=> (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x)))) (iff (in k (priorities' (r1 (r1 x)))) (in k (priorities1 (r1 (r1 x)))))))
(assert (=> (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x)))) (iff (in p (priorities' (r1 (r1 x)))) (in p (priorities1 (r1 (r1 x)))))))
(assert (=> (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x)))) (iff (in w1 (priorities' (r1 (r1 x)))) (in w1 (priorities1 (r1 (r1 x)))))))
(assert (=> (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x)))) (iff (in w2 (priorities' (r1 (r1 x)))) (in w2 (priorities1 (r1 (r1 x)))))))
(assert (=> (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x)))) (iff (in (key x) (priorities' (r1 (r1 x)))) (in (key x) (priorities1 (r1 (r1 x)))))))
(assert (=> (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x)))) (iff (in (key (r1 x)) (priorities' (r1 (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x)))))))
(assert (=> (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x)))) (iff (in (key (l x)) (priorities' (r1 (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x)))))))
(assert (=> (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x)))) (iff (in (priority x) (priorities' (r1 (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x)))))))
(assert (=> (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x)))) (iff (in (priority (r1 x)) (priorities' (r1 (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x)))))))
(assert (=> (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x)))) (iff (in (priority (l x)) (priorities' (r1 (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x)))))))
(assert (=> (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x)))) (iff (in k (keys' (l1 (r1 x)))) (in k (keys1 (l1 (r1 x)))))))
(assert (=> (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x)))) (iff (in p (keys' (l1 (r1 x)))) (in p (keys1 (l1 (r1 x)))))))
(assert (=> (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x)))) (iff (in w1 (keys' (l1 (r1 x)))) (in w1 (keys1 (l1 (r1 x)))))))
(assert (=> (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x)))) (iff (in w2 (keys' (l1 (r1 x)))) (in w2 (keys1 (l1 (r1 x)))))))
(assert (=> (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x)))) (iff (in (key x) (keys' (l1 (r1 x)))) (in (key x) (keys1 (l1 (r1 x)))))))
(assert (=> (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x)))) (iff (in (key (r1 x)) (keys' (l1 (r1 x)))) (in (key (r1 x)) (keys1 (l1 (r1 x)))))))
(assert (=> (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x)))) (iff (in (key (l x)) (keys' (l1 (r1 x)))) (in (key (l x)) (keys1 (l1 (r1 x)))))))
(assert (=> (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x)))) (iff (in (priority x) (keys' (l1 (r1 x)))) (in (priority x) (keys1 (l1 (r1 x)))))))
(assert (=> (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x)))) (iff (in (priority (r1 x)) (keys' (l1 (r1 x)))) (in (priority (r1 x)) (keys1 (l1 (r1 x)))))))
(assert (=> (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x)))) (iff (in (priority (l x)) (keys' (l1 (r1 x)))) (in (priority (l x)) (keys1 (l1 (r1 x)))))))
(assert (=> (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x)))) (iff (in k (priorities' (l1 (r1 x)))) (in k (priorities1 (l1 (r1 x)))))))
(assert (=> (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x)))) (iff (in p (priorities' (l1 (r1 x)))) (in p (priorities1 (l1 (r1 x)))))))
(assert (=> (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x)))) (iff (in w1 (priorities' (l1 (r1 x)))) (in w1 (priorities1 (l1 (r1 x)))))))
(assert (=> (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x)))) (iff (in w2 (priorities' (l1 (r1 x)))) (in w2 (priorities1 (l1 (r1 x)))))))
(assert (=> (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x)))) (iff (in (key x) (priorities' (l1 (r1 x)))) (in (key x) (priorities1 (l1 (r1 x)))))))
(assert (=> (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x)))) (iff (in (key (r1 x)) (priorities' (l1 (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x)))))))
(assert (=> (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x)))) (iff (in (key (l x)) (priorities' (l1 (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x)))))))
(assert (=> (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x)))) (iff (in (priority x) (priorities' (l1 (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x)))))))
(assert (=> (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x)))) (iff (in (priority (r1 x)) (priorities' (l1 (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x)))))))
(assert (=> (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x)))) (iff (in (priority (l x)) (priorities' (l1 (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x)))))))

(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in k (priorities (l x))) (in k (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in p (priorities (l x))) (in p (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in w1 (priorities (l x))) (in w1 (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in w2 (priorities (l x))) (in w2 (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in (key x) (priorities (l x))) (in (key x) (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in (key (r1 x)) (priorities (l x))) (in (key (r1 x)) (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in (key (l x)) (priorities (l x))) (in (key (l x)) (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in (priority x) (priorities (l x))) (in (priority x) (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in (priority (r1 x)) (priorities (l x))) (in (priority (r1 x)) (priorities (r x)))))))
(assert (=> (disjoint (priorities (l x)) (priorities (r x))) (not (and (in (priority (l x)) (priorities (l x))) (in (priority (l x)) (priorities (r x)))))))
(assert (=> (disjoint (priorities' (l' x)) (priorities' (r' x))) (not (and (in k (priorities' (l' x))) (in k (priorities' (r' x)))))))
(assert (=> (disjoint (priorities' (l' x)) (priorities' (r' x))) (not (and (in p (priorities' (l' x))) (in p (priorities' (r' x)))))))
(assert (=> (disjoint (priorities' (l' x)) (priorities' (r' x))) (not (and (in w1 (priorities' (l' x))) (in w1 (priorities' (r' x)))))))
(assert (=> (disjoint (priorities' (l' x)) (priorities' (r' x))) (not (and (in w2 (priorities' (l' x))) (in w2 (priorities' (r' x)))))))
(assert (=> (disjoint (priorities' (l' x)) (priorities' (r' x))) (not (and (in (key x) (priorities' (l' x))) (in (key x) (priorities' (r' x)))))))
(assert (=> (disjoint (priorities' (l' x)) (priorities' (r' x))) (not (and (in (key (r1 x)) (priorities' (l' x))) (in (key (r1 x)) (priorities' (r' x)))))))
(assert (=> (disjoint (priorities' (l' x)) (priorities' (r' x))) (not (and (in (key (l x)) (priorities' (l' x))) (in (key (l x)) (priorities' (r' x)))))))
(assert (=> (disjoint (priorities' (l' x)) (priorities' (r' x))) (not (and (in (priority x) (priorities' (l' x))) (in (priority x) (priorities' (r' x)))))))
(assert (=> (disjoint (priorities' (l' x)) (priorities' (r' x))) (not (and (in (priority (r1 x)) (priorities' (l' x))) (in (priority (r1 x)) (priorities' (r' x)))))))
(assert (=> (disjoint (priorities' (l' x)) (priorities' (r' x))) (not (and (in (priority (l x)) (priorities' (l' x))) (in (priority (l x)) (priorities' (r' x)))))))
(assert (=> (disjoint (priorities' (l' (l x))) (priorities' (r' (l x)))) (not (and (in k (priorities' (l' (l x)))) (in k (priorities' (r' (l x))))))))
(assert (=> (disjoint (priorities' (l' (l x))) (priorities' (r' (l x)))) (not (and (in p (priorities' (l' (l x)))) (in p (priorities' (r' (l x))))))))
(assert (=> (disjoint (priorities' (l' (l x))) (priorities' (r' (l x)))) (not (and (in w1 (priorities' (l' (l x)))) (in w1 (priorities' (r' (l x))))))))
(assert (=> (disjoint (priorities' (l' (l x))) (priorities' (r' (l x)))) (not (and (in w2 (priorities' (l' (l x)))) (in w2 (priorities' (r' (l x))))))))
(assert (=> (disjoint (priorities' (l' (l x))) (priorities' (r' (l x)))) (not (and (in (key x) (priorities' (l' (l x)))) (in (key x) (priorities' (r' (l x))))))))
(assert (=> (disjoint (priorities' (l' (l x))) (priorities' (r' (l x)))) (not (and (in (key (r1 x)) (priorities' (l' (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))))))
(assert (=> (disjoint (priorities' (l' (l x))) (priorities' (r' (l x)))) (not (and (in (key (l x)) (priorities' (l' (l x)))) (in (key (l x)) (priorities' (r' (l x))))))))
(assert (=> (disjoint (priorities' (l' (l x))) (priorities' (r' (l x)))) (not (and (in (priority x) (priorities' (l' (l x)))) (in (priority x) (priorities' (r' (l x))))))))
(assert (=> (disjoint (priorities' (l' (l x))) (priorities' (r' (l x)))) (not (and (in (priority (r1 x)) (priorities' (l' (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))))))
(assert (=> (disjoint (priorities' (l' (l x))) (priorities' (r' (l x)))) (not (and (in (priority (l x)) (priorities' (l' (l x)))) (in (priority (l x)) (priorities' (r' (l x))))))))
(assert (=> (disjoint (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (not (and (in k (priorities' (l' (r1 x)))) (in k (priorities' (r' (r1 x))))))))
(assert (=> (disjoint (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (not (and (in p (priorities' (l' (r1 x)))) (in p (priorities' (r' (r1 x))))))))
(assert (=> (disjoint (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (not (and (in w1 (priorities' (l' (r1 x)))) (in w1 (priorities' (r' (r1 x))))))))
(assert (=> (disjoint (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (not (and (in w2 (priorities' (l' (r1 x)))) (in w2 (priorities' (r' (r1 x))))))))
(assert (=> (disjoint (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (not (and (in (key x) (priorities' (l' (r1 x)))) (in (key x) (priorities' (r' (r1 x))))))))
(assert (=> (disjoint (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (not (and (in (key (r1 x)) (priorities' (l' (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))))))
(assert (=> (disjoint (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (not (and (in (key (l x)) (priorities' (l' (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))))))
(assert (=> (disjoint (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (not (and (in (priority x) (priorities' (l' (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))))))
(assert (=> (disjoint (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (not (and (in (priority (r1 x)) (priorities' (l' (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))))))
(assert (=> (disjoint (priorities' (l' (r1 x))) (priorities' (r' (r1 x)))) (not (and (in (priority (l x)) (priorities' (l' (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))))))
(assert (=> (disjoint (priorities1 (l1 x)) (priorities1 (r1 x))) (not (and (in k (priorities1 (l1 x))) (in k (priorities1 (r1 x)))))))
(assert (=> (disjoint (priorities1 (l1 x)) (priorities1 (r1 x))) (not (and (in p (priorities1 (l1 x))) (in p (priorities1 (r1 x)))))))
(assert (=> (disjoint (priorities1 (l1 x)) (priorities1 (r1 x))) (not (and (in w1 (priorities1 (l1 x))) (in w1 (priorities1 (r1 x)))))))
(assert (=> (disjoint (priorities1 (l1 x)) (priorities1 (r1 x))) (not (and (in w2 (priorities1 (l1 x))) (in w2 (priorities1 (r1 x)))))))
(assert (=> (disjoint (priorities1 (l1 x)) (priorities1 (r1 x))) (not (and (in (key x) (priorities1 (l1 x))) (in (key x) (priorities1 (r1 x)))))))
(assert (=> (disjoint (priorities1 (l1 x)) (priorities1 (r1 x))) (not (and (in (key (r1 x)) (priorities1 (l1 x))) (in (key (r1 x)) (priorities1 (r1 x)))))))
(assert (=> (disjoint (priorities1 (l1 x)) (priorities1 (r1 x))) (not (and (in (key (l x)) (priorities1 (l1 x))) (in (key (l x)) (priorities1 (r1 x)))))))
(assert (=> (disjoint (priorities1 (l1 x)) (priorities1 (r1 x))) (not (and (in (priority x) (priorities1 (l1 x))) (in (priority x) (priorities1 (r1 x)))))))
(assert (=> (disjoint (priorities1 (l1 x)) (priorities1 (r1 x))) (not (and (in (priority (r1 x)) (priorities1 (l1 x))) (in (priority (r1 x)) (priorities1 (r1 x)))))))
(assert (=> (disjoint (priorities1 (l1 x)) (priorities1 (r1 x))) (not (and (in (priority (l x)) (priorities1 (l1 x))) (in (priority (l x)) (priorities1 (r1 x)))))))
(assert (=> (disjoint (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (not (and (in k (priorities1 (l1 (r1 x)))) (in k (priorities1 (r1 (r1 x))))))))
(assert (=> (disjoint (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (not (and (in p (priorities1 (l1 (r1 x)))) (in p (priorities1 (r1 (r1 x))))))))
(assert (=> (disjoint (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (not (and (in w1 (priorities1 (l1 (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))))))
(assert (=> (disjoint (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (not (and (in w2 (priorities1 (l1 (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))))))
(assert (=> (disjoint (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (not (and (in (key x) (priorities1 (l1 (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))))))
(assert (=> (disjoint (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (not (and (in (key (r1 x)) (priorities1 (l1 (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))))))
(assert (=> (disjoint (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (not (and (in (key (l x)) (priorities1 (l1 (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))))))
(assert (=> (disjoint (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (not (and (in (priority x) (priorities1 (l1 (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))))))
(assert (=> (disjoint (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (not (and (in (priority (r1 x)) (priorities1 (l1 (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))))))
(assert (=> (disjoint (priorities1 (l1 (r1 x))) (priorities1 (r1 (r1 x)))) (not (and (in (priority (l x)) (priorities1 (l1 (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))))))

(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in k (priorities (l x)))) (< k k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in p (priorities (l x)))) (< k p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in w1 (priorities (l x)))) (< k w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in w2 (priorities (l x)))) (< k w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in (key x) (priorities (l x)))) (< k (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in (key (r1 x)) (priorities (l x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in (key (l x)) (priorities (l x)))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in (priority x) (priorities (l x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in (priority (r1 x)) (priorities (l x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in k (singleton (priority x))) (in (priority (l x)) (priorities (l x)))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in k (priorities (l x)))) (< p k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in p (priorities (l x)))) (< p p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in w1 (priorities (l x)))) (< p w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in w2 (priorities (l x)))) (< p w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in (key x) (priorities (l x)))) (< p (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in (key (r1 x)) (priorities (l x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in (key (l x)) (priorities (l x)))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in (priority x) (priorities (l x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in (priority (r1 x)) (priorities (l x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in p (singleton (priority x))) (in (priority (l x)) (priorities (l x)))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in k (priorities (l x)))) (< w1 k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in p (priorities (l x)))) (< w1 p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in w1 (priorities (l x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in w2 (priorities (l x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in (key x) (priorities (l x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in (key (r1 x)) (priorities (l x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in (key (l x)) (priorities (l x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in (priority x) (priorities (l x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in (priority (r1 x)) (priorities (l x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w1 (singleton (priority x))) (in (priority (l x)) (priorities (l x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in k (priorities (l x)))) (< w2 k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in p (priorities (l x)))) (< w2 p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in w1 (priorities (l x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in w2 (priorities (l x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in (key x) (priorities (l x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in (key (r1 x)) (priorities (l x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in (key (l x)) (priorities (l x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in (priority x) (priorities (l x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in (priority (r1 x)) (priorities (l x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in w2 (singleton (priority x))) (in (priority (l x)) (priorities (l x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in k (priorities (l x)))) (< (key x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in p (priorities (l x)))) (< (key x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in w1 (priorities (l x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in w2 (priorities (l x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in (key x) (priorities (l x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in (key (r1 x)) (priorities (l x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in (key (l x)) (priorities (l x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in (priority x) (priorities (l x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (r1 x)) (priorities (l x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (l x)) (priorities (l x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in k (priorities (l x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in p (priorities (l x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w1 (priorities (l x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w2 (priorities (l x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key x) (priorities (l x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities (l x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities (l x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority x) (priorities (l x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities (l x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities (l x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (l x)) (singleton (priority x))) (in k (priorities (l x)))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (l x)) (singleton (priority x))) (in p (priorities (l x)))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w1 (priorities (l x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w2 (priorities (l x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key x) (priorities (l x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities (l x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (l x)) (priorities (l x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority x) (priorities (l x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities (l x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (l x)) (priorities (l x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in k (priorities (l x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in p (priorities (l x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in w1 (priorities (l x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in w2 (priorities (l x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in (key x) (priorities (l x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (r1 x)) (priorities (l x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (l x)) (priorities (l x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority x) (priorities (l x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (r1 x)) (priorities (l x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (l x)) (priorities (l x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in k (priorities (l x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in p (priorities (l x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w1 (priorities (l x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w2 (priorities (l x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key x) (priorities (l x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities (l x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities (l x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority x) (priorities (l x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities (l x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities (l x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in k (priorities (l x)))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in p (priorities (l x)))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w1 (priorities (l x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w2 (priorities (l x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key x) (priorities (l x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities (l x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (l x)) (priorities (l x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority x) (priorities (l x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities (l x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (l x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (l x)) (priorities (l x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in k (singleton (key x)))) (< k k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in p (singleton (key x)))) (< k p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in w1 (singleton (key x)))) (< k w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in w2 (singleton (key x)))) (< k w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in (key x) (singleton (key x)))) (< k (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in (key (r1 x)) (singleton (key x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in (key (l x)) (singleton (key x)))) (< k (key (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in (priority x) (singleton (key x)))) (< k (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in (priority (r1 x)) (singleton (key x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in k (keys (l x))) (in (priority (l x)) (singleton (key x)))) (< k (priority (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in k (singleton (key x)))) (< p k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in p (singleton (key x)))) (< p p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in w1 (singleton (key x)))) (< p w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in w2 (singleton (key x)))) (< p w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in (key x) (singleton (key x)))) (< p (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in (key (r1 x)) (singleton (key x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in (key (l x)) (singleton (key x)))) (< p (key (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in (priority x) (singleton (key x)))) (< p (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in (priority (r1 x)) (singleton (key x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in p (keys (l x))) (in (priority (l x)) (singleton (key x)))) (< p (priority (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in k (singleton (key x)))) (< w1 k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in p (singleton (key x)))) (< w1 p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in w1 (singleton (key x)))) (< w1 w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in w2 (singleton (key x)))) (< w1 w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in (key x) (singleton (key x)))) (< w1 (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in (key (r1 x)) (singleton (key x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in (key (l x)) (singleton (key x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in (priority x) (singleton (key x)))) (< w1 (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in (priority (r1 x)) (singleton (key x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w1 (keys (l x))) (in (priority (l x)) (singleton (key x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in k (singleton (key x)))) (< w2 k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in p (singleton (key x)))) (< w2 p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in w1 (singleton (key x)))) (< w2 w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in w2 (singleton (key x)))) (< w2 w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in (key x) (singleton (key x)))) (< w2 (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in (key (r1 x)) (singleton (key x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in (key (l x)) (singleton (key x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in (priority x) (singleton (key x)))) (< w2 (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in (priority (r1 x)) (singleton (key x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in w2 (keys (l x))) (in (priority (l x)) (singleton (key x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in k (singleton (key x)))) (< (key x) k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in p (singleton (key x)))) (< (key x) p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in w1 (singleton (key x)))) (< (key x) w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in w2 (singleton (key x)))) (< (key x) w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in (key x) (singleton (key x)))) (< (key x) (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in (key (r1 x)) (singleton (key x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in (key (l x)) (singleton (key x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in (priority x) (singleton (key x)))) (< (key x) (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in (priority (r1 x)) (singleton (key x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key x) (keys (l x))) (in (priority (l x)) (singleton (key x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys (l x))) (in k (singleton (key x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys (l x))) (in p (singleton (key x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys (l x))) (in w1 (singleton (key x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys (l x))) (in w2 (singleton (key x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys (l x))) (in (key x) (singleton (key x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys (l x))) (in (key (r1 x)) (singleton (key x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys (l x))) (in (key (l x)) (singleton (key x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys (l x))) (in (priority x) (singleton (key x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys (l x))) (in (priority (r1 x)) (singleton (key x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys (l x))) (in (priority (l x)) (singleton (key x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (l x)) (keys (l x))) (in k (singleton (key x)))) (< (key (l x)) k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (l x)) (keys (l x))) (in p (singleton (key x)))) (< (key (l x)) p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (l x)) (keys (l x))) (in w1 (singleton (key x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (l x)) (keys (l x))) (in w2 (singleton (key x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (l x)) (keys (l x))) (in (key x) (singleton (key x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (l x)) (keys (l x))) (in (key (r1 x)) (singleton (key x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (l x)) (keys (l x))) (in (key (l x)) (singleton (key x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (l x)) (keys (l x))) (in (priority x) (singleton (key x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (l x)) (keys (l x))) (in (priority (r1 x)) (singleton (key x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (key (l x)) (keys (l x))) (in (priority (l x)) (singleton (key x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in k (singleton (key x)))) (< (priority x) k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in p (singleton (key x)))) (< (priority x) p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in w1 (singleton (key x)))) (< (priority x) w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in w2 (singleton (key x)))) (< (priority x) w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in (key x) (singleton (key x)))) (< (priority x) (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in (key (r1 x)) (singleton (key x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in (key (l x)) (singleton (key x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in (priority x) (singleton (key x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in (priority (r1 x)) (singleton (key x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority x) (keys (l x))) (in (priority (l x)) (singleton (key x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys (l x))) (in k (singleton (key x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys (l x))) (in p (singleton (key x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys (l x))) (in w1 (singleton (key x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys (l x))) (in w2 (singleton (key x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys (l x))) (in (key x) (singleton (key x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys (l x))) (in (key (r1 x)) (singleton (key x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys (l x))) (in (key (l x)) (singleton (key x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys (l x))) (in (priority x) (singleton (key x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys (l x))) (in (priority (r1 x)) (singleton (key x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys (l x))) (in (priority (l x)) (singleton (key x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys (l x))) (in k (singleton (key x)))) (< (priority (l x)) k ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys (l x))) (in p (singleton (key x)))) (< (priority (l x)) p ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys (l x))) (in w1 (singleton (key x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys (l x))) (in w2 (singleton (key x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys (l x))) (in (key x) (singleton (key x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys (l x))) (in (key (r1 x)) (singleton (key x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys (l x))) (in (key (l x)) (singleton (key x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys (l x))) (in (priority x) (singleton (key x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys (l x))) (in (priority (r1 x)) (singleton (key x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys (l x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys (l x))) (in (priority (l x)) (singleton (key x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in k (priorities (r x)))) (< k k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in p (priorities (r x)))) (< k p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in w1 (priorities (r x)))) (< k w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in w2 (priorities (r x)))) (< k w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in (key x) (priorities (r x)))) (< k (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in (key (r1 x)) (priorities (r x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in (key (l x)) (priorities (r x)))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in (priority x) (priorities (r x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in (priority (r1 x)) (priorities (r x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in k (singleton (priority x))) (in (priority (l x)) (priorities (r x)))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in k (priorities (r x)))) (< p k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in p (priorities (r x)))) (< p p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in w1 (priorities (r x)))) (< p w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in w2 (priorities (r x)))) (< p w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in (key x) (priorities (r x)))) (< p (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in (key (r1 x)) (priorities (r x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in (key (l x)) (priorities (r x)))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in (priority x) (priorities (r x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in (priority (r1 x)) (priorities (r x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in p (singleton (priority x))) (in (priority (l x)) (priorities (r x)))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in k (priorities (r x)))) (< w1 k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in p (priorities (r x)))) (< w1 p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in w1 (priorities (r x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in w2 (priorities (r x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in (key x) (priorities (r x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in (key (r1 x)) (priorities (r x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in (key (l x)) (priorities (r x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in (priority x) (priorities (r x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in (priority (r1 x)) (priorities (r x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w1 (singleton (priority x))) (in (priority (l x)) (priorities (r x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in k (priorities (r x)))) (< w2 k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in p (priorities (r x)))) (< w2 p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in w1 (priorities (r x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in w2 (priorities (r x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in (key x) (priorities (r x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in (key (r1 x)) (priorities (r x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in (key (l x)) (priorities (r x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in (priority x) (priorities (r x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in (priority (r1 x)) (priorities (r x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in w2 (singleton (priority x))) (in (priority (l x)) (priorities (r x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in k (priorities (r x)))) (< (key x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in p (priorities (r x)))) (< (key x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in w1 (priorities (r x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in w2 (priorities (r x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in (key x) (priorities (r x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in (key (r1 x)) (priorities (r x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in (key (l x)) (priorities (r x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in (priority x) (priorities (r x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (r1 x)) (priorities (r x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (l x)) (priorities (r x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in k (priorities (r x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in p (priorities (r x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w1 (priorities (r x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w2 (priorities (r x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key x) (priorities (r x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities (r x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities (r x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority x) (priorities (r x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities (r x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities (r x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (l x)) (singleton (priority x))) (in k (priorities (r x)))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (l x)) (singleton (priority x))) (in p (priorities (r x)))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w1 (priorities (r x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w2 (priorities (r x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key x) (priorities (r x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities (r x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (l x)) (priorities (r x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority x) (priorities (r x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities (r x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (l x)) (priorities (r x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in k (priorities (r x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in p (priorities (r x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in w1 (priorities (r x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in w2 (priorities (r x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in (key x) (priorities (r x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (r1 x)) (priorities (r x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (l x)) (priorities (r x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority x) (priorities (r x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (r1 x)) (priorities (r x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (l x)) (priorities (r x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in k (priorities (r x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in p (priorities (r x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w1 (priorities (r x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w2 (priorities (r x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key x) (priorities (r x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities (r x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities (r x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority x) (priorities (r x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities (r x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities (r x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in k (priorities (r x)))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in p (priorities (r x)))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w1 (priorities (r x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w2 (priorities (r x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key x) (priorities (r x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities (r x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (l x)) (priorities (r x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority x) (priorities (r x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities (r x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities (r x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (l x)) (priorities (r x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in k (keys (r x)))) (< k k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in p (keys (r x)))) (< k p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in w1 (keys (r x)))) (< k w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in w2 (keys (r x)))) (< k w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in (key x) (keys (r x)))) (< k (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in (key (r1 x)) (keys (r x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in (key (l x)) (keys (r x)))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in (priority x) (keys (r x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in (priority (r1 x)) (keys (r x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in k (singleton (key x))) (in (priority (l x)) (keys (r x)))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in k (keys (r x)))) (< p k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in p (keys (r x)))) (< p p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in w1 (keys (r x)))) (< p w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in w2 (keys (r x)))) (< p w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in (key x) (keys (r x)))) (< p (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in (key (r1 x)) (keys (r x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in (key (l x)) (keys (r x)))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in (priority x) (keys (r x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in (priority (r1 x)) (keys (r x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in p (singleton (key x))) (in (priority (l x)) (keys (r x)))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in k (keys (r x)))) (< w1 k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in p (keys (r x)))) (< w1 p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in w1 (keys (r x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in w2 (keys (r x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in (key x) (keys (r x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in (key (r1 x)) (keys (r x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in (key (l x)) (keys (r x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in (priority x) (keys (r x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in (priority (r1 x)) (keys (r x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w1 (singleton (key x))) (in (priority (l x)) (keys (r x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in k (keys (r x)))) (< w2 k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in p (keys (r x)))) (< w2 p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in w1 (keys (r x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in w2 (keys (r x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in (key x) (keys (r x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in (key (r1 x)) (keys (r x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in (key (l x)) (keys (r x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in (priority x) (keys (r x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in (priority (r1 x)) (keys (r x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in w2 (singleton (key x))) (in (priority (l x)) (keys (r x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in k (keys (r x)))) (< (key x) k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in p (keys (r x)))) (< (key x) p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in w1 (keys (r x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in w2 (keys (r x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in (key x) (keys (r x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in (key (r1 x)) (keys (r x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in (key (l x)) (keys (r x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in (priority x) (keys (r x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in (priority (r1 x)) (keys (r x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key x) (singleton (key x))) (in (priority (l x)) (keys (r x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in k (keys (r x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in p (keys (r x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in w1 (keys (r x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in w2 (keys (r x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (key x) (keys (r x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (key (r1 x)) (keys (r x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (key (l x)) (keys (r x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (priority x) (keys (r x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (priority (r1 x)) (keys (r x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (priority (l x)) (keys (r x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (l x)) (singleton (key x))) (in k (keys (r x)))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (l x)) (singleton (key x))) (in p (keys (r x)))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (l x)) (singleton (key x))) (in w1 (keys (r x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (l x)) (singleton (key x))) (in w2 (keys (r x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (l x)) (singleton (key x))) (in (key x) (keys (r x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (l x)) (singleton (key x))) (in (key (r1 x)) (keys (r x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (l x)) (singleton (key x))) (in (key (l x)) (keys (r x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (l x)) (singleton (key x))) (in (priority x) (keys (r x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (l x)) (singleton (key x))) (in (priority (r1 x)) (keys (r x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (key (l x)) (singleton (key x))) (in (priority (l x)) (keys (r x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in k (keys (r x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in p (keys (r x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in w1 (keys (r x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in w2 (keys (r x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in (key x) (keys (r x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in (key (r1 x)) (keys (r x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in (key (l x)) (keys (r x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in (priority x) (keys (r x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in (priority (r1 x)) (keys (r x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority x) (singleton (key x))) (in (priority (l x)) (keys (r x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in k (keys (r x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in p (keys (r x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in w1 (keys (r x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in w2 (keys (r x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (key x) (keys (r x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (key (r1 x)) (keys (r x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (key (l x)) (keys (r x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (priority x) (keys (r x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (priority (r1 x)) (keys (r x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (priority (l x)) (keys (r x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (l x)) (singleton (key x))) (in k (keys (r x)))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (l x)) (singleton (key x))) (in p (keys (r x)))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (l x)) (singleton (key x))) (in w1 (keys (r x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (l x)) (singleton (key x))) (in w2 (keys (r x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (key x) (keys (r x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (key (r1 x)) (keys (r x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (key (l x)) (keys (r x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (priority x) (keys (r x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (priority (r1 x)) (keys (r x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys (r x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (priority (l x)) (keys (r x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in k (singleton (priority x))) (in k (priorities' (l' x)))) (< k k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in k (singleton (priority x))) (in p (priorities' (l' x)))) (< k p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in k (singleton (priority x))) (in w1 (priorities' (l' x)))) (< k w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in k (singleton (priority x))) (in w2 (priorities' (l' x)))) (< k w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in k (singleton (priority x))) (in (key x) (priorities' (l' x)))) (< k (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in k (singleton (priority x))) (in (key (r1 x)) (priorities' (l' x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in k (singleton (priority x))) (in (key (l x)) (priorities' (l' x)))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in k (singleton (priority x))) (in (priority x) (priorities' (l' x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in k (singleton (priority x))) (in (priority (r1 x)) (priorities' (l' x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in k (singleton (priority x))) (in (priority (l x)) (priorities' (l' x)))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in p (singleton (priority x))) (in k (priorities' (l' x)))) (< p k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in p (singleton (priority x))) (in p (priorities' (l' x)))) (< p p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in p (singleton (priority x))) (in w1 (priorities' (l' x)))) (< p w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in p (singleton (priority x))) (in w2 (priorities' (l' x)))) (< p w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in p (singleton (priority x))) (in (key x) (priorities' (l' x)))) (< p (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in p (singleton (priority x))) (in (key (r1 x)) (priorities' (l' x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in p (singleton (priority x))) (in (key (l x)) (priorities' (l' x)))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in p (singleton (priority x))) (in (priority x) (priorities' (l' x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in p (singleton (priority x))) (in (priority (r1 x)) (priorities' (l' x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in p (singleton (priority x))) (in (priority (l x)) (priorities' (l' x)))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w1 (singleton (priority x))) (in k (priorities' (l' x)))) (< w1 k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w1 (singleton (priority x))) (in p (priorities' (l' x)))) (< w1 p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w1 (singleton (priority x))) (in w1 (priorities' (l' x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w1 (singleton (priority x))) (in w2 (priorities' (l' x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w1 (singleton (priority x))) (in (key x) (priorities' (l' x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w1 (singleton (priority x))) (in (key (r1 x)) (priorities' (l' x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w1 (singleton (priority x))) (in (key (l x)) (priorities' (l' x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w1 (singleton (priority x))) (in (priority x) (priorities' (l' x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w1 (singleton (priority x))) (in (priority (r1 x)) (priorities' (l' x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w1 (singleton (priority x))) (in (priority (l x)) (priorities' (l' x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w2 (singleton (priority x))) (in k (priorities' (l' x)))) (< w2 k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w2 (singleton (priority x))) (in p (priorities' (l' x)))) (< w2 p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w2 (singleton (priority x))) (in w1 (priorities' (l' x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w2 (singleton (priority x))) (in w2 (priorities' (l' x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w2 (singleton (priority x))) (in (key x) (priorities' (l' x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w2 (singleton (priority x))) (in (key (r1 x)) (priorities' (l' x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w2 (singleton (priority x))) (in (key (l x)) (priorities' (l' x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w2 (singleton (priority x))) (in (priority x) (priorities' (l' x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w2 (singleton (priority x))) (in (priority (r1 x)) (priorities' (l' x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in w2 (singleton (priority x))) (in (priority (l x)) (priorities' (l' x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key x) (singleton (priority x))) (in k (priorities' (l' x)))) (< (key x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key x) (singleton (priority x))) (in p (priorities' (l' x)))) (< (key x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key x) (singleton (priority x))) (in w1 (priorities' (l' x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key x) (singleton (priority x))) (in w2 (priorities' (l' x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key x) (singleton (priority x))) (in (key x) (priorities' (l' x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key x) (singleton (priority x))) (in (key (r1 x)) (priorities' (l' x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key x) (singleton (priority x))) (in (key (l x)) (priorities' (l' x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key x) (singleton (priority x))) (in (priority x) (priorities' (l' x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (r1 x)) (priorities' (l' x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (l x)) (priorities' (l' x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in k (priorities' (l' x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in p (priorities' (l' x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w1 (priorities' (l' x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w2 (priorities' (l' x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key x) (priorities' (l' x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities' (l' x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities' (l' x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority x) (priorities' (l' x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities' (l' x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities' (l' x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in k (priorities' (l' x)))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in p (priorities' (l' x)))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w1 (priorities' (l' x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w2 (priorities' (l' x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key x) (priorities' (l' x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities' (l' x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (l x)) (priorities' (l' x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority x) (priorities' (l' x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities' (l' x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (l x)) (priorities' (l' x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority x) (singleton (priority x))) (in k (priorities' (l' x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority x) (singleton (priority x))) (in p (priorities' (l' x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority x) (singleton (priority x))) (in w1 (priorities' (l' x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority x) (singleton (priority x))) (in w2 (priorities' (l' x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority x) (singleton (priority x))) (in (key x) (priorities' (l' x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (r1 x)) (priorities' (l' x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (l x)) (priorities' (l' x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority x) (priorities' (l' x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (r1 x)) (priorities' (l' x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (l x)) (priorities' (l' x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in k (priorities' (l' x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in p (priorities' (l' x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w1 (priorities' (l' x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w2 (priorities' (l' x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key x) (priorities' (l' x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities' (l' x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities' (l' x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority x) (priorities' (l' x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities' (l' x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities' (l' x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in k (priorities' (l' x)))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in p (priorities' (l' x)))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w1 (priorities' (l' x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w2 (priorities' (l' x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key x) (priorities' (l' x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities' (l' x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (l x)) (priorities' (l' x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority x) (priorities' (l' x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities' (l' x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (l' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (l x)) (priorities' (l' x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in k (priorities' (l' (l x))))) (< k k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in p (priorities' (l' (l x))))) (< k p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in w1 (priorities' (l' (l x))))) (< k w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in w2 (priorities' (l' (l x))))) (< k w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (key x) (priorities' (l' (l x))))) (< k (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (l' (l x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (key (l x)) (priorities' (l' (l x))))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (priority x) (priorities' (l' (l x))))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (l' (l x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (priority (l x)) (priorities' (l' (l x))))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in k (priorities' (l' (l x))))) (< p k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in p (priorities' (l' (l x))))) (< p p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in w1 (priorities' (l' (l x))))) (< p w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in w2 (priorities' (l' (l x))))) (< p w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (key x) (priorities' (l' (l x))))) (< p (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (l' (l x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (key (l x)) (priorities' (l' (l x))))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (priority x) (priorities' (l' (l x))))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (l' (l x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (priority (l x)) (priorities' (l' (l x))))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in k (priorities' (l' (l x))))) (< w1 k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in p (priorities' (l' (l x))))) (< w1 p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in w1 (priorities' (l' (l x))))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in w2 (priorities' (l' (l x))))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (key x) (priorities' (l' (l x))))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (l' (l x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (key (l x)) (priorities' (l' (l x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (priority x) (priorities' (l' (l x))))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (l' (l x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (priority (l x)) (priorities' (l' (l x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in k (priorities' (l' (l x))))) (< w2 k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in p (priorities' (l' (l x))))) (< w2 p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in w1 (priorities' (l' (l x))))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in w2 (priorities' (l' (l x))))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (key x) (priorities' (l' (l x))))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (l' (l x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (key (l x)) (priorities' (l' (l x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (priority x) (priorities' (l' (l x))))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (l' (l x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (priority (l x)) (priorities' (l' (l x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in k (priorities' (l' (l x))))) (< (key x) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in p (priorities' (l' (l x))))) (< (key x) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in w1 (priorities' (l' (l x))))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in w2 (priorities' (l' (l x))))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (key x) (priorities' (l' (l x))))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (l' (l x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (key (l x)) (priorities' (l' (l x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (priority x) (priorities' (l' (l x))))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (l' (l x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (l' (l x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in k (priorities' (l' (l x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in p (priorities' (l' (l x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in w1 (priorities' (l' (l x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in w2 (priorities' (l' (l x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (key x) (priorities' (l' (l x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (l' (l x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (key (l x)) (priorities' (l' (l x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (priority x) (priorities' (l' (l x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (l' (l x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (l' (l x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in k (priorities' (l' (l x))))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in p (priorities' (l' (l x))))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in w1 (priorities' (l' (l x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in w2 (priorities' (l' (l x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (key x) (priorities' (l' (l x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (l' (l x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (key (l x)) (priorities' (l' (l x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (priority x) (priorities' (l' (l x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (l' (l x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (l' (l x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in k (priorities' (l' (l x))))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in p (priorities' (l' (l x))))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in w1 (priorities' (l' (l x))))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in w2 (priorities' (l' (l x))))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (key x) (priorities' (l' (l x))))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (l' (l x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (key (l x)) (priorities' (l' (l x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (priority x) (priorities' (l' (l x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (l' (l x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (l' (l x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in k (priorities' (l' (l x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in p (priorities' (l' (l x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in w1 (priorities' (l' (l x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in w2 (priorities' (l' (l x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (key x) (priorities' (l' (l x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (l' (l x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (key (l x)) (priorities' (l' (l x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (priority x) (priorities' (l' (l x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (l' (l x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (l' (l x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in k (priorities' (l' (l x))))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in p (priorities' (l' (l x))))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in w1 (priorities' (l' (l x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in w2 (priorities' (l' (l x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (key x) (priorities' (l' (l x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (l' (l x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (key (l x)) (priorities' (l' (l x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (priority x) (priorities' (l' (l x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (l' (l x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (l' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (l' (l x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in k (keys' (l' x))) (in k (singleton (key x)))) (< k k ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in k (keys' (l' x))) (in p (singleton (key x)))) (< k p ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in k (keys' (l' x))) (in w1 (singleton (key x)))) (< k w1 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in k (keys' (l' x))) (in w2 (singleton (key x)))) (< k w2 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in k (keys' (l' x))) (in (key x) (singleton (key x)))) (< k (key x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in k (keys' (l' x))) (in (key (r1 x)) (singleton (key x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in k (keys' (l' x))) (in (key (l x)) (singleton (key x)))) (< k (key (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in k (keys' (l' x))) (in (priority x) (singleton (key x)))) (< k (priority x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in k (keys' (l' x))) (in (priority (r1 x)) (singleton (key x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in k (keys' (l' x))) (in (priority (l x)) (singleton (key x)))) (< k (priority (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in p (keys' (l' x))) (in k (singleton (key x)))) (< p k ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in p (keys' (l' x))) (in p (singleton (key x)))) (< p p ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in p (keys' (l' x))) (in w1 (singleton (key x)))) (< p w1 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in p (keys' (l' x))) (in w2 (singleton (key x)))) (< p w2 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in p (keys' (l' x))) (in (key x) (singleton (key x)))) (< p (key x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in p (keys' (l' x))) (in (key (r1 x)) (singleton (key x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in p (keys' (l' x))) (in (key (l x)) (singleton (key x)))) (< p (key (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in p (keys' (l' x))) (in (priority x) (singleton (key x)))) (< p (priority x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in p (keys' (l' x))) (in (priority (r1 x)) (singleton (key x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in p (keys' (l' x))) (in (priority (l x)) (singleton (key x)))) (< p (priority (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w1 (keys' (l' x))) (in k (singleton (key x)))) (< w1 k ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w1 (keys' (l' x))) (in p (singleton (key x)))) (< w1 p ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w1 (keys' (l' x))) (in w1 (singleton (key x)))) (< w1 w1 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w1 (keys' (l' x))) (in w2 (singleton (key x)))) (< w1 w2 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w1 (keys' (l' x))) (in (key x) (singleton (key x)))) (< w1 (key x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w1 (keys' (l' x))) (in (key (r1 x)) (singleton (key x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w1 (keys' (l' x))) (in (key (l x)) (singleton (key x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w1 (keys' (l' x))) (in (priority x) (singleton (key x)))) (< w1 (priority x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w1 (keys' (l' x))) (in (priority (r1 x)) (singleton (key x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w1 (keys' (l' x))) (in (priority (l x)) (singleton (key x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w2 (keys' (l' x))) (in k (singleton (key x)))) (< w2 k ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w2 (keys' (l' x))) (in p (singleton (key x)))) (< w2 p ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w2 (keys' (l' x))) (in w1 (singleton (key x)))) (< w2 w1 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w2 (keys' (l' x))) (in w2 (singleton (key x)))) (< w2 w2 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w2 (keys' (l' x))) (in (key x) (singleton (key x)))) (< w2 (key x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w2 (keys' (l' x))) (in (key (r1 x)) (singleton (key x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w2 (keys' (l' x))) (in (key (l x)) (singleton (key x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w2 (keys' (l' x))) (in (priority x) (singleton (key x)))) (< w2 (priority x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w2 (keys' (l' x))) (in (priority (r1 x)) (singleton (key x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in w2 (keys' (l' x))) (in (priority (l x)) (singleton (key x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key x) (keys' (l' x))) (in k (singleton (key x)))) (< (key x) k ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key x) (keys' (l' x))) (in p (singleton (key x)))) (< (key x) p ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key x) (keys' (l' x))) (in w1 (singleton (key x)))) (< (key x) w1 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key x) (keys' (l' x))) (in w2 (singleton (key x)))) (< (key x) w2 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key x) (keys' (l' x))) (in (key x) (singleton (key x)))) (< (key x) (key x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key x) (keys' (l' x))) (in (key (r1 x)) (singleton (key x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key x) (keys' (l' x))) (in (key (l x)) (singleton (key x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key x) (keys' (l' x))) (in (priority x) (singleton (key x)))) (< (key x) (priority x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key x) (keys' (l' x))) (in (priority (r1 x)) (singleton (key x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key x) (keys' (l' x))) (in (priority (l x)) (singleton (key x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys' (l' x))) (in k (singleton (key x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys' (l' x))) (in p (singleton (key x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys' (l' x))) (in w1 (singleton (key x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys' (l' x))) (in w2 (singleton (key x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys' (l' x))) (in (key x) (singleton (key x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys' (l' x))) (in (key (r1 x)) (singleton (key x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys' (l' x))) (in (key (l x)) (singleton (key x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys' (l' x))) (in (priority x) (singleton (key x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys' (l' x))) (in (priority (r1 x)) (singleton (key x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys' (l' x))) (in (priority (l x)) (singleton (key x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (l x)) (keys' (l' x))) (in k (singleton (key x)))) (< (key (l x)) k ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (l x)) (keys' (l' x))) (in p (singleton (key x)))) (< (key (l x)) p ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (l x)) (keys' (l' x))) (in w1 (singleton (key x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (l x)) (keys' (l' x))) (in w2 (singleton (key x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (l x)) (keys' (l' x))) (in (key x) (singleton (key x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (l x)) (keys' (l' x))) (in (key (r1 x)) (singleton (key x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (l x)) (keys' (l' x))) (in (key (l x)) (singleton (key x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (l x)) (keys' (l' x))) (in (priority x) (singleton (key x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (l x)) (keys' (l' x))) (in (priority (r1 x)) (singleton (key x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (key (l x)) (keys' (l' x))) (in (priority (l x)) (singleton (key x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority x) (keys' (l' x))) (in k (singleton (key x)))) (< (priority x) k ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority x) (keys' (l' x))) (in p (singleton (key x)))) (< (priority x) p ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority x) (keys' (l' x))) (in w1 (singleton (key x)))) (< (priority x) w1 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority x) (keys' (l' x))) (in w2 (singleton (key x)))) (< (priority x) w2 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority x) (keys' (l' x))) (in (key x) (singleton (key x)))) (< (priority x) (key x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority x) (keys' (l' x))) (in (key (r1 x)) (singleton (key x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority x) (keys' (l' x))) (in (key (l x)) (singleton (key x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority x) (keys' (l' x))) (in (priority x) (singleton (key x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority x) (keys' (l' x))) (in (priority (r1 x)) (singleton (key x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority x) (keys' (l' x))) (in (priority (l x)) (singleton (key x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys' (l' x))) (in k (singleton (key x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys' (l' x))) (in p (singleton (key x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys' (l' x))) (in w1 (singleton (key x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys' (l' x))) (in w2 (singleton (key x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys' (l' x))) (in (key x) (singleton (key x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys' (l' x))) (in (key (r1 x)) (singleton (key x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys' (l' x))) (in (key (l x)) (singleton (key x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys' (l' x))) (in (priority x) (singleton (key x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys' (l' x))) (in (priority (r1 x)) (singleton (key x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys' (l' x))) (in (priority (l x)) (singleton (key x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys' (l' x))) (in k (singleton (key x)))) (< (priority (l x)) k ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys' (l' x))) (in p (singleton (key x)))) (< (priority (l x)) p ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys' (l' x))) (in w1 (singleton (key x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys' (l' x))) (in w2 (singleton (key x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys' (l' x))) (in (key x) (singleton (key x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys' (l' x))) (in (key (r1 x)) (singleton (key x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys' (l' x))) (in (key (l x)) (singleton (key x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys' (l' x))) (in (priority x) (singleton (key x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys' (l' x))) (in (priority (r1 x)) (singleton (key x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys' (l' x))) (in (priority (l x)) (singleton (key x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in k (keys' (l' (l x)))) (in k (singleton (key (l x))))) (< k k ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in k (keys' (l' (l x)))) (in p (singleton (key (l x))))) (< k p ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in k (keys' (l' (l x)))) (in w1 (singleton (key (l x))))) (< k w1 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in k (keys' (l' (l x)))) (in w2 (singleton (key (l x))))) (< k w2 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in k (keys' (l' (l x)))) (in (key x) (singleton (key (l x))))) (< k (key x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in k (keys' (l' (l x)))) (in (key (r1 x)) (singleton (key (l x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in k (keys' (l' (l x)))) (in (key (l x)) (singleton (key (l x))))) (< k (key (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in k (keys' (l' (l x)))) (in (priority x) (singleton (key (l x))))) (< k (priority x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in k (keys' (l' (l x)))) (in (priority (r1 x)) (singleton (key (l x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in k (keys' (l' (l x)))) (in (priority (l x)) (singleton (key (l x))))) (< k (priority (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in p (keys' (l' (l x)))) (in k (singleton (key (l x))))) (< p k ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in p (keys' (l' (l x)))) (in p (singleton (key (l x))))) (< p p ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in p (keys' (l' (l x)))) (in w1 (singleton (key (l x))))) (< p w1 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in p (keys' (l' (l x)))) (in w2 (singleton (key (l x))))) (< p w2 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in p (keys' (l' (l x)))) (in (key x) (singleton (key (l x))))) (< p (key x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in p (keys' (l' (l x)))) (in (key (r1 x)) (singleton (key (l x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in p (keys' (l' (l x)))) (in (key (l x)) (singleton (key (l x))))) (< p (key (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in p (keys' (l' (l x)))) (in (priority x) (singleton (key (l x))))) (< p (priority x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in p (keys' (l' (l x)))) (in (priority (r1 x)) (singleton (key (l x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in p (keys' (l' (l x)))) (in (priority (l x)) (singleton (key (l x))))) (< p (priority (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w1 (keys' (l' (l x)))) (in k (singleton (key (l x))))) (< w1 k ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w1 (keys' (l' (l x)))) (in p (singleton (key (l x))))) (< w1 p ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w1 (keys' (l' (l x)))) (in w1 (singleton (key (l x))))) (< w1 w1 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w1 (keys' (l' (l x)))) (in w2 (singleton (key (l x))))) (< w1 w2 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w1 (keys' (l' (l x)))) (in (key x) (singleton (key (l x))))) (< w1 (key x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w1 (keys' (l' (l x)))) (in (key (r1 x)) (singleton (key (l x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w1 (keys' (l' (l x)))) (in (key (l x)) (singleton (key (l x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w1 (keys' (l' (l x)))) (in (priority x) (singleton (key (l x))))) (< w1 (priority x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w1 (keys' (l' (l x)))) (in (priority (r1 x)) (singleton (key (l x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w1 (keys' (l' (l x)))) (in (priority (l x)) (singleton (key (l x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w2 (keys' (l' (l x)))) (in k (singleton (key (l x))))) (< w2 k ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w2 (keys' (l' (l x)))) (in p (singleton (key (l x))))) (< w2 p ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w2 (keys' (l' (l x)))) (in w1 (singleton (key (l x))))) (< w2 w1 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w2 (keys' (l' (l x)))) (in w2 (singleton (key (l x))))) (< w2 w2 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w2 (keys' (l' (l x)))) (in (key x) (singleton (key (l x))))) (< w2 (key x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w2 (keys' (l' (l x)))) (in (key (r1 x)) (singleton (key (l x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w2 (keys' (l' (l x)))) (in (key (l x)) (singleton (key (l x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w2 (keys' (l' (l x)))) (in (priority x) (singleton (key (l x))))) (< w2 (priority x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w2 (keys' (l' (l x)))) (in (priority (r1 x)) (singleton (key (l x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in w2 (keys' (l' (l x)))) (in (priority (l x)) (singleton (key (l x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key x) (keys' (l' (l x)))) (in k (singleton (key (l x))))) (< (key x) k ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key x) (keys' (l' (l x)))) (in p (singleton (key (l x))))) (< (key x) p ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key x) (keys' (l' (l x)))) (in w1 (singleton (key (l x))))) (< (key x) w1 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key x) (keys' (l' (l x)))) (in w2 (singleton (key (l x))))) (< (key x) w2 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key x) (keys' (l' (l x)))) (in (key x) (singleton (key (l x))))) (< (key x) (key x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key x) (keys' (l' (l x)))) (in (key (r1 x)) (singleton (key (l x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key x) (keys' (l' (l x)))) (in (key (l x)) (singleton (key (l x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key x) (keys' (l' (l x)))) (in (priority x) (singleton (key (l x))))) (< (key x) (priority x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key x) (keys' (l' (l x)))) (in (priority (r1 x)) (singleton (key (l x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key x) (keys' (l' (l x)))) (in (priority (l x)) (singleton (key (l x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (r1 x)) (keys' (l' (l x)))) (in k (singleton (key (l x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (r1 x)) (keys' (l' (l x)))) (in p (singleton (key (l x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (r1 x)) (keys' (l' (l x)))) (in w1 (singleton (key (l x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (r1 x)) (keys' (l' (l x)))) (in w2 (singleton (key (l x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (r1 x)) (keys' (l' (l x)))) (in (key x) (singleton (key (l x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (r1 x)) (keys' (l' (l x)))) (in (key (r1 x)) (singleton (key (l x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (r1 x)) (keys' (l' (l x)))) (in (key (l x)) (singleton (key (l x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (r1 x)) (keys' (l' (l x)))) (in (priority x) (singleton (key (l x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (r1 x)) (keys' (l' (l x)))) (in (priority (r1 x)) (singleton (key (l x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (r1 x)) (keys' (l' (l x)))) (in (priority (l x)) (singleton (key (l x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (l x)) (keys' (l' (l x)))) (in k (singleton (key (l x))))) (< (key (l x)) k ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (l x)) (keys' (l' (l x)))) (in p (singleton (key (l x))))) (< (key (l x)) p ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (l x)) (keys' (l' (l x)))) (in w1 (singleton (key (l x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (l x)) (keys' (l' (l x)))) (in w2 (singleton (key (l x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (l x)) (keys' (l' (l x)))) (in (key x) (singleton (key (l x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (l x)) (keys' (l' (l x)))) (in (key (r1 x)) (singleton (key (l x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (l x)) (keys' (l' (l x)))) (in (key (l x)) (singleton (key (l x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (l x)) (keys' (l' (l x)))) (in (priority x) (singleton (key (l x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (l x)) (keys' (l' (l x)))) (in (priority (r1 x)) (singleton (key (l x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (key (l x)) (keys' (l' (l x)))) (in (priority (l x)) (singleton (key (l x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority x) (keys' (l' (l x)))) (in k (singleton (key (l x))))) (< (priority x) k ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority x) (keys' (l' (l x)))) (in p (singleton (key (l x))))) (< (priority x) p ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority x) (keys' (l' (l x)))) (in w1 (singleton (key (l x))))) (< (priority x) w1 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority x) (keys' (l' (l x)))) (in w2 (singleton (key (l x))))) (< (priority x) w2 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority x) (keys' (l' (l x)))) (in (key x) (singleton (key (l x))))) (< (priority x) (key x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority x) (keys' (l' (l x)))) (in (key (r1 x)) (singleton (key (l x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority x) (keys' (l' (l x)))) (in (key (l x)) (singleton (key (l x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority x) (keys' (l' (l x)))) (in (priority x) (singleton (key (l x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority x) (keys' (l' (l x)))) (in (priority (r1 x)) (singleton (key (l x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority x) (keys' (l' (l x)))) (in (priority (l x)) (singleton (key (l x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (r1 x)) (keys' (l' (l x)))) (in k (singleton (key (l x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (r1 x)) (keys' (l' (l x)))) (in p (singleton (key (l x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (r1 x)) (keys' (l' (l x)))) (in w1 (singleton (key (l x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (r1 x)) (keys' (l' (l x)))) (in w2 (singleton (key (l x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (r1 x)) (keys' (l' (l x)))) (in (key x) (singleton (key (l x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (r1 x)) (keys' (l' (l x)))) (in (key (r1 x)) (singleton (key (l x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (r1 x)) (keys' (l' (l x)))) (in (key (l x)) (singleton (key (l x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (r1 x)) (keys' (l' (l x)))) (in (priority x) (singleton (key (l x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (r1 x)) (keys' (l' (l x)))) (in (priority (r1 x)) (singleton (key (l x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (r1 x)) (keys' (l' (l x)))) (in (priority (l x)) (singleton (key (l x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (l x)) (keys' (l' (l x)))) (in k (singleton (key (l x))))) (< (priority (l x)) k ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (l x)) (keys' (l' (l x)))) (in p (singleton (key (l x))))) (< (priority (l x)) p ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (l x)) (keys' (l' (l x)))) (in w1 (singleton (key (l x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (l x)) (keys' (l' (l x)))) (in w2 (singleton (key (l x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (l x)) (keys' (l' (l x)))) (in (key x) (singleton (key (l x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (l x)) (keys' (l' (l x)))) (in (key (r1 x)) (singleton (key (l x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (l x)) (keys' (l' (l x)))) (in (key (l x)) (singleton (key (l x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (l x)) (keys' (l' (l x)))) (in (priority x) (singleton (key (l x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (l x)) (keys' (l' (l x)))) (in (priority (r1 x)) (singleton (key (l x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (l x))) (singleton (key (l x)))) (=> (and (in (priority (l x)) (keys' (l' (l x)))) (in (priority (l x)) (singleton (key (l x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in k (singleton (priority x))) (in k (priorities' (r' x)))) (< k k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in k (singleton (priority x))) (in p (priorities' (r' x)))) (< k p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in k (singleton (priority x))) (in w1 (priorities' (r' x)))) (< k w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in k (singleton (priority x))) (in w2 (priorities' (r' x)))) (< k w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in k (singleton (priority x))) (in (key x) (priorities' (r' x)))) (< k (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in k (singleton (priority x))) (in (key (r1 x)) (priorities' (r' x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in k (singleton (priority x))) (in (key (l x)) (priorities' (r' x)))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in k (singleton (priority x))) (in (priority x) (priorities' (r' x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in k (singleton (priority x))) (in (priority (r1 x)) (priorities' (r' x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in k (singleton (priority x))) (in (priority (l x)) (priorities' (r' x)))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in p (singleton (priority x))) (in k (priorities' (r' x)))) (< p k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in p (singleton (priority x))) (in p (priorities' (r' x)))) (< p p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in p (singleton (priority x))) (in w1 (priorities' (r' x)))) (< p w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in p (singleton (priority x))) (in w2 (priorities' (r' x)))) (< p w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in p (singleton (priority x))) (in (key x) (priorities' (r' x)))) (< p (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in p (singleton (priority x))) (in (key (r1 x)) (priorities' (r' x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in p (singleton (priority x))) (in (key (l x)) (priorities' (r' x)))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in p (singleton (priority x))) (in (priority x) (priorities' (r' x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in p (singleton (priority x))) (in (priority (r1 x)) (priorities' (r' x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in p (singleton (priority x))) (in (priority (l x)) (priorities' (r' x)))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w1 (singleton (priority x))) (in k (priorities' (r' x)))) (< w1 k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w1 (singleton (priority x))) (in p (priorities' (r' x)))) (< w1 p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w1 (singleton (priority x))) (in w1 (priorities' (r' x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w1 (singleton (priority x))) (in w2 (priorities' (r' x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w1 (singleton (priority x))) (in (key x) (priorities' (r' x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w1 (singleton (priority x))) (in (key (r1 x)) (priorities' (r' x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w1 (singleton (priority x))) (in (key (l x)) (priorities' (r' x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w1 (singleton (priority x))) (in (priority x) (priorities' (r' x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w1 (singleton (priority x))) (in (priority (r1 x)) (priorities' (r' x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w1 (singleton (priority x))) (in (priority (l x)) (priorities' (r' x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w2 (singleton (priority x))) (in k (priorities' (r' x)))) (< w2 k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w2 (singleton (priority x))) (in p (priorities' (r' x)))) (< w2 p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w2 (singleton (priority x))) (in w1 (priorities' (r' x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w2 (singleton (priority x))) (in w2 (priorities' (r' x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w2 (singleton (priority x))) (in (key x) (priorities' (r' x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w2 (singleton (priority x))) (in (key (r1 x)) (priorities' (r' x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w2 (singleton (priority x))) (in (key (l x)) (priorities' (r' x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w2 (singleton (priority x))) (in (priority x) (priorities' (r' x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w2 (singleton (priority x))) (in (priority (r1 x)) (priorities' (r' x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in w2 (singleton (priority x))) (in (priority (l x)) (priorities' (r' x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key x) (singleton (priority x))) (in k (priorities' (r' x)))) (< (key x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key x) (singleton (priority x))) (in p (priorities' (r' x)))) (< (key x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key x) (singleton (priority x))) (in w1 (priorities' (r' x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key x) (singleton (priority x))) (in w2 (priorities' (r' x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key x) (singleton (priority x))) (in (key x) (priorities' (r' x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key x) (singleton (priority x))) (in (key (r1 x)) (priorities' (r' x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key x) (singleton (priority x))) (in (key (l x)) (priorities' (r' x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key x) (singleton (priority x))) (in (priority x) (priorities' (r' x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (r1 x)) (priorities' (r' x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (l x)) (priorities' (r' x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in k (priorities' (r' x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in p (priorities' (r' x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w1 (priorities' (r' x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w2 (priorities' (r' x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key x) (priorities' (r' x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities' (r' x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities' (r' x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority x) (priorities' (r' x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities' (r' x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities' (r' x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in k (priorities' (r' x)))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in p (priorities' (r' x)))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w1 (priorities' (r' x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w2 (priorities' (r' x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key x) (priorities' (r' x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities' (r' x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (l x)) (priorities' (r' x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority x) (priorities' (r' x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities' (r' x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (l x)) (priorities' (r' x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority x) (singleton (priority x))) (in k (priorities' (r' x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority x) (singleton (priority x))) (in p (priorities' (r' x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority x) (singleton (priority x))) (in w1 (priorities' (r' x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority x) (singleton (priority x))) (in w2 (priorities' (r' x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority x) (singleton (priority x))) (in (key x) (priorities' (r' x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (r1 x)) (priorities' (r' x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (l x)) (priorities' (r' x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority x) (priorities' (r' x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (r1 x)) (priorities' (r' x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (l x)) (priorities' (r' x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in k (priorities' (r' x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in p (priorities' (r' x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w1 (priorities' (r' x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w2 (priorities' (r' x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key x) (priorities' (r' x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities' (r' x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities' (r' x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority x) (priorities' (r' x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities' (r' x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities' (r' x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in k (priorities' (r' x)))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in p (priorities' (r' x)))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w1 (priorities' (r' x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w2 (priorities' (r' x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key x) (priorities' (r' x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities' (r' x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (l x)) (priorities' (r' x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority x) (priorities' (r' x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities' (r' x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities' (r' x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (l x)) (priorities' (r' x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in k (priorities' (r' (l x))))) (< k k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in p (priorities' (r' (l x))))) (< k p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in w1 (priorities' (r' (l x))))) (< k w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in w2 (priorities' (r' (l x))))) (< k w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (key x) (priorities' (r' (l x))))) (< k (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (key (l x)) (priorities' (r' (l x))))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (priority x) (priorities' (r' (l x))))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in k (singleton (priority (l x)))) (in (priority (l x)) (priorities' (r' (l x))))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in k (priorities' (r' (l x))))) (< p k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in p (priorities' (r' (l x))))) (< p p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in w1 (priorities' (r' (l x))))) (< p w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in w2 (priorities' (r' (l x))))) (< p w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (key x) (priorities' (r' (l x))))) (< p (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (key (l x)) (priorities' (r' (l x))))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (priority x) (priorities' (r' (l x))))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in p (singleton (priority (l x)))) (in (priority (l x)) (priorities' (r' (l x))))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in k (priorities' (r' (l x))))) (< w1 k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in p (priorities' (r' (l x))))) (< w1 p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in w1 (priorities' (r' (l x))))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in w2 (priorities' (r' (l x))))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (key x) (priorities' (r' (l x))))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (key (l x)) (priorities' (r' (l x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (priority x) (priorities' (r' (l x))))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w1 (singleton (priority (l x)))) (in (priority (l x)) (priorities' (r' (l x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in k (priorities' (r' (l x))))) (< w2 k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in p (priorities' (r' (l x))))) (< w2 p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in w1 (priorities' (r' (l x))))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in w2 (priorities' (r' (l x))))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (key x) (priorities' (r' (l x))))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (key (l x)) (priorities' (r' (l x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (priority x) (priorities' (r' (l x))))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in w2 (singleton (priority (l x)))) (in (priority (l x)) (priorities' (r' (l x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in k (priorities' (r' (l x))))) (< (key x) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in p (priorities' (r' (l x))))) (< (key x) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in w1 (priorities' (r' (l x))))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in w2 (priorities' (r' (l x))))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (key x) (priorities' (r' (l x))))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (key (l x)) (priorities' (r' (l x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (priority x) (priorities' (r' (l x))))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key x) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (r' (l x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in k (priorities' (r' (l x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in p (priorities' (r' (l x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in w1 (priorities' (r' (l x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in w2 (priorities' (r' (l x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (key x) (priorities' (r' (l x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (key (l x)) (priorities' (r' (l x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (priority x) (priorities' (r' (l x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (r' (l x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in k (priorities' (r' (l x))))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in p (priorities' (r' (l x))))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in w1 (priorities' (r' (l x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in w2 (priorities' (r' (l x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (key x) (priorities' (r' (l x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (key (l x)) (priorities' (r' (l x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (priority x) (priorities' (r' (l x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (key (l x)) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (r' (l x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in k (priorities' (r' (l x))))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in p (priorities' (r' (l x))))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in w1 (priorities' (r' (l x))))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in w2 (priorities' (r' (l x))))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (key x) (priorities' (r' (l x))))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (key (l x)) (priorities' (r' (l x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (priority x) (priorities' (r' (l x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority x) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (r' (l x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in k (priorities' (r' (l x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in p (priorities' (r' (l x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in w1 (priorities' (r' (l x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in w2 (priorities' (r' (l x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (key x) (priorities' (r' (l x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (key (l x)) (priorities' (r' (l x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (priority x) (priorities' (r' (l x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (r' (l x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in k (priorities' (r' (l x))))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in p (priorities' (r' (l x))))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in w1 (priorities' (r' (l x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in w2 (priorities' (r' (l x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (key x) (priorities' (r' (l x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (key (r1 x)) (priorities' (r' (l x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (key (l x)) (priorities' (r' (l x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (priority x) (priorities' (r' (l x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (priority (r1 x)) (priorities' (r' (l x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (l x))) (priorities' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (priority (l x)))) (in (priority (l x)) (priorities' (r' (l x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in k (singleton (key x))) (in k (keys' (r' x)))) (< k k ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in k (singleton (key x))) (in p (keys' (r' x)))) (< k p ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in k (singleton (key x))) (in w1 (keys' (r' x)))) (< k w1 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in k (singleton (key x))) (in w2 (keys' (r' x)))) (< k w2 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in k (singleton (key x))) (in (key x) (keys' (r' x)))) (< k (key x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in k (singleton (key x))) (in (key (r1 x)) (keys' (r' x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in k (singleton (key x))) (in (key (l x)) (keys' (r' x)))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in k (singleton (key x))) (in (priority x) (keys' (r' x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in k (singleton (key x))) (in (priority (r1 x)) (keys' (r' x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in k (singleton (key x))) (in (priority (l x)) (keys' (r' x)))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in p (singleton (key x))) (in k (keys' (r' x)))) (< p k ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in p (singleton (key x))) (in p (keys' (r' x)))) (< p p ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in p (singleton (key x))) (in w1 (keys' (r' x)))) (< p w1 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in p (singleton (key x))) (in w2 (keys' (r' x)))) (< p w2 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in p (singleton (key x))) (in (key x) (keys' (r' x)))) (< p (key x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in p (singleton (key x))) (in (key (r1 x)) (keys' (r' x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in p (singleton (key x))) (in (key (l x)) (keys' (r' x)))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in p (singleton (key x))) (in (priority x) (keys' (r' x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in p (singleton (key x))) (in (priority (r1 x)) (keys' (r' x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in p (singleton (key x))) (in (priority (l x)) (keys' (r' x)))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w1 (singleton (key x))) (in k (keys' (r' x)))) (< w1 k ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w1 (singleton (key x))) (in p (keys' (r' x)))) (< w1 p ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w1 (singleton (key x))) (in w1 (keys' (r' x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w1 (singleton (key x))) (in w2 (keys' (r' x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w1 (singleton (key x))) (in (key x) (keys' (r' x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w1 (singleton (key x))) (in (key (r1 x)) (keys' (r' x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w1 (singleton (key x))) (in (key (l x)) (keys' (r' x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w1 (singleton (key x))) (in (priority x) (keys' (r' x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w1 (singleton (key x))) (in (priority (r1 x)) (keys' (r' x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w1 (singleton (key x))) (in (priority (l x)) (keys' (r' x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w2 (singleton (key x))) (in k (keys' (r' x)))) (< w2 k ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w2 (singleton (key x))) (in p (keys' (r' x)))) (< w2 p ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w2 (singleton (key x))) (in w1 (keys' (r' x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w2 (singleton (key x))) (in w2 (keys' (r' x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w2 (singleton (key x))) (in (key x) (keys' (r' x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w2 (singleton (key x))) (in (key (r1 x)) (keys' (r' x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w2 (singleton (key x))) (in (key (l x)) (keys' (r' x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w2 (singleton (key x))) (in (priority x) (keys' (r' x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w2 (singleton (key x))) (in (priority (r1 x)) (keys' (r' x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in w2 (singleton (key x))) (in (priority (l x)) (keys' (r' x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key x) (singleton (key x))) (in k (keys' (r' x)))) (< (key x) k ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key x) (singleton (key x))) (in p (keys' (r' x)))) (< (key x) p ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key x) (singleton (key x))) (in w1 (keys' (r' x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key x) (singleton (key x))) (in w2 (keys' (r' x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key x) (singleton (key x))) (in (key x) (keys' (r' x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key x) (singleton (key x))) (in (key (r1 x)) (keys' (r' x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key x) (singleton (key x))) (in (key (l x)) (keys' (r' x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key x) (singleton (key x))) (in (priority x) (keys' (r' x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key x) (singleton (key x))) (in (priority (r1 x)) (keys' (r' x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key x) (singleton (key x))) (in (priority (l x)) (keys' (r' x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in k (keys' (r' x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in p (keys' (r' x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in w1 (keys' (r' x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in w2 (keys' (r' x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (key x) (keys' (r' x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (key (r1 x)) (keys' (r' x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (key (l x)) (keys' (r' x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (priority x) (keys' (r' x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (priority (r1 x)) (keys' (r' x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (priority (l x)) (keys' (r' x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (l x)) (singleton (key x))) (in k (keys' (r' x)))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (l x)) (singleton (key x))) (in p (keys' (r' x)))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (l x)) (singleton (key x))) (in w1 (keys' (r' x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (l x)) (singleton (key x))) (in w2 (keys' (r' x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (l x)) (singleton (key x))) (in (key x) (keys' (r' x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (l x)) (singleton (key x))) (in (key (r1 x)) (keys' (r' x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (l x)) (singleton (key x))) (in (key (l x)) (keys' (r' x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (l x)) (singleton (key x))) (in (priority x) (keys' (r' x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (l x)) (singleton (key x))) (in (priority (r1 x)) (keys' (r' x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (key (l x)) (singleton (key x))) (in (priority (l x)) (keys' (r' x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority x) (singleton (key x))) (in k (keys' (r' x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority x) (singleton (key x))) (in p (keys' (r' x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority x) (singleton (key x))) (in w1 (keys' (r' x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority x) (singleton (key x))) (in w2 (keys' (r' x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority x) (singleton (key x))) (in (key x) (keys' (r' x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority x) (singleton (key x))) (in (key (r1 x)) (keys' (r' x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority x) (singleton (key x))) (in (key (l x)) (keys' (r' x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority x) (singleton (key x))) (in (priority x) (keys' (r' x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority x) (singleton (key x))) (in (priority (r1 x)) (keys' (r' x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority x) (singleton (key x))) (in (priority (l x)) (keys' (r' x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in k (keys' (r' x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in p (keys' (r' x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in w1 (keys' (r' x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in w2 (keys' (r' x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (key x) (keys' (r' x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (key (r1 x)) (keys' (r' x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (key (l x)) (keys' (r' x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (priority x) (keys' (r' x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (priority (r1 x)) (keys' (r' x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (priority (l x)) (keys' (r' x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (l x)) (singleton (key x))) (in k (keys' (r' x)))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (l x)) (singleton (key x))) (in p (keys' (r' x)))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (l x)) (singleton (key x))) (in w1 (keys' (r' x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (l x)) (singleton (key x))) (in w2 (keys' (r' x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (key x) (keys' (r' x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (key (r1 x)) (keys' (r' x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (key (l x)) (keys' (r' x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (priority x) (keys' (r' x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (priority (r1 x)) (keys' (r' x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys' (r' x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (priority (l x)) (keys' (r' x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in k (singleton (key (l x)))) (in k (keys' (r' (l x))))) (< k k ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in k (singleton (key (l x)))) (in p (keys' (r' (l x))))) (< k p ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in k (singleton (key (l x)))) (in w1 (keys' (r' (l x))))) (< k w1 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in k (singleton (key (l x)))) (in w2 (keys' (r' (l x))))) (< k w2 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in k (singleton (key (l x)))) (in (key x) (keys' (r' (l x))))) (< k (key x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in k (singleton (key (l x)))) (in (key (r1 x)) (keys' (r' (l x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in k (singleton (key (l x)))) (in (key (l x)) (keys' (r' (l x))))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in k (singleton (key (l x)))) (in (priority x) (keys' (r' (l x))))) (< k (priority x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in k (singleton (key (l x)))) (in (priority (r1 x)) (keys' (r' (l x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in k (singleton (key (l x)))) (in (priority (l x)) (keys' (r' (l x))))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in p (singleton (key (l x)))) (in k (keys' (r' (l x))))) (< p k ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in p (singleton (key (l x)))) (in p (keys' (r' (l x))))) (< p p ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in p (singleton (key (l x)))) (in w1 (keys' (r' (l x))))) (< p w1 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in p (singleton (key (l x)))) (in w2 (keys' (r' (l x))))) (< p w2 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in p (singleton (key (l x)))) (in (key x) (keys' (r' (l x))))) (< p (key x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in p (singleton (key (l x)))) (in (key (r1 x)) (keys' (r' (l x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in p (singleton (key (l x)))) (in (key (l x)) (keys' (r' (l x))))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in p (singleton (key (l x)))) (in (priority x) (keys' (r' (l x))))) (< p (priority x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in p (singleton (key (l x)))) (in (priority (r1 x)) (keys' (r' (l x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in p (singleton (key (l x)))) (in (priority (l x)) (keys' (r' (l x))))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w1 (singleton (key (l x)))) (in k (keys' (r' (l x))))) (< w1 k ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w1 (singleton (key (l x)))) (in p (keys' (r' (l x))))) (< w1 p ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w1 (singleton (key (l x)))) (in w1 (keys' (r' (l x))))) (< w1 w1 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w1 (singleton (key (l x)))) (in w2 (keys' (r' (l x))))) (< w1 w2 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w1 (singleton (key (l x)))) (in (key x) (keys' (r' (l x))))) (< w1 (key x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w1 (singleton (key (l x)))) (in (key (r1 x)) (keys' (r' (l x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w1 (singleton (key (l x)))) (in (key (l x)) (keys' (r' (l x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w1 (singleton (key (l x)))) (in (priority x) (keys' (r' (l x))))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w1 (singleton (key (l x)))) (in (priority (r1 x)) (keys' (r' (l x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w1 (singleton (key (l x)))) (in (priority (l x)) (keys' (r' (l x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w2 (singleton (key (l x)))) (in k (keys' (r' (l x))))) (< w2 k ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w2 (singleton (key (l x)))) (in p (keys' (r' (l x))))) (< w2 p ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w2 (singleton (key (l x)))) (in w1 (keys' (r' (l x))))) (< w2 w1 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w2 (singleton (key (l x)))) (in w2 (keys' (r' (l x))))) (< w2 w2 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w2 (singleton (key (l x)))) (in (key x) (keys' (r' (l x))))) (< w2 (key x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w2 (singleton (key (l x)))) (in (key (r1 x)) (keys' (r' (l x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w2 (singleton (key (l x)))) (in (key (l x)) (keys' (r' (l x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w2 (singleton (key (l x)))) (in (priority x) (keys' (r' (l x))))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w2 (singleton (key (l x)))) (in (priority (r1 x)) (keys' (r' (l x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in w2 (singleton (key (l x)))) (in (priority (l x)) (keys' (r' (l x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key x) (singleton (key (l x)))) (in k (keys' (r' (l x))))) (< (key x) k ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key x) (singleton (key (l x)))) (in p (keys' (r' (l x))))) (< (key x) p ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key x) (singleton (key (l x)))) (in w1 (keys' (r' (l x))))) (< (key x) w1 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key x) (singleton (key (l x)))) (in w2 (keys' (r' (l x))))) (< (key x) w2 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key x) (singleton (key (l x)))) (in (key x) (keys' (r' (l x))))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key x) (singleton (key (l x)))) (in (key (r1 x)) (keys' (r' (l x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key x) (singleton (key (l x)))) (in (key (l x)) (keys' (r' (l x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key x) (singleton (key (l x)))) (in (priority x) (keys' (r' (l x))))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key x) (singleton (key (l x)))) (in (priority (r1 x)) (keys' (r' (l x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key x) (singleton (key (l x)))) (in (priority (l x)) (keys' (r' (l x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (key (l x)))) (in k (keys' (r' (l x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (key (l x)))) (in p (keys' (r' (l x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (key (l x)))) (in w1 (keys' (r' (l x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (key (l x)))) (in w2 (keys' (r' (l x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (key (l x)))) (in (key x) (keys' (r' (l x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (key (l x)))) (in (key (r1 x)) (keys' (r' (l x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (key (l x)))) (in (key (l x)) (keys' (r' (l x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (key (l x)))) (in (priority x) (keys' (r' (l x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (key (l x)))) (in (priority (r1 x)) (keys' (r' (l x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (r1 x)) (singleton (key (l x)))) (in (priority (l x)) (keys' (r' (l x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (l x)) (singleton (key (l x)))) (in k (keys' (r' (l x))))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (l x)) (singleton (key (l x)))) (in p (keys' (r' (l x))))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (l x)) (singleton (key (l x)))) (in w1 (keys' (r' (l x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (l x)) (singleton (key (l x)))) (in w2 (keys' (r' (l x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (l x)) (singleton (key (l x)))) (in (key x) (keys' (r' (l x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (l x)) (singleton (key (l x)))) (in (key (r1 x)) (keys' (r' (l x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (l x)) (singleton (key (l x)))) (in (key (l x)) (keys' (r' (l x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (l x)) (singleton (key (l x)))) (in (priority x) (keys' (r' (l x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (l x)) (singleton (key (l x)))) (in (priority (r1 x)) (keys' (r' (l x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (key (l x)) (singleton (key (l x)))) (in (priority (l x)) (keys' (r' (l x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority x) (singleton (key (l x)))) (in k (keys' (r' (l x))))) (< (priority x) k ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority x) (singleton (key (l x)))) (in p (keys' (r' (l x))))) (< (priority x) p ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority x) (singleton (key (l x)))) (in w1 (keys' (r' (l x))))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority x) (singleton (key (l x)))) (in w2 (keys' (r' (l x))))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority x) (singleton (key (l x)))) (in (key x) (keys' (r' (l x))))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority x) (singleton (key (l x)))) (in (key (r1 x)) (keys' (r' (l x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority x) (singleton (key (l x)))) (in (key (l x)) (keys' (r' (l x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority x) (singleton (key (l x)))) (in (priority x) (keys' (r' (l x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority x) (singleton (key (l x)))) (in (priority (r1 x)) (keys' (r' (l x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority x) (singleton (key (l x)))) (in (priority (l x)) (keys' (r' (l x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (key (l x)))) (in k (keys' (r' (l x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (key (l x)))) (in p (keys' (r' (l x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (key (l x)))) (in w1 (keys' (r' (l x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (key (l x)))) (in w2 (keys' (r' (l x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (key (l x)))) (in (key x) (keys' (r' (l x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (key (l x)))) (in (key (r1 x)) (keys' (r' (l x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (key (l x)))) (in (key (l x)) (keys' (r' (l x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (key (l x)))) (in (priority x) (keys' (r' (l x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (key (l x)))) (in (priority (r1 x)) (keys' (r' (l x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (r1 x)) (singleton (key (l x)))) (in (priority (l x)) (keys' (r' (l x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (key (l x)))) (in k (keys' (r' (l x))))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (key (l x)))) (in p (keys' (r' (l x))))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (key (l x)))) (in w1 (keys' (r' (l x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (key (l x)))) (in w2 (keys' (r' (l x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (key (l x)))) (in (key x) (keys' (r' (l x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (key (l x)))) (in (key (r1 x)) (keys' (r' (l x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (key (l x)))) (in (key (l x)) (keys' (r' (l x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (key (l x)))) (in (priority x) (keys' (r' (l x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (key (l x)))) (in (priority (r1 x)) (keys' (r' (l x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (l x))) (keys' (r' (l x)))) (=> (and (in (priority (l x)) (singleton (key (l x)))) (in (priority (l x)) (keys' (r' (l x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in k (priorities' (l' (r1 x))))) (< k k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in p (priorities' (l' (r1 x))))) (< k p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in w1 (priorities' (l' (r1 x))))) (< k w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in w2 (priorities' (l' (r1 x))))) (< k w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key x) (priorities' (l' (r1 x))))) (< k (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (l' (r1 x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (l' (r1 x))))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority x) (priorities' (l' (r1 x))))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (l' (r1 x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (l' (r1 x))))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in k (priorities' (l' (r1 x))))) (< p k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in p (priorities' (l' (r1 x))))) (< p p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in w1 (priorities' (l' (r1 x))))) (< p w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in w2 (priorities' (l' (r1 x))))) (< p w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key x) (priorities' (l' (r1 x))))) (< p (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (l' (r1 x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (l' (r1 x))))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority x) (priorities' (l' (r1 x))))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (l' (r1 x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (l' (r1 x))))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in k (priorities' (l' (r1 x))))) (< w1 k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in p (priorities' (l' (r1 x))))) (< w1 p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in w1 (priorities' (l' (r1 x))))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in w2 (priorities' (l' (r1 x))))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key x) (priorities' (l' (r1 x))))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (l' (r1 x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (l' (r1 x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority x) (priorities' (l' (r1 x))))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (l' (r1 x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (l' (r1 x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in k (priorities' (l' (r1 x))))) (< w2 k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in p (priorities' (l' (r1 x))))) (< w2 p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in w1 (priorities' (l' (r1 x))))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in w2 (priorities' (l' (r1 x))))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key x) (priorities' (l' (r1 x))))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (l' (r1 x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (l' (r1 x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority x) (priorities' (l' (r1 x))))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (l' (r1 x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (l' (r1 x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in k (priorities' (l' (r1 x))))) (< (key x) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in p (priorities' (l' (r1 x))))) (< (key x) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in w1 (priorities' (l' (r1 x))))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in w2 (priorities' (l' (r1 x))))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key x) (priorities' (l' (r1 x))))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (l' (r1 x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (l' (r1 x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority x) (priorities' (l' (r1 x))))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (l' (r1 x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (l' (r1 x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in k (priorities' (l' (r1 x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in p (priorities' (l' (r1 x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in w1 (priorities' (l' (r1 x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in w2 (priorities' (l' (r1 x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key x) (priorities' (l' (r1 x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (l' (r1 x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (l' (r1 x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority x) (priorities' (l' (r1 x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (l' (r1 x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (l' (r1 x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in k (priorities' (l' (r1 x))))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in p (priorities' (l' (r1 x))))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in w1 (priorities' (l' (r1 x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in w2 (priorities' (l' (r1 x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key x) (priorities' (l' (r1 x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (l' (r1 x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (l' (r1 x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority x) (priorities' (l' (r1 x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (l' (r1 x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (l' (r1 x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in k (priorities' (l' (r1 x))))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in p (priorities' (l' (r1 x))))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in w1 (priorities' (l' (r1 x))))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in w2 (priorities' (l' (r1 x))))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key x) (priorities' (l' (r1 x))))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (l' (r1 x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (l' (r1 x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority x) (priorities' (l' (r1 x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (l' (r1 x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (l' (r1 x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in k (priorities' (l' (r1 x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in p (priorities' (l' (r1 x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in w1 (priorities' (l' (r1 x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in w2 (priorities' (l' (r1 x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key x) (priorities' (l' (r1 x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (l' (r1 x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (l' (r1 x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority x) (priorities' (l' (r1 x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (l' (r1 x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (l' (r1 x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in k (priorities' (l' (r1 x))))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in p (priorities' (l' (r1 x))))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in w1 (priorities' (l' (r1 x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in w2 (priorities' (l' (r1 x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key x) (priorities' (l' (r1 x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (l' (r1 x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (l' (r1 x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority x) (priorities' (l' (r1 x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (l' (r1 x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (l' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (l' (r1 x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys' (l' (r1 x)))) (in k (singleton (key (r1 x))))) (< k k ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys' (l' (r1 x)))) (in p (singleton (key (r1 x))))) (< k p ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x))))) (< k w1 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x))))) (< k w2 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< k (key x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< k (key (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< k (priority x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< k (priority (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys' (l' (r1 x)))) (in k (singleton (key (r1 x))))) (< p k ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys' (l' (r1 x)))) (in p (singleton (key (r1 x))))) (< p p ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x))))) (< p w1 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x))))) (< p w2 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< p (key x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< p (key (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< p (priority x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< p (priority (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys' (l' (r1 x)))) (in k (singleton (key (r1 x))))) (< w1 k ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys' (l' (r1 x)))) (in p (singleton (key (r1 x))))) (< w1 p ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x))))) (< w1 w1 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x))))) (< w1 w2 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< w1 (key x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< w1 (priority x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys' (l' (r1 x)))) (in k (singleton (key (r1 x))))) (< w2 k ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys' (l' (r1 x)))) (in p (singleton (key (r1 x))))) (< w2 p ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x))))) (< w2 w1 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x))))) (< w2 w2 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< w2 (key x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< w2 (priority x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys' (l' (r1 x)))) (in k (singleton (key (r1 x))))) (< (key x) k ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys' (l' (r1 x)))) (in p (singleton (key (r1 x))))) (< (key x) p ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (key x) w1 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (key x) w2 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (key x) (key x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (key x) (priority x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys' (l' (r1 x)))) (in k (singleton (key (r1 x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys' (l' (r1 x)))) (in p (singleton (key (r1 x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys' (l' (r1 x)))) (in k (singleton (key (r1 x))))) (< (key (l x)) k ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys' (l' (r1 x)))) (in p (singleton (key (r1 x))))) (< (key (l x)) p ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys' (l' (r1 x)))) (in k (singleton (key (r1 x))))) (< (priority x) k ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys' (l' (r1 x)))) (in p (singleton (key (r1 x))))) (< (priority x) p ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (priority x) w1 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (priority x) w2 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (priority x) (key x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys' (l' (r1 x)))) (in k (singleton (key (r1 x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys' (l' (r1 x)))) (in p (singleton (key (r1 x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys' (l' (r1 x)))) (in k (singleton (key (r1 x))))) (< (priority (l x)) k ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys' (l' (r1 x)))) (in p (singleton (key (r1 x))))) (< (priority (l x)) p ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys' (l' (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys' (l' (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys' (l' (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys' (l' (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys' (l' (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys' (l' (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys' (l' (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys' (l' (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys' (l' (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in k (priorities' (r' (r1 x))))) (< k k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in p (priorities' (r' (r1 x))))) (< k p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in w1 (priorities' (r' (r1 x))))) (< k w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in w2 (priorities' (r' (r1 x))))) (< k w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key x) (priorities' (r' (r1 x))))) (< k (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in k (priorities' (r' (r1 x))))) (< p k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in p (priorities' (r' (r1 x))))) (< p p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in w1 (priorities' (r' (r1 x))))) (< p w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in w2 (priorities' (r' (r1 x))))) (< p w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key x) (priorities' (r' (r1 x))))) (< p (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in k (priorities' (r' (r1 x))))) (< w1 k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in p (priorities' (r' (r1 x))))) (< w1 p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in w1 (priorities' (r' (r1 x))))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in w2 (priorities' (r' (r1 x))))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key x) (priorities' (r' (r1 x))))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in k (priorities' (r' (r1 x))))) (< w2 k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in p (priorities' (r' (r1 x))))) (< w2 p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in w1 (priorities' (r' (r1 x))))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in w2 (priorities' (r' (r1 x))))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key x) (priorities' (r' (r1 x))))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in k (priorities' (r' (r1 x))))) (< (key x) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in p (priorities' (r' (r1 x))))) (< (key x) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in w1 (priorities' (r' (r1 x))))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in w2 (priorities' (r' (r1 x))))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key x) (priorities' (r' (r1 x))))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in k (priorities' (r' (r1 x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in p (priorities' (r' (r1 x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in w1 (priorities' (r' (r1 x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in w2 (priorities' (r' (r1 x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key x) (priorities' (r' (r1 x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in k (priorities' (r' (r1 x))))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in p (priorities' (r' (r1 x))))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in w1 (priorities' (r' (r1 x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in w2 (priorities' (r' (r1 x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key x) (priorities' (r' (r1 x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in k (priorities' (r' (r1 x))))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in p (priorities' (r' (r1 x))))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in w1 (priorities' (r' (r1 x))))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in w2 (priorities' (r' (r1 x))))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key x) (priorities' (r' (r1 x))))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in k (priorities' (r' (r1 x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in p (priorities' (r' (r1 x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in w1 (priorities' (r' (r1 x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in w2 (priorities' (r' (r1 x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key x) (priorities' (r' (r1 x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in k (priorities' (r' (r1 x))))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in p (priorities' (r' (r1 x))))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in w1 (priorities' (r' (r1 x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in w2 (priorities' (r' (r1 x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key x) (priorities' (r' (r1 x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities' (r' (r1 x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities' (r' (r1 x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority x) (priorities' (r' (r1 x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities' (r' (r1 x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities' (r' (r1 x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in k (keys' (r' (r1 x))))) (< k k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in p (keys' (r' (r1 x))))) (< k p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in w1 (keys' (r' (r1 x))))) (< k w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in w2 (keys' (r' (r1 x))))) (< k w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (key x) (keys' (r' (r1 x))))) (< k (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (key (l x)) (keys' (r' (r1 x))))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (priority x) (keys' (r' (r1 x))))) (< k (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x))))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in k (keys' (r' (r1 x))))) (< p k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in p (keys' (r' (r1 x))))) (< p p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in w1 (keys' (r' (r1 x))))) (< p w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in w2 (keys' (r' (r1 x))))) (< p w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (key x) (keys' (r' (r1 x))))) (< p (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (key (l x)) (keys' (r' (r1 x))))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (priority x) (keys' (r' (r1 x))))) (< p (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x))))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in k (keys' (r' (r1 x))))) (< w1 k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in p (keys' (r' (r1 x))))) (< w1 p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in w1 (keys' (r' (r1 x))))) (< w1 w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in w2 (keys' (r' (r1 x))))) (< w1 w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (key x) (keys' (r' (r1 x))))) (< w1 (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (key (l x)) (keys' (r' (r1 x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (priority x) (keys' (r' (r1 x))))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in k (keys' (r' (r1 x))))) (< w2 k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in p (keys' (r' (r1 x))))) (< w2 p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in w1 (keys' (r' (r1 x))))) (< w2 w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in w2 (keys' (r' (r1 x))))) (< w2 w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (key x) (keys' (r' (r1 x))))) (< w2 (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (key (l x)) (keys' (r' (r1 x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (priority x) (keys' (r' (r1 x))))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in k (keys' (r' (r1 x))))) (< (key x) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in p (keys' (r' (r1 x))))) (< (key x) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in w1 (keys' (r' (r1 x))))) (< (key x) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in w2 (keys' (r' (r1 x))))) (< (key x) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (key x) (keys' (r' (r1 x))))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (key (l x)) (keys' (r' (r1 x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (priority x) (keys' (r' (r1 x))))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in k (keys' (r' (r1 x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in p (keys' (r' (r1 x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in w1 (keys' (r' (r1 x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in w2 (keys' (r' (r1 x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (key x) (keys' (r' (r1 x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (key (l x)) (keys' (r' (r1 x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (priority x) (keys' (r' (r1 x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in k (keys' (r' (r1 x))))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in p (keys' (r' (r1 x))))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in w1 (keys' (r' (r1 x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in w2 (keys' (r' (r1 x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (key x) (keys' (r' (r1 x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (key (l x)) (keys' (r' (r1 x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (priority x) (keys' (r' (r1 x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in k (keys' (r' (r1 x))))) (< (priority x) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in p (keys' (r' (r1 x))))) (< (priority x) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in w1 (keys' (r' (r1 x))))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in w2 (keys' (r' (r1 x))))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (key x) (keys' (r' (r1 x))))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (key (l x)) (keys' (r' (r1 x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (priority x) (keys' (r' (r1 x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in k (keys' (r' (r1 x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in p (keys' (r' (r1 x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in w1 (keys' (r' (r1 x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in w2 (keys' (r' (r1 x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (key x) (keys' (r' (r1 x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (key (l x)) (keys' (r' (r1 x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (priority x) (keys' (r' (r1 x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in k (keys' (r' (r1 x))))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in p (keys' (r' (r1 x))))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in w1 (keys' (r' (r1 x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in w2 (keys' (r' (r1 x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (key x) (keys' (r' (r1 x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (key (r1 x)) (keys' (r' (r1 x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (key (l x)) (keys' (r' (r1 x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (priority x) (keys' (r' (r1 x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys' (r' (r1 x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys' (r' (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (priority (l x)) (keys' (r' (r1 x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in k (singleton (priority x))) (in k (priorities1 (l1 x)))) (< k k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in k (singleton (priority x))) (in p (priorities1 (l1 x)))) (< k p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in k (singleton (priority x))) (in w1 (priorities1 (l1 x)))) (< k w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in k (singleton (priority x))) (in w2 (priorities1 (l1 x)))) (< k w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in k (singleton (priority x))) (in (key x) (priorities1 (l1 x)))) (< k (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in k (singleton (priority x))) (in (key (r1 x)) (priorities1 (l1 x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in k (singleton (priority x))) (in (key (l x)) (priorities1 (l1 x)))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in k (singleton (priority x))) (in (priority x) (priorities1 (l1 x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in k (singleton (priority x))) (in (priority (r1 x)) (priorities1 (l1 x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in k (singleton (priority x))) (in (priority (l x)) (priorities1 (l1 x)))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in p (singleton (priority x))) (in k (priorities1 (l1 x)))) (< p k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in p (singleton (priority x))) (in p (priorities1 (l1 x)))) (< p p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in p (singleton (priority x))) (in w1 (priorities1 (l1 x)))) (< p w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in p (singleton (priority x))) (in w2 (priorities1 (l1 x)))) (< p w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in p (singleton (priority x))) (in (key x) (priorities1 (l1 x)))) (< p (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in p (singleton (priority x))) (in (key (r1 x)) (priorities1 (l1 x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in p (singleton (priority x))) (in (key (l x)) (priorities1 (l1 x)))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in p (singleton (priority x))) (in (priority x) (priorities1 (l1 x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in p (singleton (priority x))) (in (priority (r1 x)) (priorities1 (l1 x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in p (singleton (priority x))) (in (priority (l x)) (priorities1 (l1 x)))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w1 (singleton (priority x))) (in k (priorities1 (l1 x)))) (< w1 k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w1 (singleton (priority x))) (in p (priorities1 (l1 x)))) (< w1 p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w1 (singleton (priority x))) (in w1 (priorities1 (l1 x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w1 (singleton (priority x))) (in w2 (priorities1 (l1 x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w1 (singleton (priority x))) (in (key x) (priorities1 (l1 x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w1 (singleton (priority x))) (in (key (r1 x)) (priorities1 (l1 x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w1 (singleton (priority x))) (in (key (l x)) (priorities1 (l1 x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w1 (singleton (priority x))) (in (priority x) (priorities1 (l1 x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w1 (singleton (priority x))) (in (priority (r1 x)) (priorities1 (l1 x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w1 (singleton (priority x))) (in (priority (l x)) (priorities1 (l1 x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w2 (singleton (priority x))) (in k (priorities1 (l1 x)))) (< w2 k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w2 (singleton (priority x))) (in p (priorities1 (l1 x)))) (< w2 p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w2 (singleton (priority x))) (in w1 (priorities1 (l1 x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w2 (singleton (priority x))) (in w2 (priorities1 (l1 x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w2 (singleton (priority x))) (in (key x) (priorities1 (l1 x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w2 (singleton (priority x))) (in (key (r1 x)) (priorities1 (l1 x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w2 (singleton (priority x))) (in (key (l x)) (priorities1 (l1 x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w2 (singleton (priority x))) (in (priority x) (priorities1 (l1 x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w2 (singleton (priority x))) (in (priority (r1 x)) (priorities1 (l1 x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in w2 (singleton (priority x))) (in (priority (l x)) (priorities1 (l1 x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key x) (singleton (priority x))) (in k (priorities1 (l1 x)))) (< (key x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key x) (singleton (priority x))) (in p (priorities1 (l1 x)))) (< (key x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key x) (singleton (priority x))) (in w1 (priorities1 (l1 x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key x) (singleton (priority x))) (in w2 (priorities1 (l1 x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key x) (singleton (priority x))) (in (key x) (priorities1 (l1 x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key x) (singleton (priority x))) (in (key (r1 x)) (priorities1 (l1 x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key x) (singleton (priority x))) (in (key (l x)) (priorities1 (l1 x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key x) (singleton (priority x))) (in (priority x) (priorities1 (l1 x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (l1 x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (l x)) (priorities1 (l1 x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in k (priorities1 (l1 x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in p (priorities1 (l1 x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w1 (priorities1 (l1 x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w2 (priorities1 (l1 x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key x) (priorities1 (l1 x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities1 (l1 x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities1 (l1 x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority x) (priorities1 (l1 x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (l1 x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities1 (l1 x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in k (priorities1 (l1 x)))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in p (priorities1 (l1 x)))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w1 (priorities1 (l1 x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w2 (priorities1 (l1 x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key x) (priorities1 (l1 x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities1 (l1 x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (l x)) (priorities1 (l1 x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority x) (priorities1 (l1 x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (l1 x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (l x)) (priorities1 (l1 x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority x) (singleton (priority x))) (in k (priorities1 (l1 x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority x) (singleton (priority x))) (in p (priorities1 (l1 x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority x) (singleton (priority x))) (in w1 (priorities1 (l1 x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority x) (singleton (priority x))) (in w2 (priorities1 (l1 x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (key x) (priorities1 (l1 x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (r1 x)) (priorities1 (l1 x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (l x)) (priorities1 (l1 x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority x) (priorities1 (l1 x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (l1 x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (l x)) (priorities1 (l1 x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in k (priorities1 (l1 x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in p (priorities1 (l1 x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w1 (priorities1 (l1 x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w2 (priorities1 (l1 x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key x) (priorities1 (l1 x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities1 (l1 x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities1 (l1 x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority x) (priorities1 (l1 x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (l1 x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities1 (l1 x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in k (priorities1 (l1 x)))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in p (priorities1 (l1 x)))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w1 (priorities1 (l1 x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w2 (priorities1 (l1 x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key x) (priorities1 (l1 x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities1 (l1 x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (l x)) (priorities1 (l1 x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority x) (priorities1 (l1 x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (l1 x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (l1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (l x)) (priorities1 (l1 x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in k (priorities1 (l1 (r1 x))))) (< k k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in p (priorities1 (l1 (r1 x))))) (< k p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in w1 (priorities1 (l1 (r1 x))))) (< k w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in w2 (priorities1 (l1 (r1 x))))) (< k w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key x) (priorities1 (l1 (r1 x))))) (< k (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x))))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x))))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x))))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in k (priorities1 (l1 (r1 x))))) (< p k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in p (priorities1 (l1 (r1 x))))) (< p p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in w1 (priorities1 (l1 (r1 x))))) (< p w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in w2 (priorities1 (l1 (r1 x))))) (< p w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key x) (priorities1 (l1 (r1 x))))) (< p (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x))))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x))))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x))))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in k (priorities1 (l1 (r1 x))))) (< w1 k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in p (priorities1 (l1 (r1 x))))) (< w1 p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in w1 (priorities1 (l1 (r1 x))))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in w2 (priorities1 (l1 (r1 x))))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key x) (priorities1 (l1 (r1 x))))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x))))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in k (priorities1 (l1 (r1 x))))) (< w2 k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in p (priorities1 (l1 (r1 x))))) (< w2 p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in w1 (priorities1 (l1 (r1 x))))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in w2 (priorities1 (l1 (r1 x))))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key x) (priorities1 (l1 (r1 x))))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x))))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in k (priorities1 (l1 (r1 x))))) (< (key x) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in p (priorities1 (l1 (r1 x))))) (< (key x) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in w1 (priorities1 (l1 (r1 x))))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in w2 (priorities1 (l1 (r1 x))))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key x) (priorities1 (l1 (r1 x))))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x))))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in k (priorities1 (l1 (r1 x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in p (priorities1 (l1 (r1 x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in w1 (priorities1 (l1 (r1 x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in w2 (priorities1 (l1 (r1 x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key x) (priorities1 (l1 (r1 x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in k (priorities1 (l1 (r1 x))))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in p (priorities1 (l1 (r1 x))))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in w1 (priorities1 (l1 (r1 x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in w2 (priorities1 (l1 (r1 x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key x) (priorities1 (l1 (r1 x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in k (priorities1 (l1 (r1 x))))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in p (priorities1 (l1 (r1 x))))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in w1 (priorities1 (l1 (r1 x))))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in w2 (priorities1 (l1 (r1 x))))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key x) (priorities1 (l1 (r1 x))))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in k (priorities1 (l1 (r1 x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in p (priorities1 (l1 (r1 x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in w1 (priorities1 (l1 (r1 x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in w2 (priorities1 (l1 (r1 x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key x) (priorities1 (l1 (r1 x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in k (priorities1 (l1 (r1 x))))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in p (priorities1 (l1 (r1 x))))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in w1 (priorities1 (l1 (r1 x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in w2 (priorities1 (l1 (r1 x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key x) (priorities1 (l1 (r1 x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (l1 (r1 x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (l1 (r1 x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (l1 (r1 x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (l1 (r1 x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (l1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (l1 (r1 x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in k (keys1 (l1 x))) (in k (singleton (key x)))) (< k k ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in k (keys1 (l1 x))) (in p (singleton (key x)))) (< k p ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in k (keys1 (l1 x))) (in w1 (singleton (key x)))) (< k w1 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in k (keys1 (l1 x))) (in w2 (singleton (key x)))) (< k w2 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in k (keys1 (l1 x))) (in (key x) (singleton (key x)))) (< k (key x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in k (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in k (keys1 (l1 x))) (in (key (l x)) (singleton (key x)))) (< k (key (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in k (keys1 (l1 x))) (in (priority x) (singleton (key x)))) (< k (priority x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in k (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in k (keys1 (l1 x))) (in (priority (l x)) (singleton (key x)))) (< k (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in p (keys1 (l1 x))) (in k (singleton (key x)))) (< p k ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in p (keys1 (l1 x))) (in p (singleton (key x)))) (< p p ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in p (keys1 (l1 x))) (in w1 (singleton (key x)))) (< p w1 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in p (keys1 (l1 x))) (in w2 (singleton (key x)))) (< p w2 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in p (keys1 (l1 x))) (in (key x) (singleton (key x)))) (< p (key x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in p (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in p (keys1 (l1 x))) (in (key (l x)) (singleton (key x)))) (< p (key (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in p (keys1 (l1 x))) (in (priority x) (singleton (key x)))) (< p (priority x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in p (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in p (keys1 (l1 x))) (in (priority (l x)) (singleton (key x)))) (< p (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w1 (keys1 (l1 x))) (in k (singleton (key x)))) (< w1 k ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w1 (keys1 (l1 x))) (in p (singleton (key x)))) (< w1 p ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w1 (keys1 (l1 x))) (in w1 (singleton (key x)))) (< w1 w1 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w1 (keys1 (l1 x))) (in w2 (singleton (key x)))) (< w1 w2 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w1 (keys1 (l1 x))) (in (key x) (singleton (key x)))) (< w1 (key x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w1 (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w1 (keys1 (l1 x))) (in (key (l x)) (singleton (key x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w1 (keys1 (l1 x))) (in (priority x) (singleton (key x)))) (< w1 (priority x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w1 (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w1 (keys1 (l1 x))) (in (priority (l x)) (singleton (key x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w2 (keys1 (l1 x))) (in k (singleton (key x)))) (< w2 k ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w2 (keys1 (l1 x))) (in p (singleton (key x)))) (< w2 p ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w2 (keys1 (l1 x))) (in w1 (singleton (key x)))) (< w2 w1 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w2 (keys1 (l1 x))) (in w2 (singleton (key x)))) (< w2 w2 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w2 (keys1 (l1 x))) (in (key x) (singleton (key x)))) (< w2 (key x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w2 (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w2 (keys1 (l1 x))) (in (key (l x)) (singleton (key x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w2 (keys1 (l1 x))) (in (priority x) (singleton (key x)))) (< w2 (priority x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w2 (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in w2 (keys1 (l1 x))) (in (priority (l x)) (singleton (key x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key x) (keys1 (l1 x))) (in k (singleton (key x)))) (< (key x) k ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key x) (keys1 (l1 x))) (in p (singleton (key x)))) (< (key x) p ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key x) (keys1 (l1 x))) (in w1 (singleton (key x)))) (< (key x) w1 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key x) (keys1 (l1 x))) (in w2 (singleton (key x)))) (< (key x) w2 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key x) (keys1 (l1 x))) (in (key x) (singleton (key x)))) (< (key x) (key x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key x) (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key x) (keys1 (l1 x))) (in (key (l x)) (singleton (key x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key x) (keys1 (l1 x))) (in (priority x) (singleton (key x)))) (< (key x) (priority x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key x) (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key x) (keys1 (l1 x))) (in (priority (l x)) (singleton (key x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys1 (l1 x))) (in k (singleton (key x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys1 (l1 x))) (in p (singleton (key x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys1 (l1 x))) (in w1 (singleton (key x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys1 (l1 x))) (in w2 (singleton (key x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys1 (l1 x))) (in (key x) (singleton (key x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys1 (l1 x))) (in (key (l x)) (singleton (key x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys1 (l1 x))) (in (priority x) (singleton (key x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (r1 x)) (keys1 (l1 x))) (in (priority (l x)) (singleton (key x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (l x)) (keys1 (l1 x))) (in k (singleton (key x)))) (< (key (l x)) k ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (l x)) (keys1 (l1 x))) (in p (singleton (key x)))) (< (key (l x)) p ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (l x)) (keys1 (l1 x))) (in w1 (singleton (key x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (l x)) (keys1 (l1 x))) (in w2 (singleton (key x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (l x)) (keys1 (l1 x))) (in (key x) (singleton (key x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (l x)) (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (l x)) (keys1 (l1 x))) (in (key (l x)) (singleton (key x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (l x)) (keys1 (l1 x))) (in (priority x) (singleton (key x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (l x)) (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (key (l x)) (keys1 (l1 x))) (in (priority (l x)) (singleton (key x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority x) (keys1 (l1 x))) (in k (singleton (key x)))) (< (priority x) k ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority x) (keys1 (l1 x))) (in p (singleton (key x)))) (< (priority x) p ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority x) (keys1 (l1 x))) (in w1 (singleton (key x)))) (< (priority x) w1 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority x) (keys1 (l1 x))) (in w2 (singleton (key x)))) (< (priority x) w2 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority x) (keys1 (l1 x))) (in (key x) (singleton (key x)))) (< (priority x) (key x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority x) (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority x) (keys1 (l1 x))) (in (key (l x)) (singleton (key x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority x) (keys1 (l1 x))) (in (priority x) (singleton (key x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority x) (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority x) (keys1 (l1 x))) (in (priority (l x)) (singleton (key x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys1 (l1 x))) (in k (singleton (key x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys1 (l1 x))) (in p (singleton (key x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys1 (l1 x))) (in w1 (singleton (key x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys1 (l1 x))) (in w2 (singleton (key x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys1 (l1 x))) (in (key x) (singleton (key x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys1 (l1 x))) (in (key (l x)) (singleton (key x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys1 (l1 x))) (in (priority x) (singleton (key x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (r1 x)) (keys1 (l1 x))) (in (priority (l x)) (singleton (key x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys1 (l1 x))) (in k (singleton (key x)))) (< (priority (l x)) k ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys1 (l1 x))) (in p (singleton (key x)))) (< (priority (l x)) p ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys1 (l1 x))) (in w1 (singleton (key x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys1 (l1 x))) (in w2 (singleton (key x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys1 (l1 x))) (in (key x) (singleton (key x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys1 (l1 x))) (in (key (r1 x)) (singleton (key x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys1 (l1 x))) (in (key (l x)) (singleton (key x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys1 (l1 x))) (in (priority x) (singleton (key x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys1 (l1 x))) (in (priority (r1 x)) (singleton (key x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 x)) (singleton (key x))) (=> (and (in (priority (l x)) (keys1 (l1 x))) (in (priority (l x)) (singleton (key x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x))))) (< k k ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x))))) (< k p ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x))))) (< k w1 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x))))) (< k w2 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< k (key x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< k (key (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< k (priority x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in k (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< k (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x))))) (< p k ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x))))) (< p p ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x))))) (< p w1 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x))))) (< p w2 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< p (key x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< p (key (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< p (priority x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in p (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< p (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x))))) (< w1 k ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x))))) (< w1 p ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x))))) (< w1 w1 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x))))) (< w1 w2 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< w1 (key x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< w1 (priority x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w1 (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x))))) (< w2 k ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x))))) (< w2 p ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x))))) (< w2 w1 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x))))) (< w2 w2 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< w2 (key x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< w2 (priority x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in w2 (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x))))) (< (key x) k ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x))))) (< (key x) p ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (key x) w1 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (key x) w2 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (key x) (key x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (key x) (priority x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key x) (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (r1 x)) (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x))))) (< (key (l x)) k ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x))))) (< (key (l x)) p ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (key (l x)) (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x))))) (< (priority x) k ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x))))) (< (priority x) p ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (priority x) w1 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (priority x) w2 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (priority x) (key x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority x) (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (r1 x)) (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys1 (l1 (r1 x)))) (in k (singleton (key (r1 x))))) (< (priority (l x)) k ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys1 (l1 (r1 x)))) (in p (singleton (key (r1 x))))) (< (priority (l x)) p ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys1 (l1 (r1 x)))) (in w1 (singleton (key (r1 x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys1 (l1 (r1 x)))) (in w2 (singleton (key (r1 x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys1 (l1 (r1 x)))) (in (key x) (singleton (key (r1 x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys1 (l1 (r1 x)))) (in (key (r1 x)) (singleton (key (r1 x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys1 (l1 (r1 x)))) (in (key (l x)) (singleton (key (r1 x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys1 (l1 (r1 x)))) (in (priority x) (singleton (key (r1 x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys1 (l1 (r1 x)))) (in (priority (r1 x)) (singleton (key (r1 x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (keys1 (l1 (r1 x))) (singleton (key (r1 x)))) (=> (and (in (priority (l x)) (keys1 (l1 (r1 x)))) (in (priority (l x)) (singleton (key (r1 x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in k (singleton (priority x))) (in k (priorities1 (r1 x)))) (< k k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in k (singleton (priority x))) (in p (priorities1 (r1 x)))) (< k p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in k (singleton (priority x))) (in w1 (priorities1 (r1 x)))) (< k w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in k (singleton (priority x))) (in w2 (priorities1 (r1 x)))) (< k w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in k (singleton (priority x))) (in (key x) (priorities1 (r1 x)))) (< k (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in k (singleton (priority x))) (in (key (r1 x)) (priorities1 (r1 x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in k (singleton (priority x))) (in (key (l x)) (priorities1 (r1 x)))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in k (singleton (priority x))) (in (priority x) (priorities1 (r1 x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in k (singleton (priority x))) (in (priority (r1 x)) (priorities1 (r1 x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in k (singleton (priority x))) (in (priority (l x)) (priorities1 (r1 x)))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in p (singleton (priority x))) (in k (priorities1 (r1 x)))) (< p k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in p (singleton (priority x))) (in p (priorities1 (r1 x)))) (< p p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in p (singleton (priority x))) (in w1 (priorities1 (r1 x)))) (< p w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in p (singleton (priority x))) (in w2 (priorities1 (r1 x)))) (< p w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in p (singleton (priority x))) (in (key x) (priorities1 (r1 x)))) (< p (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in p (singleton (priority x))) (in (key (r1 x)) (priorities1 (r1 x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in p (singleton (priority x))) (in (key (l x)) (priorities1 (r1 x)))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in p (singleton (priority x))) (in (priority x) (priorities1 (r1 x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in p (singleton (priority x))) (in (priority (r1 x)) (priorities1 (r1 x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in p (singleton (priority x))) (in (priority (l x)) (priorities1 (r1 x)))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w1 (singleton (priority x))) (in k (priorities1 (r1 x)))) (< w1 k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w1 (singleton (priority x))) (in p (priorities1 (r1 x)))) (< w1 p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w1 (singleton (priority x))) (in w1 (priorities1 (r1 x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w1 (singleton (priority x))) (in w2 (priorities1 (r1 x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w1 (singleton (priority x))) (in (key x) (priorities1 (r1 x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w1 (singleton (priority x))) (in (key (r1 x)) (priorities1 (r1 x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w1 (singleton (priority x))) (in (key (l x)) (priorities1 (r1 x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w1 (singleton (priority x))) (in (priority x) (priorities1 (r1 x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w1 (singleton (priority x))) (in (priority (r1 x)) (priorities1 (r1 x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w1 (singleton (priority x))) (in (priority (l x)) (priorities1 (r1 x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w2 (singleton (priority x))) (in k (priorities1 (r1 x)))) (< w2 k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w2 (singleton (priority x))) (in p (priorities1 (r1 x)))) (< w2 p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w2 (singleton (priority x))) (in w1 (priorities1 (r1 x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w2 (singleton (priority x))) (in w2 (priorities1 (r1 x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w2 (singleton (priority x))) (in (key x) (priorities1 (r1 x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w2 (singleton (priority x))) (in (key (r1 x)) (priorities1 (r1 x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w2 (singleton (priority x))) (in (key (l x)) (priorities1 (r1 x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w2 (singleton (priority x))) (in (priority x) (priorities1 (r1 x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w2 (singleton (priority x))) (in (priority (r1 x)) (priorities1 (r1 x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in w2 (singleton (priority x))) (in (priority (l x)) (priorities1 (r1 x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key x) (singleton (priority x))) (in k (priorities1 (r1 x)))) (< (key x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key x) (singleton (priority x))) (in p (priorities1 (r1 x)))) (< (key x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key x) (singleton (priority x))) (in w1 (priorities1 (r1 x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key x) (singleton (priority x))) (in w2 (priorities1 (r1 x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key x) (singleton (priority x))) (in (key x) (priorities1 (r1 x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key x) (singleton (priority x))) (in (key (r1 x)) (priorities1 (r1 x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key x) (singleton (priority x))) (in (key (l x)) (priorities1 (r1 x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key x) (singleton (priority x))) (in (priority x) (priorities1 (r1 x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (r1 x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key x) (singleton (priority x))) (in (priority (l x)) (priorities1 (r1 x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in k (priorities1 (r1 x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in p (priorities1 (r1 x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w1 (priorities1 (r1 x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in w2 (priorities1 (r1 x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key x) (priorities1 (r1 x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities1 (r1 x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities1 (r1 x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority x) (priorities1 (r1 x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (r1 x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities1 (r1 x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in k (priorities1 (r1 x)))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in p (priorities1 (r1 x)))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w1 (priorities1 (r1 x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in w2 (priorities1 (r1 x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key x) (priorities1 (r1 x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities1 (r1 x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (key (l x)) (priorities1 (r1 x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority x) (priorities1 (r1 x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (r1 x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (key (l x)) (singleton (priority x))) (in (priority (l x)) (priorities1 (r1 x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority x) (singleton (priority x))) (in k (priorities1 (r1 x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority x) (singleton (priority x))) (in p (priorities1 (r1 x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority x) (singleton (priority x))) (in w1 (priorities1 (r1 x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority x) (singleton (priority x))) (in w2 (priorities1 (r1 x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (key x) (priorities1 (r1 x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (r1 x)) (priorities1 (r1 x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (key (l x)) (priorities1 (r1 x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority x) (priorities1 (r1 x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (r1 x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority x) (singleton (priority x))) (in (priority (l x)) (priorities1 (r1 x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in k (priorities1 (r1 x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in p (priorities1 (r1 x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w1 (priorities1 (r1 x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in w2 (priorities1 (r1 x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key x) (priorities1 (r1 x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (r1 x)) (priorities1 (r1 x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (key (l x)) (priorities1 (r1 x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority x) (priorities1 (r1 x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (r1 x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (priority x))) (in (priority (l x)) (priorities1 (r1 x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in k (priorities1 (r1 x)))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in p (priorities1 (r1 x)))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w1 (priorities1 (r1 x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in w2 (priorities1 (r1 x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key x) (priorities1 (r1 x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (r1 x)) (priorities1 (r1 x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (key (l x)) (priorities1 (r1 x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority x) (priorities1 (r1 x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (r1 x)) (priorities1 (r1 x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority x)) (priorities1 (r1 x))) (=> (and (in (priority (l x)) (singleton (priority x))) (in (priority (l x)) (priorities1 (r1 x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in k (priorities1 (r1 (r1 x))))) (< k k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in p (priorities1 (r1 (r1 x))))) (< k p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))) (< k w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))) (< k w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))) (< k (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))) (< k (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in k (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in k (priorities1 (r1 (r1 x))))) (< p k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in p (priorities1 (r1 (r1 x))))) (< p p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))) (< p w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))) (< p w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))) (< p (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))) (< p (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in p (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in k (priorities1 (r1 (r1 x))))) (< w1 k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in p (priorities1 (r1 (r1 x))))) (< w1 p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))) (< w1 w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))) (< w1 w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))) (< w1 (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w1 (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in k (priorities1 (r1 (r1 x))))) (< w2 k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in p (priorities1 (r1 (r1 x))))) (< w2 p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))) (< w2 w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))) (< w2 w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))) (< w2 (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in w2 (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in k (priorities1 (r1 (r1 x))))) (< (key x) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in p (priorities1 (r1 (r1 x))))) (< (key x) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))) (< (key x) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))) (< (key x) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in k (priorities1 (r1 (r1 x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in p (priorities1 (r1 (r1 x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in k (priorities1 (r1 (r1 x))))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in p (priorities1 (r1 (r1 x))))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in k (priorities1 (r1 (r1 x))))) (< (priority x) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in p (priorities1 (r1 (r1 x))))) (< (priority x) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in k (priorities1 (r1 (r1 x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in p (priorities1 (r1 (r1 x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in k (priorities1 (r1 (r1 x))))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in p (priorities1 (r1 (r1 x))))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in w1 (priorities1 (r1 (r1 x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in w2 (priorities1 (r1 (r1 x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key x) (priorities1 (r1 (r1 x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key (r1 x)) (priorities1 (r1 (r1 x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (key (l x)) (priorities1 (r1 (r1 x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority x) (priorities1 (r1 (r1 x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority (r1 x)) (priorities1 (r1 (r1 x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (priority (r1 x))) (priorities1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (priority (r1 x)))) (in (priority (l x)) (priorities1 (r1 (r1 x))))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in k (singleton (key x))) (in k (keys1 (r1 x)))) (< k k ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in k (singleton (key x))) (in p (keys1 (r1 x)))) (< k p ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in k (singleton (key x))) (in w1 (keys1 (r1 x)))) (< k w1 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in k (singleton (key x))) (in w2 (keys1 (r1 x)))) (< k w2 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in k (singleton (key x))) (in (key x) (keys1 (r1 x)))) (< k (key x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in k (singleton (key x))) (in (key (r1 x)) (keys1 (r1 x)))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in k (singleton (key x))) (in (key (l x)) (keys1 (r1 x)))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in k (singleton (key x))) (in (priority x) (keys1 (r1 x)))) (< k (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in k (singleton (key x))) (in (priority (r1 x)) (keys1 (r1 x)))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in k (singleton (key x))) (in (priority (l x)) (keys1 (r1 x)))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in p (singleton (key x))) (in k (keys1 (r1 x)))) (< p k ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in p (singleton (key x))) (in p (keys1 (r1 x)))) (< p p ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in p (singleton (key x))) (in w1 (keys1 (r1 x)))) (< p w1 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in p (singleton (key x))) (in w2 (keys1 (r1 x)))) (< p w2 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in p (singleton (key x))) (in (key x) (keys1 (r1 x)))) (< p (key x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in p (singleton (key x))) (in (key (r1 x)) (keys1 (r1 x)))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in p (singleton (key x))) (in (key (l x)) (keys1 (r1 x)))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in p (singleton (key x))) (in (priority x) (keys1 (r1 x)))) (< p (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in p (singleton (key x))) (in (priority (r1 x)) (keys1 (r1 x)))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in p (singleton (key x))) (in (priority (l x)) (keys1 (r1 x)))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w1 (singleton (key x))) (in k (keys1 (r1 x)))) (< w1 k ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w1 (singleton (key x))) (in p (keys1 (r1 x)))) (< w1 p ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w1 (singleton (key x))) (in w1 (keys1 (r1 x)))) (< w1 w1 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w1 (singleton (key x))) (in w2 (keys1 (r1 x)))) (< w1 w2 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w1 (singleton (key x))) (in (key x) (keys1 (r1 x)))) (< w1 (key x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w1 (singleton (key x))) (in (key (r1 x)) (keys1 (r1 x)))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w1 (singleton (key x))) (in (key (l x)) (keys1 (r1 x)))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w1 (singleton (key x))) (in (priority x) (keys1 (r1 x)))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w1 (singleton (key x))) (in (priority (r1 x)) (keys1 (r1 x)))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w1 (singleton (key x))) (in (priority (l x)) (keys1 (r1 x)))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w2 (singleton (key x))) (in k (keys1 (r1 x)))) (< w2 k ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w2 (singleton (key x))) (in p (keys1 (r1 x)))) (< w2 p ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w2 (singleton (key x))) (in w1 (keys1 (r1 x)))) (< w2 w1 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w2 (singleton (key x))) (in w2 (keys1 (r1 x)))) (< w2 w2 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w2 (singleton (key x))) (in (key x) (keys1 (r1 x)))) (< w2 (key x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w2 (singleton (key x))) (in (key (r1 x)) (keys1 (r1 x)))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w2 (singleton (key x))) (in (key (l x)) (keys1 (r1 x)))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w2 (singleton (key x))) (in (priority x) (keys1 (r1 x)))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w2 (singleton (key x))) (in (priority (r1 x)) (keys1 (r1 x)))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in w2 (singleton (key x))) (in (priority (l x)) (keys1 (r1 x)))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key x) (singleton (key x))) (in k (keys1 (r1 x)))) (< (key x) k ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key x) (singleton (key x))) (in p (keys1 (r1 x)))) (< (key x) p ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key x) (singleton (key x))) (in w1 (keys1 (r1 x)))) (< (key x) w1 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key x) (singleton (key x))) (in w2 (keys1 (r1 x)))) (< (key x) w2 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key x) (singleton (key x))) (in (key x) (keys1 (r1 x)))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key x) (singleton (key x))) (in (key (r1 x)) (keys1 (r1 x)))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key x) (singleton (key x))) (in (key (l x)) (keys1 (r1 x)))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key x) (singleton (key x))) (in (priority x) (keys1 (r1 x)))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key x) (singleton (key x))) (in (priority (r1 x)) (keys1 (r1 x)))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key x) (singleton (key x))) (in (priority (l x)) (keys1 (r1 x)))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in k (keys1 (r1 x)))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in p (keys1 (r1 x)))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in w1 (keys1 (r1 x)))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in w2 (keys1 (r1 x)))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (key x) (keys1 (r1 x)))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (key (r1 x)) (keys1 (r1 x)))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (key (l x)) (keys1 (r1 x)))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (priority x) (keys1 (r1 x)))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (priority (r1 x)) (keys1 (r1 x)))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (r1 x)) (singleton (key x))) (in (priority (l x)) (keys1 (r1 x)))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (l x)) (singleton (key x))) (in k (keys1 (r1 x)))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (l x)) (singleton (key x))) (in p (keys1 (r1 x)))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (l x)) (singleton (key x))) (in w1 (keys1 (r1 x)))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (l x)) (singleton (key x))) (in w2 (keys1 (r1 x)))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (l x)) (singleton (key x))) (in (key x) (keys1 (r1 x)))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (l x)) (singleton (key x))) (in (key (r1 x)) (keys1 (r1 x)))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (l x)) (singleton (key x))) (in (key (l x)) (keys1 (r1 x)))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (l x)) (singleton (key x))) (in (priority x) (keys1 (r1 x)))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (l x)) (singleton (key x))) (in (priority (r1 x)) (keys1 (r1 x)))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (key (l x)) (singleton (key x))) (in (priority (l x)) (keys1 (r1 x)))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority x) (singleton (key x))) (in k (keys1 (r1 x)))) (< (priority x) k ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority x) (singleton (key x))) (in p (keys1 (r1 x)))) (< (priority x) p ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority x) (singleton (key x))) (in w1 (keys1 (r1 x)))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority x) (singleton (key x))) (in w2 (keys1 (r1 x)))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority x) (singleton (key x))) (in (key x) (keys1 (r1 x)))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority x) (singleton (key x))) (in (key (r1 x)) (keys1 (r1 x)))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority x) (singleton (key x))) (in (key (l x)) (keys1 (r1 x)))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority x) (singleton (key x))) (in (priority x) (keys1 (r1 x)))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority x) (singleton (key x))) (in (priority (r1 x)) (keys1 (r1 x)))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority x) (singleton (key x))) (in (priority (l x)) (keys1 (r1 x)))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in k (keys1 (r1 x)))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in p (keys1 (r1 x)))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in w1 (keys1 (r1 x)))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in w2 (keys1 (r1 x)))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (key x) (keys1 (r1 x)))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (key (r1 x)) (keys1 (r1 x)))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (key (l x)) (keys1 (r1 x)))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (priority x) (keys1 (r1 x)))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (priority (r1 x)) (keys1 (r1 x)))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (r1 x)) (singleton (key x))) (in (priority (l x)) (keys1 (r1 x)))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (l x)) (singleton (key x))) (in k (keys1 (r1 x)))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (l x)) (singleton (key x))) (in p (keys1 (r1 x)))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (l x)) (singleton (key x))) (in w1 (keys1 (r1 x)))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (l x)) (singleton (key x))) (in w2 (keys1 (r1 x)))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (key x) (keys1 (r1 x)))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (key (r1 x)) (keys1 (r1 x)))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (key (l x)) (keys1 (r1 x)))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (priority x) (keys1 (r1 x)))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (priority (r1 x)) (keys1 (r1 x)))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key x)) (keys1 (r1 x))) (=> (and (in (priority (l x)) (singleton (key x))) (in (priority (l x)) (keys1 (r1 x)))) (< (priority (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in k (keys1 (r1 (r1 x))))) (< k k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in p (keys1 (r1 (r1 x))))) (< k p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in w1 (keys1 (r1 (r1 x))))) (< k w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in w2 (keys1 (r1 (r1 x))))) (< k w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (key x) (keys1 (r1 (r1 x))))) (< k (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x))))) (< k (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x))))) (< k (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (priority x) (keys1 (r1 (r1 x))))) (< k (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x))))) (< k (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in k (singleton (key (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x))))) (< k (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in k (keys1 (r1 (r1 x))))) (< p k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in p (keys1 (r1 (r1 x))))) (< p p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in w1 (keys1 (r1 (r1 x))))) (< p w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in w2 (keys1 (r1 (r1 x))))) (< p w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (key x) (keys1 (r1 (r1 x))))) (< p (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x))))) (< p (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x))))) (< p (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (priority x) (keys1 (r1 (r1 x))))) (< p (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x))))) (< p (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in p (singleton (key (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x))))) (< p (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in k (keys1 (r1 (r1 x))))) (< w1 k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in p (keys1 (r1 (r1 x))))) (< w1 p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in w1 (keys1 (r1 (r1 x))))) (< w1 w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in w2 (keys1 (r1 (r1 x))))) (< w1 w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (key x) (keys1 (r1 (r1 x))))) (< w1 (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x))))) (< w1 (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x))))) (< w1 (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (priority x) (keys1 (r1 (r1 x))))) (< w1 (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x))))) (< w1 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w1 (singleton (key (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x))))) (< w1 (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in k (keys1 (r1 (r1 x))))) (< w2 k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in p (keys1 (r1 (r1 x))))) (< w2 p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in w1 (keys1 (r1 (r1 x))))) (< w2 w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in w2 (keys1 (r1 (r1 x))))) (< w2 w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (key x) (keys1 (r1 (r1 x))))) (< w2 (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x))))) (< w2 (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x))))) (< w2 (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (priority x) (keys1 (r1 (r1 x))))) (< w2 (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x))))) (< w2 (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in w2 (singleton (key (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x))))) (< w2 (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in k (keys1 (r1 (r1 x))))) (< (key x) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in p (keys1 (r1 (r1 x))))) (< (key x) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in w1 (keys1 (r1 (r1 x))))) (< (key x) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in w2 (keys1 (r1 (r1 x))))) (< (key x) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (key x) (keys1 (r1 (r1 x))))) (< (key x) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x))))) (< (key x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x))))) (< (key x) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (priority x) (keys1 (r1 (r1 x))))) (< (key x) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x))))) (< (key x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key x) (singleton (key (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x))))) (< (key x) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in k (keys1 (r1 (r1 x))))) (< (key (r1 x)) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in p (keys1 (r1 (r1 x))))) (< (key (r1 x)) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in w1 (keys1 (r1 (r1 x))))) (< (key (r1 x)) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in w2 (keys1 (r1 (r1 x))))) (< (key (r1 x)) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (key x) (keys1 (r1 (r1 x))))) (< (key (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x))))) (< (key (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x))))) (< (key (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (priority x) (keys1 (r1 (r1 x))))) (< (key (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x))))) (< (key (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (r1 x)) (singleton (key (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x))))) (< (key (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in k (keys1 (r1 (r1 x))))) (< (key (l x)) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in p (keys1 (r1 (r1 x))))) (< (key (l x)) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in w1 (keys1 (r1 (r1 x))))) (< (key (l x)) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in w2 (keys1 (r1 (r1 x))))) (< (key (l x)) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (key x) (keys1 (r1 (r1 x))))) (< (key (l x)) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x))))) (< (key (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x))))) (< (key (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (priority x) (keys1 (r1 (r1 x))))) (< (key (l x)) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x))))) (< (key (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (key (l x)) (singleton (key (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x))))) (< (key (l x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in k (keys1 (r1 (r1 x))))) (< (priority x) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in p (keys1 (r1 (r1 x))))) (< (priority x) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in w1 (keys1 (r1 (r1 x))))) (< (priority x) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in w2 (keys1 (r1 (r1 x))))) (< (priority x) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (key x) (keys1 (r1 (r1 x))))) (< (priority x) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x))))) (< (priority x) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x))))) (< (priority x) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (priority x) (keys1 (r1 (r1 x))))) (< (priority x) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x))))) (< (priority x) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority x) (singleton (key (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x))))) (< (priority x) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in k (keys1 (r1 (r1 x))))) (< (priority (r1 x)) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in p (keys1 (r1 (r1 x))))) (< (priority (r1 x)) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in w1 (keys1 (r1 (r1 x))))) (< (priority (r1 x)) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in w2 (keys1 (r1 (r1 x))))) (< (priority (r1 x)) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (key x) (keys1 (r1 (r1 x))))) (< (priority (r1 x)) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x))))) (< (priority (r1 x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x))))) (< (priority (r1 x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (priority x) (keys1 (r1 (r1 x))))) (< (priority (r1 x)) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x))))) (< (priority (r1 x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (r1 x)) (singleton (key (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x))))) (< (priority (r1 x)) (priority (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in k (keys1 (r1 (r1 x))))) (< (priority (l x)) k ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in p (keys1 (r1 (r1 x))))) (< (priority (l x)) p ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in w1 (keys1 (r1 (r1 x))))) (< (priority (l x)) w1 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in w2 (keys1 (r1 (r1 x))))) (< (priority (l x)) w2 ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (key x) (keys1 (r1 (r1 x))))) (< (priority (l x)) (key x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (key (r1 x)) (keys1 (r1 (r1 x))))) (< (priority (l x)) (key (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (key (l x)) (keys1 (r1 (r1 x))))) (< (priority (l x)) (key (l x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (priority x) (keys1 (r1 (r1 x))))) (< (priority (l x)) (priority x) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (priority (r1 x)) (keys1 (r1 (r1 x))))) (< (priority (l x)) (priority (r1 x)) ))))
(assert (=> (lt (singleton (key (r1 x))) (keys1 (r1 (r1 x)))) (=> (and (in (priority (l x)) (singleton (key (r1 x)))) (in (priority (l x)) (keys1 (r1 (r1 x))))) (< (priority (l x)) (priority (l x)) ))))


(assert (not (in k emptyset)))
(assert (not (in p emptyset)))
(assert (not (in w1 emptyset)))
(assert (not (in w2 emptyset)))
(assert (not (in (key x) emptyset)))
(assert (not (in (key (r1 x)) emptyset)))
(assert (not (in (key (l x)) emptyset)))
(assert (not (in (priority x) emptyset)))
(assert (not (in (priority (r1 x)) emptyset)))
(assert (not (in (priority (l x)) emptyset)))

(define (unroll-keys (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (keys arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
      (eq (keys arg0) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (eq (keys arg0) (union (keys (l arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (eq (keys arg0) (union (keys (r arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (eq (keys arg0) (union (union (keys (l arg0)) (keys (r arg0))) (singleton (key arg0))))
    )
))

(define (unroll-keys' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (keys' arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
      (eq (keys' arg0) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (eq (keys' arg0) (union (keys' (l' arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (eq (keys' arg0) (union (keys' (r' arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (eq (keys' arg0) (union (union (keys' (l' arg0)) (keys' (r' arg0))) (singleton (key arg0))))
    )
))

(define (unroll-keys1 (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (keys1 arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l1 arg0) nil)
      (= (r1 arg0) nil)
      (eq (keys1 arg0) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (= (r1 arg0) nil)
      (not (= arg0 (l1 arg0)))
      (eq (keys1 arg0) (union (keys1 (l1 arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r1 arg0) nil))
      (= (l1 arg0) nil)
      (not (= arg0 (r1 arg0)))
      (eq (keys1 arg0) (union (keys1 (r1 arg0)) (singleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (not (= (r1 arg0) nil))
      (not (= arg0 (l1 arg0)))
      (not (= arg0 (r1 arg0)))
      (not (= (l1 arg0) (r1 arg0)))
      (eq (keys1 arg0) (union (union (keys1 (l1 arg0)) (keys1 (r1 arg0))) (singleton (key arg0))))
    )
))

(define (unroll-priorities (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (priorities arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
      (eq (priorities arg0) (singleton (priority arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (eq (priorities arg0) (union (priorities (l arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (eq (priorities arg0) (union (priorities (r arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (eq (priorities arg0) (union (union (priorities (l arg0)) (priorities (r arg0))) (singleton (priority arg0))))
    )
))

(define (unroll-priorities' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (priorities' arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
      (eq (priorities' arg0) (singleton (priority arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (eq (priorities' arg0) (union (priorities' (l' arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (eq (priorities' arg0) (union (priorities' (r' arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (eq (priorities' arg0) (union (union (priorities' (l' arg0)) (priorities' (r' arg0))) (singleton (priority arg0))))
    )
))

(define (unroll-priorities1 (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (eq (priorities1 arg0) emptyset)
    )
    (and
      (not (= arg0 nil))
      (= (l1 arg0) nil)
      (= (r1 arg0) nil)
      (eq (priorities1 arg0) (singleton (priority arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (= (r1 arg0) nil)
      (not (= arg0 (l1 arg0)))
      (eq (priorities1 arg0) (union (priorities1 (l1 arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r1 arg0) nil))
      (= (l1 arg0) nil)
      (not (= arg0 (r1 arg0)))
      (eq (priorities1 arg0) (union (priorities1 (r1 arg0)) (singleton (priority arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (not (= (r1 arg0) nil))
      (not (= arg0 (l1 arg0)))
      (not (= arg0 (r1 arg0)))
      (not (= (l1 arg0) (r1 arg0)))
      (eq (priorities1 arg0) (union (union (priorities1 (l1 arg0)) (priorities1 (r1 arg0))) (singleton (priority arg0))))
    )
))

(define (unroll-treap (arg0 Loc))
  (or
    (= arg0 nil) 
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (treap (l arg0))
      (lt (singleton (priority arg0)) (priorities (l arg0)))
      (lt (keys (l arg0)) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (treap (r arg0))
      (lt (singleton (priority arg0)) (priorities (r arg0)))
      (lt (singleton (key arg0)) (keys (r arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (treap (l arg0))
      (treap (r arg0))
      (lt (singleton (priority arg0)) (priorities (l arg0)))
      (lt (singleton (priority arg0)) (priorities (r arg0)))
      (lt (keys (l arg0)) (singleton (key arg0)))
      (lt (singleton (key arg0)) (keys (r arg0)))
      (disjoint (priorities (l arg0)) (priorities (r arg0)))
    )
))

(define (unroll-treap' (arg0 Loc))
  (or 
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (treap' (l' arg0))
      (lt (singleton (priority arg0)) (priorities' (l' arg0)))
      (lt (keys' (l' arg0)) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (treap' (r' arg0))
      (lt (singleton (priority arg0)) (priorities' (r' arg0)))
      (lt (singleton (key arg0)) (keys' (r' arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (treap' (l' arg0))
      (treap' (r' arg0))
      (lt (singleton (priority arg0)) (priorities' (l' arg0)))
      (lt (singleton (priority arg0)) (priorities' (r' arg0)))
      (lt (keys' (l' arg0)) (singleton (key arg0)))
      (lt (singleton (key arg0)) (keys' (r' arg0)))
      (disjoint (priorities' (l' arg0)) (priorities' (r' arg0)))
    )
))

(define (unroll-negtreap' (arg0 Loc))
  (or 
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (or 
         (not (treap' (l' arg0)))
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (l' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (l' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (keys' (l' arg0)) (singleton (key arg0))))
            (<= w1 w2)
            (in w1 (singleton (key arg0)))
            (in w2 (keys' (l' arg0)))
         )
      )
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (or 
         (not (treap' (r' arg0)))
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (r' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (r' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (singleton (key arg0)) (keys' (r' arg0))))
            (<= w1 w2)
            (in w1 (keys' (r' arg0)))
            (in w2 (singleton (key arg0)))
         )
      )
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (or 
         (not (treap' (l' arg0)))
         (not (treap' (r' arg0)))
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (l' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (l' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (singleton (priority arg0)) (priorities' (r' arg0))))
            (<= w1 w2)
            (in w1 (priorities' (r' arg0)))
            (in w2 (singleton (priority arg0)))
         )
         (and 
            (not (lt (keys' (l' arg0)) (singleton (key arg0))))
            (<= w1 w2)
            (in w1 (singleton (key arg0)))
            (in w2 (keys' (l' arg0)))
         )
         (and 
            (not (lt (singleton (key arg0)) (keys' (r' arg0))))
            (<= w1 w2)
            (in w1 (keys' (r' arg0)))
            (in w2 (singleton (key arg0)))
         )
         (and 
            (not (disjoint (priorities' (l' arg0)) (priorities' (r' arg0))))
            (in w1 (priorities' (l' arg0)))
            (in w1 (priorities' (r' arg0)))
         )
      )
    )
))

(define (unroll-treap1 (arg0 Loc))
  (or 
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (= (l1 arg0) nil)
      (= (r1 arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (= (r1 arg0) nil)
      (not (= arg0 (l1 arg0)))
      (treap1 (l1 arg0))
      (lt (singleton (priority arg0)) (priorities1 (l1 arg0)))
      (lt (keys1 (l1 arg0)) (singleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r1 arg0) nil))
      (= (l1 arg0) nil)
      (not (= arg0 (r1 arg0)))
      (treap1 (r1 arg0))
      (lt (singleton (priority arg0)) (priorities1 (r1 arg0)))
      (lt (singleton (key arg0)) (keys1 (r1 arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l1 arg0) nil))
      (not (= (r1 arg0) nil))
      (not (= arg0 (l1 arg0)))
      (not (= arg0 (r1 arg0)))
      (not (= (l1 arg0) (r1 arg0)))
      (treap1 (l1 arg0))
      (treap1 (r1 arg0))
      (lt (singleton (priority arg0)) (priorities1 (l1 arg0)))
      (lt (singleton (priority arg0)) (priorities1 (r1 arg0)))
      (lt (keys1 (l1 arg0)) (singleton (key arg0)))
      (lt (singleton (key arg0)) (keys1 (r1 arg0)))
      (disjoint (priorities1 (l1 arg0)) (priorities1 (r1 arg0)))
    )
))


(define (precondition (arg0 Loc))
  (and
     (treap arg0)
     (not (in k (keys arg0)))
     (not (in p (priorities arg0)))
  )     
)

(define (postcondition (arg0 Loc) (arg1 Loc))
  (and
     (not (= arg1 nil))
     (treap' arg1)
     (eq (keys' arg1) (union (singleton k) (keys arg0)))
     (eq (priorities' arg1) (union (singleton p) (priorities arg0)))
  )   
)

(define (postcondition1 (arg0 Loc) (arg1 Loc))
  (and
     (not (= arg1 nil))
     (treap1 arg1)
     (eq (keys1 arg1) (union (singleton k) (keys arg0)))
     (eq (priorities1 arg1) (union (singleton p) (priorities arg0)))
  )   
)

(define (negpostcondition (arg0 Loc) (arg1 Loc))
  (or
     (= arg1 nil)
     (not (treap' arg1))
     (and
        (not (eq (keys' arg1) (union (singleton k) (keys arg0))))
        (or
           (and (in w1 (keys' arg1)) (not (in w1 (union (singleton k) (keys arg0)))))
           (and (not (in w1 (keys' arg1))) (in w1 (union (singleton k) (keys arg0))))
        )
     )
     (and 
        (not (eq (priorities' arg1) (union (singleton p) (priorities arg0))))
        (or
           (and (in w1 (priorities' arg1)) (not (in w1 (union (singleton p) (priorities arg0)))))
           (and (not (in w1 (priorities' arg1))) (in w1 (union (singleton p) (priorities arg0))))
        )
     )
  )   
)



; Path5

(declare-fun p5vc2 () Bool)
(assert (iff p5vc2
  (=>
     (and
        (precondition x)
        (not (= x nil))
        (unroll-keys x)
        (unroll-priorities x)
        (=> (treap x) (unroll-treap x))
        (not (< k (key x)))
        (= (l x) (l1 x))
        (eq (keys (l x)) (keys1 (l x)))
        (eq (priorities (l x)) (priorities1 (l x)))
        (iff (treap (l x)) (treap1 (l x)))
        (postcondition1 (r x) (r1 x))
        (unroll-keys1 x)
        (unroll-priorities1 x)
        (=> (treap1 x) (unroll-treap1 x))
        (unroll-keys1 (r1 x))
        (unroll-priorities1 (r1 x))
        (=> (treap1 (r1 x)) (unroll-treap1 (r1 x)))
        (> (priority x) (priority (r1 x)))
        (= (r' x) (l1 (r1 x)))
        (= (l' (r1 x)) x)
        (= (l' x) (l x))
        (= (r' (r1 x)) (r1 (r1 x)))
        (eq (keys' (l x)) (keys1 (l x)))
        (eq (priorities' (l x)) (priorities1 (l x)))
        (iff (treap' (l x)) (treap1 (l x)))
        (eq (keys' (r1 (r1 x))) (keys1 (r1 (r1 x))))
        (eq (priorities' (r1 (r1 x))) (priorities1 (r1 (r1 x))))
        (iff (treap' (r1 (r1 x))) (treap1 (r1 (r1 x))))
        (eq (keys' (l1 (r1 x))) (keys1 (l1 (r1 x))))
        (eq (priorities' (l1 (r1 x))) (priorities1 (l1 (r1 x))))
        (iff (treap' (l1 (r1 x))) (treap1 (l1 (r1 x))))
        (unroll-keys' (r1 x))
        (unroll-priorities' (r1 x))
        (=> (treap' x) (unroll-treap' x))
        (unroll-keys' x)
        (unroll-priorities' x)
        (=> (treap' (l x)) (unroll-treap' (l x)))
        (=> (not (treap' (r1 x))) (unroll-negtreap' (r1 x)))
        (=> (not (treap' x)) (unroll-negtreap' x))
     )
     (not (negpostcondition x (r1 x)))
  )
))


(assert (not p5vc2))
(check-sat)
(model)